(def whitec (c)
 (in c #\space #\newline #\tab #\return))

(def nonwhite (c) (no (whitec c)))

(def color (r g b)
  (with (c (table)
         f (fn (x) (if (< x 0) 0 (> x 255) 255 x)))
    (= (c 'r) (f r) (c 'g) (f g) (c 'b) (f b))
    c))

;; a simpler hexreps
(def hexreps (i)
   (let s (coerce i 'string 16)
      (if (is (len s) 1) (+ "0" s) s)))

(def hexrep (col)
  (+ (hexreps (col 'r)) (hexreps (col 'g)) (hexreps (col 'b))))

;; (def headmatch (pat seq (o start 0))
;;   (let p (len pat) 
;;     ((afn (i)      
;;        (or (is i p) 
;;            (and (is (pat i) (seq (+ i start)))
;;                 (self (+ i 1)))))
;;      0)))

;; (def begins (seq pat (o start 0))
;;   (unless (len> pat (- (len seq) start))
;;     (headmatch pat seq start)))



;;a - (b * int(a/b))
;;http://stackoverflow.com/questions/2660997/implementing-the-modulo-operator-as-a-function-in-c
(def mod (a b)
  (- a (* b (int (/ a b)))))
; Matching.  Spun off 29 Jul 06.

; arc> (tostring (writec (coerce 133 'char)))
;
;> (define ss (open-output-string))
;> (write-char (integer->char 133) ss)
;> (get-output-string ss)
;"\u0085"

(def tokens (s (o sep whitec))
  (let test (testify sep)
    (let rec (afn (cs toks tok)
               (if (no cs)         (consif tok toks)
                   (test (car cs)) (self (cdr cs) (consif tok toks) nil)
                                   (self (cdr cs) toks (cons (car cs) tok))))
      (rev (map [coerce _ 'string]
                (map rev (rec (coerce s 'cons) nil nil)))))))

; names of cut, split, halve not optimal

(def halve (s (o sep whitec))
  (let test (testify sep)
    (let rec (afn (cs tok)
               (if (no cs)         (list (rev tok))
                   (test (car cs)) (list cs (rev tok))
                                   (self (cdr cs) (cons (car cs) tok))))
      (rev (map [coerce _ 'string]
                (rec (coerce s 'cons) nil))))))

; maybe promote to arc.arc, but if so include a list clause

(def positions (test seq)
  (accum a
    (let f (testify test)
      (forlen i seq
        (if (f (seq i)) (a i))))))

(def lines (s)
  (accum a
    ((afn ((p . ps))
       (if ps
           (do (a (rem #\return (cut s (+ p 1) (car ps))))
               (self ps))
           (a (cut s (+ p 1)))))
     (cons -1 (positions #\newline s)))))

(def slices (s test)
  (accum a
    ((afn ((p . ps))
       (if ps
           (do (a (cut s (+ p 1) (car ps)))
               (self ps))
           (a (cut s (+ p 1)))))
     (cons -1 (positions test s)))))

; > (require (lib "uri-codec.ss" "net"))
;> (form-urlencoded-decode "x%ce%bbx")
;"xλx"

; first byte: 0-7F, 1 char; c2-df 2; e0-ef 3, f0-f4 4. 

; Fixed for utf8 by pc.

(def urldecode (s)
 (tostring
  (forlen i s
    (caselet c (s i)
      #\+ (writec #\space)
      #\% (do (when (> (- (len s) i) 2)
                (writeb (int (cut s (+ i 1) (+ i 3)) 16)))
              (++ i 2))
          (writec c)))))

(def urlencode (s)
  (tostring 
    (each c s 
      (writec #\%)
      (let i (int c)
        (if (< i 16) (writec #\0))
        (pr (coerce i 'string 16))))))

(mac litmatch (pat string (o start 0))
  (w/uniq (gstring gstart)
    `(with (,gstring ,string ,gstart ,start)
       (unless (> (+ ,gstart ,(len pat)) (len ,gstring))
         (and ,@(let acc nil
                  (forlen i pat
                    (push `(is ,(pat i) (,gstring (+ ,gstart ,i)))
                           acc))
                  (rev acc)))))))

; litmatch would be cleaner if map worked for string and integer args:

;             ,@(map (fn (n c)  
;                      `(is ,c (,gstring (+ ,gstart ,n))))
;                    (len pat)
;                    pat)

(mac endmatch (pat string)
  (w/uniq (gstring glen)
    `(withs (,gstring ,string ,glen (len ,gstring))
       (unless (> ,(len pat) (len ,gstring))
         (and ,@(let acc nil
                  (forlen i pat
                    (push `(is ,(pat (- (len pat) 1 i)) 
                               (,gstring (- ,glen 1 ,i)))
                           acc))
                  (rev acc)))))))

(def posmatch (pat seq (o start 0))
  (catch
    (if (isa pat 'fn)
        (for i start (- (len seq) 1)
          (when (pat (seq i)) (throw i)))
        (for i start (- (len seq) (len pat))
          (when (headmatch pat seq i) (throw i))))
    nil))

(def headmatch (pat seq (o start 0))
  (let p (len pat) 
    ((afn (i)      
       (or (is i p) 
           (and (is (pat i) (seq (+ i start)))
                (self (+ i 1)))))
     0)))

(def begins (seq pat (o start 0))
  (unless (len> pat (- (len seq) start))
    (headmatch pat seq start)))

(def subst (new old seq)
  (let boundary (+ (- (len seq) (len old)) 1)
    (tostring 
      (forlen i seq
        (if (and (< i boundary) (headmatch old seq i))
            (do (++ i (- (len old) 1))
                (pr new))
            (pr (seq i)))))))

(def multisubst (pairs seq)
  (tostring 
    (forlen i seq
      (iflet (old new) (find [begins seq (car _) i] pairs)
        (do (++ i (- (len old) 1))
            (pr new))
        (pr (seq i))))))

; not a good name

(def findsubseq (pat seq (o start 0))
  (if (< (- (len seq) start) (len pat))
       nil
      (if (headmatch pat seq start)
          start
          (findsubseq pat seq (+ start 1)))))

(def blank (s) (~find ~whitec s))

(def nonblank (s) (unless (blank s) s))

(def trim (s (o where 'both) (o test whitec))
  (withs (f   (testify test)
           p1 (pos ~f s))
    (if p1
        (cut s 
             (if (in where 'front 'both) p1 0)
             (when (in where 'end 'both)
               (let i (- (len s) 1)
                 (while (and (> i p1) (f (s i)))
                   (-- i))
                 (+ i 1))))
        "")))

(def num (n (o digits 2) (o trail-zeros nil) (o init-zero nil))
  (withs (comma
          (fn (i)
            (tostring
              (map [apply pr (rev _)]
                   (rev (intersperse '(#\,)
                                     (tuples (rev (coerce (string i) 'cons))
                                             3))))))
          abrep
          (let a (abs n)
            (if (< digits 1)
                 (comma (roundup a))
                (exact a)
                 (string (comma a)
                         (when (and trail-zeros (> digits 0))
                           (string "." (newstring digits #\0))))
                 (withs (d (expt 10 digits)
                         m (/ (roundup (* a d)) d)
                         i (trunc m)
                         r (abs (trunc (- (* m d) (* i d)))))
                   (+ (if (is i 0) 
                          (if (or init-zero (is r 0)) "0" "") 
                          (comma i))
                      (withs (rest   (string r)
                              padded (+ (newstring (- digits (len rest)) #\0)
                                        rest)
                              final  (if trail-zeros
                                         padded
                                         (trim padded 'end [is _ #\0])))
                        (string (unless (empty final) ".")
                                final)))))))
    (if (and (< n 0) (find [and (digit _) (isnt _ #\0)] abrep))
        (+ "-" abrep)
        abrep)))
        

; English

(def pluralize (n str)
  (if (or (is n 1) (single n))
      str
      (string str "s")))

(def plural (n x)
  (string n #\  (pluralize n x)))


; http://www.eki.ee/letter/chardata.cgi?HTML4=1
; http://jrgraphix.net/research/unicode_blocks.php?block=1
; http://home.tiscali.nl/t876506/utf8tbl.html
; http://www.fileformat.info/info/unicode/block/latin_supplement/utf8test.htm
; http://en.wikipedia.org/wiki/Utf-8
; http://unicode.org/charts/charindex2.html
(mac str body `(string ,@body))

(def fwrite (file contents)
     (w/outfile p file (each b contents (writec b p))))

(def fappend (file contents)
     (w/appendfile p file (each b contents (writec b p))))

(def fread (file) (tostring (system (str "cat " file)))) ; cat, seriously Arc?

(def fexists(file)
  (withs (exists nil)
	 (= exists (tostring (system (str "ls " file " 2>/dev/null | wc -l | awk '{ print $1 }' | xargs echo -n "))))
	 (if (is exists "0") nil t)))

;; splits on strings too, not just chars; better
(def strsplit (st sp)
  (withs (left st index nil ret nil)
	 (while (> (len left) 0)
		(= index (findsubseq sp left))
		(if (no index)
		    (do (push (cut left 0 index) ret)
			(= left nil))
		    (do ;;(prn "match in: " index)
			;;(prn "will push: " (cut left 0 index))
			(push (cut left 0 index) ret)
			(= left (cut left (+ index (len sp)) (len left)))
			;;(prn "left is: " left)
			)))
	 (if (no ret)
	     (= ret (list st))
	     (= ret (rev ret)))
	 ret))

(def pgp-tomultiline (s prefix)
  (withs (multi (strsplit s "\n") ret "" counter 0 numitems (len multi))
	 (each item multi
	       ;; must also get rid of carriage return, produced by the version string, e.g.:
	       ;; Version: OpenPGP.js v0.10.1
	       (withs (itemtouse ((strsplit item "\r") 0))
		      (if (> counter 0)
			  (= ret (str ret " +
" prefix)))
		      (= ret (str ret "\"" itemtouse ))
		      (if (> numitems 1)
			  (= ret (str ret "\\n")))
		      (= ret (str ret "\""))
		      (++ counter)))
	 ret))

;; http://stackoverflow.com/questions/1068834/object-comparison-in-javascript
(def deepcompare ()
  "function deepCompare () {
  var i, l, leftChain, rightChain;

  function compare2Objects (x, y) {
    var p;

    // remember that NaN === NaN returns false
    // and isNaN(undefined) returns true
    if (isNaN(x) && isNaN(y) && typeof x === 'number' && typeof y === 'number') {
         return true;
    }

    // Compare primitives and functions.     
    // Check if both arguments link to the same object.
    // Especially useful on step when comparing prototypes
    if (x === y) {
        return true;
    }

    // Works in case when functions are created in constructor.
    // Comparing dates is a common scenario. Another built-ins?
    // We can even handle functions passed across iframes
    if ((typeof x === 'function' && typeof y === 'function') ||
       (x instanceof Date && y instanceof Date) ||
       (x instanceof RegExp && y instanceof RegExp) ||
       (x instanceof String && y instanceof String) ||
       (x instanceof Number && y instanceof Number)) {
        return x.toString() === y.toString();
    }

    // At last checking prototypes as good a we can
    if (!(x instanceof Object && y instanceof Object)) {
        return false;
    }

    if (x.isPrototypeOf(y) || y.isPrototypeOf(x)) {
        return false;
    }

    if (x.constructor !== y.constructor) {
        return false;
    }

    if (x.prototype !== y.prototype) {
        return false;
    }

    // Check for infinitive linking loops
    if (leftChain.indexOf(x) > -1 || rightChain.indexOf(y) > -1) {
         return false;
    }

    // Quick checking of one object beeing a subset of another.
    // todo: cache the structure of arguments[0] for performance
    for (p in y) {
        if (y.hasOwnProperty(p) !== x.hasOwnProperty(p)) {
            return false;
        }
        else if (typeof y[p] !== typeof x[p]) {
            return false;
        }
    }

    for (p in x) {
        if (y.hasOwnProperty(p) !== x.hasOwnProperty(p)) {
            return false;
        }
        else if (typeof y[p] !== typeof x[p]) {
            return false;
        }

        switch (typeof (x[p])) {
            case 'object':
            case 'function':

                leftChain.push(x);
                rightChain.push(y);

                if (!compare2Objects (x[p], y[p])) {
                    return false;
                }

                leftChain.pop();
                rightChain.pop();
                break;

            default:
                if (x[p] !== y[p]) {
                    return false;
                }
                break;
        }
    }

    return true;
  }

  if (arguments.length < 1) {
    return true; //Die silently? Don't know how to handle such case, please help...
    // throw 'Need two or more arguments to compare';
  }

  for (i = 1, l = arguments.length; i < l; i++) {

      leftChain = []; //Todo: this can be cached
      rightChain = [];

      if (!compare2Objects(arguments[0], arguments[i])) {
          return false;
      }
  }

  return true;
}
")

(def encrypt-nonsearchable ()
  (str "function encrypt_nonsearchable(input, for_keys, sign, signing_keys) {
  // from openpgp.js
  var msg, armored;
  msg = openpgp.message.fromText(input);
  if (sign)
     msg = msg.sign(signing_keys);
  msg = msg.encrypt(for_keys);
  armored = openpgp.armor.encode(openpgp.enums.armor.message, msg.packets.write());
  return armored;
}
"))

(def encsearch-js-decryptkeys ()
  (withs (out "")
	 (= out (str out "// Decrypt the encrypted search info
var encsearchinfo = document.getElementById('encsearchinfo').value;
var searchinfo = decrypt_nonsearchable('encsearchinfo', encsearchinfo, privkey_openpgp);
searchinfo = JSON.parse(searchinfo);
var searchsalt = searchinfo['salt'];
var searchpass = searchinfo['pass'];
var searchiv = searchinfo['iv'];
var searchmperc = searchinfo['mperc'];
"))
	 out))

;; emit all code necessary to later perform an encrypted search
;; store/retrieve/decrypt
(def encsearch-js (enc-itemlist dec-itemlist autocomp-itemlist)
  (withs (out "" emit-tosearch nil emit-toretrieve nil emit-fromsearch nil)
	 (each item enc-itemlist
	       (if item!tosearch
		   (= emit-tosearch t))
	       (if item!toretrieve
		   (= emit-toretrieve t)))
	 (each item dec-itemlist
	       (if item!fromsearch
		   (= emit-fromsearch t)))
	 (if autocomp-itemlist
	     (do (= emit-toretrieve t)
		 (= emit-fromsearch t)))

	 (if (or emit-tosearch emit-toretrieve emit-fromsearch)
	     (do (= out
		    (str out
			 (encsearch-js-decryptkeys)
			 (encsearch-js-common)))))

	 (if emit-tosearch
	     (= out (str out (encsearch-js-tosearch))))
	 (if emit-toretrieve
	     (= out (str out (encsearch-js-toretrieve))))
	 (if emit-fromsearch
	     (= out (str out (encsearch-js-fromsearch))))

	 out))

;; The Dawn of Encryption
;; http://www.cs.berkeley.edu/~dawnsong/papers/se.pdf
(def encsearch-js-common ()
  (withs (ret "")
	 ;; split on anything that is not a word
	 (= ret (str ret "// split a sentence on whitespace, into a list of individual words to encrypt
function wordsplit_forenc(s) {
  var sinit = s.split(/\\W/);
  var sfinal = [];
  var wcounter = 0;
  var scopy = '';

  while (wcounter < sinit.length) {
    scopy = scopy + sinit[wcounter];
    if (sinit[wcounter] != '') // remove blank matches from split
      sfinal.push(sinit[wcounter]);
    var ccounter = scopy.length;
    var stop = 0;
    while (stop == 0) {
      if (ccounter < s.length && s[ccounter].match(/\\W/) != null) {
        scopy = scopy + s[ccounter];		
        sfinal.push(s[ccounter]);
        ccounter++;
      } else
        stop = 1;
      }
      wcounter++;
  }

  return sfinal;
}

function is_whitespace(s) {
  return /\\W/g.test(s);
}

function nonwordsplit_forenc (space_and_words) {
  var words = [];
  var space = {};
  var counter = 0;
  var word_counter = 0;

  while (counter < space_and_words.length) {
    // if a word does not consist only of word characters, then it's
    // whitespace or punctuation.
    if (is_whitespace(space_and_words[counter])) {
      // it's whitespace or punctuation
      // index with -1, because word_counter was already incremented
      if (space[word_counter-1] == null)
        space[word_counter-1] = [];
      space[word_counter-1].push(space_and_words[counter]);
    } else {
      // it's a word
      words.push(space_and_words[counter]);
      word_counter++;
    }
    counter++;
  }
  //alert('space: ' + JSON.stringify(space));
  //alert('words:' + JSON.stringify(words));

  return [space, words];
}

function searchabledata_encrypt_internal (value, internalpass) {
  var value_str = JSON.stringify(value);
  var encrypted = CryptoJS.AES.encrypt(value_str, internalpass);
  var value_enc = encrypted.toString();

  return value_enc;
}

function lettercasefold_forenc( words ) {
  var lowercase_words = [];
  var lettercase = [];
  var counter = 0;

  while (counter < words.length) {
    var lowercase_word = words[counter].toLowerCase();
    var lower_encoding = {};
    var letter_counter = 0;

    // Identify uppercase letters in each word
    while (letter_counter < words[counter].length) {
      if (lowercase_word[letter_counter] != words[counter][letter_counter]) {
        // This letter was uppercase
        lower_encoding[letter_counter] = 1;
      }
      letter_counter++;
    }
    lowercase_words.push(lowercase_word);
    lettercase.push(lower_encoding);

    counter++;
  }

  return [lowercase_words, lettercase];
}

function add_count_tosearch(words) {
  var count_words = [];
  var all_word_counts = {};
  var counter = 0;

  while (counter < words.length) {
    if (all_word_counts[words[counter]] == null) {
       all_word_counts[words[counter]] = 0;
    } else {
       all_word_counts[words[counter]] += 1;
    }
    var new_word = { 'count': all_word_counts[words[counter]], 'word': words[counter] };
    new_word = JSON.stringify(new_word);
    count_words.push(new_word);
    
    counter++;
  }

  return count_words;
}

// Given a word, pick a suitable m value for it
// fixme: currently make m be a percentage of n; not sure what's a good value
function pickm (word, searchmperc) {
  var n = word.length;
  var m = Math.ceil(n * searchmperc);

  return m;
}
"
;; from http://code.google.com/p/crypto-js/source/browse/branches/2.0.x/src/Crypto.js?spec=svn301&r=301
"
function bytesToHex (bytes) {
  for (var hex = [], i = 0; i < bytes.length; i++) {
    hex.push((bytes[i] >>> 4).toString(16));
    hex.push((bytes[i] & 0xF).toString(16));
  }
  return hex.join('');
}

function hexToBytes (hex) {
  for (var bytes = [], c = 0; c < hex.length; c += 2)
    bytes.push(parseInt(hex.substr(c, 2), 16));
  return bytes;
}

function XORBytes (bytes_array1, bytes_array2) {
  var counter = 0;
  var xor_bytes = [];

  if (bytes_array1.length == bytes_array2.length) {
    while (counter < bytes_array1.length) {
      var this_byte = bytes_array1[counter] ^ bytes_array2[counter];
      xor_bytes.push(this_byte);
      counter++;
    }
  }

  return xor_bytes;
}

// return a random value between 0 and 1
function random_zerotoone() {
  // fixme: we shouldn't need to do this. It's CryptoJS.lib.WordArray.random() that should be fixed.
  var ar = new Uint32Array(1);
  var v = window.crypto.getRandomValues(ar)[0];
  var zerotoone = v / (Math.pow(2,32) - 1);

  return zerotoone;
/*  
  var randomValue_words = CryptoJS.lib.WordArray.random(1);
  var randomValue_hex = randomValue_words.toString();
  var randomValue_bin = hexToBytes(randomValue_hex)[0] / 255;

  return randomValue_bin;
*/
}
"

;; Fisher-Yates Shuffle, changed to not use Math.random() because Math.random()
;; was seeded to return repeatable values and was causing shuffle to always
;; generate the same permutation. Also because Math.random() is not
;; cryptographically secure in all browsers.
;;
;; http://stackoverflow.com/questions/2450954/how-to-randomize-shuffle-a-javascript-array
"
function shuffle(array) {
  var currentIndex = array.length, temporaryValue, randomIndex ;

  // While there remain elements to shuffle...
  while (0 !== currentIndex) {

    // Pick a remaining element...
    randomIndex = Math.floor(random_zerotoone() * currentIndex);
    currentIndex -= 1;

    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}

// Pre-encrypt every word with deterministic encryption
function search_preencrypt(words, searchpass, searchiv) {
  var preenc_words = [];
  var iv = CryptoJS.enc.Hex.parse(searchiv);
  var searchpass_words = CryptoJS.enc.Hex.parse(searchpass);

  var counter = 0;
  while (counter < words.length) {
    var encrypted = CryptoJS.AES.encrypt(words[counter], searchpass_words, { iv: iv });
    // Save in hex, to make debugging easier
    var encrypted_words = CryptoJS.enc.Base64.parse(encrypted.toString());
    var encrypted_hex = CryptoJS.enc.Hex.stringify(encrypted_words);
    preenc_words.push(encrypted_hex);
    console.log('the word: ' + words[counter] + ' has been pre-encrypted to: ' + encrypted_hex);
    // to debug, enable this:
    //if (counter == 0)
    //  alert('===============preencrypted word was: ' + encrypted_hex + ' for: ' + words[counter] + ' using searchpass: ' + searchpass);
    counter++;
  }

  return preenc_words;
}

// Crop each pre-encrypted word to produce L_i
function search_li(preenc_words, searchmperc) {
  var li_words = [];

  var counter = 0;
  while (counter < preenc_words.length) {
    var this_preenc_word = preenc_words[counter]
    // in calculating mbytes, divide by two because this_preenc_word
    // is a hex string, where each byte is represented by two characters
    var nbytes = this_preenc_word.length / 2;
    var mbytes = pickm(this_preenc_word, searchmperc) / 2;
    // Split word into its first n-m bytes to produce L_i
    var first_nm_word = this_preenc_word.substr(0, (nbytes - mbytes) * 2);
    //console.log('will extract L_i key for: ' + this_preenc_word + ' from the first n-m bytes which are: ' + first_nm_word + ' and should be n-m: ' + (nbytes-mbytes));
    li_words.push(first_nm_word);
    counter++;
  }

  return li_words;
}

// initialize pseudorandom generator that returns repeatable values given the seed
function search_random_init(searchsalt) {
  Math.seedrandom(searchsalt);
}

// For every pre-encrypted word, generate a random value which is as
// long as the word
function search_random(preenc_words) {
  var s_random_words = [];

  var counter = 0;
  while (counter < preenc_words.length) {
    var this_preenc_word = preenc_words[counter];
    //console.log('preenc word: ' + this_preenc_word);
    //console.log('preenc word len: ' + this_preenc_word.length);
    // In calculating nbytes and mbytes, divide by two because this_preenc_word
    // is a hex string, where each byte is represented by two characters.
    var nbytes = this_preenc_word.length / 2;
    var random_counter = 0;
    var random_word = '';
    while (random_counter < nbytes) {
      // Not only is it ok to use Math.random() here, it's also a requirement.
      // Because it has been seeded with a pseudorandom generator that returns
      // repeatable values, and we want repeatable values.
      var random_value = Math.random();
      //console.log('random_value is: ' + random_value);
      var random_value_byte = random_value * 255;
      //console.log('random_value as a byte is: ' + random_value_byte);
      random_word = random_word + bytesToHex([random_value_byte]);
      random_counter++;
    }
    //console.log('the word: ' + this_preenc_word + ' has the random value: ' + random_word + ' cropped in n bytes: ' + nbytes);
    s_random_words.push(random_word);

    counter++;
  }

  return s_random_words;
}

// For each random value, generate a separate key with a function that takes
// the pre-encrypted word as input
function search_key(preenc_words, li_words, s_random_words, searchiv, searchmperc) {
  var f_key_words = [];
  var iv = CryptoJS.enc.Hex.parse(searchiv);

  var counter = 0;
  while (counter < s_random_words.length) {
    var this_preenc_word = preenc_words[counter];
    var this_random_value = s_random_words[counter];
    var nbytes = this_preenc_word.length / 2;
    var mbytes = pickm(this_preenc_word, searchmperc) / 2;
    var random_bytes = nbytes - mbytes;
    var this_random_value_firstnm_hex = this_random_value.substr(0, (nbytes - mbytes) * 2);
    var this_random_value_firstnm_words = CryptoJS.enc.Hex.parse(this_random_value_firstnm_hex);

    var li_firstnm_hex = li_words[counter];
    var li_firstnm_words = CryptoJS.enc.Hex.parse(li_firstnm_hex);
    var this_separate_key = CryptoJS.AES.encrypt(this_random_value_firstnm_words, li_firstnm_words, { iv: iv });
    var this_separate_key_words = CryptoJS.enc.Base64.parse(this_separate_key.toString());
    var this_separate_key_hex = CryptoJS.enc.Hex.stringify(this_separate_key_words);
    // Save in hex, to make debugging easier
    this_separate_key = this_separate_key_hex;
    // keep only last m bytes for this key
    // in cropping mbytes, multiply by two because this_separate_key is a hex string
    var this_separate_key_cropped = this_separate_key.substr( this_separate_key.length - mbytes * 2, this_separate_key.length);
    //console.log('the L_i word: ' + li_words[counter] + ' has the separate key: ' + this_separate_key + ' which was cropped to: ' + this_separate_key_cropped + ' of m: ' + mbytes);
    f_key_words.push(this_separate_key_cropped);
    // to debug, enable this:
    //if (counter == 0)
    //  alert('========== key was: ' + this_separate_key_cropped + ' with random value ' + this_random_value + ' and li_firstnm_word ' + li_firstnm_hex)
    counter++;
  }

  return f_key_words;
}

// XOR each pre-encrypted word E(W_ci) with each concatenation of S_i and F_ki(L_i)
function search_xor(preenc_words, s_random_words, f_key_words, searchmperc) {
  var xor_words = [];

  var counter = 0;
  while (counter < preenc_words.length) {
    var this_preenc_word = preenc_words[counter];
    var this_random_word = s_random_words[counter];
    var nbytes = this_preenc_word.length / 2;
    var mbytes = pickm(this_preenc_word, searchmperc) / 2;
    var this_random_word = this_random_word.substr(0, (nbytes - mbytes) * 2);
    var concat_word = this_random_word + f_key_words[counter];

    var bytes_preenc_word = hexToBytes(this_preenc_word);
    var bytes_concat_word = hexToBytes(concat_word);
    var bytes_xor_word = XORBytes(bytes_preenc_word, bytes_concat_word);
    var xor_word = bytesToHex(bytes_xor_word);
    console.log('XOR ' + this_preenc_word + ' with ' + concat_word + ' yields ' + xor_word);
    // encode the xor_word to Base64 to make it compact
    var xor_word_words = CryptoJS.enc.Hex.parse(xor_word);
    var xor_word_base64 = CryptoJS.enc.Base64.stringify(xor_word_words);
    xor_words.push(xor_word_base64);
    counter++;
  }

  return xor_words;
}

"))
	 ret))

(def encsearch-js-tosearch ()
  (withs (ret "")
	 (= ret (str ret "function permutation_calculate(num) {
  var perm = [];
  var counter = 0;

  while (counter < num) {
    perm.push(counter);
    counter++;
  }
  shuffle(perm);

  return perm;
}

function permutation_apply(perm, words) {
  perm_words = [];
  var counter = 0;

  while (counter < perm.length) {
    var word_index = perm[counter];
    var word_to_push = words[word_index];
    perm_words.push(word_to_push);
    counter++;
  }

  return perm_words;
}

function permutation_encrypt(perm, searchpass) {
  var perm_str = JSON.stringify(perm);
  var encrypted = CryptoJS.AES.encrypt(perm_str, searchpass);
  var perm_enc = encrypted.toString();
  //alert('encrypted: ' + perm_str + ' and got: ' + perm_enc);

  return perm_enc;
}

function encrypt_tosearch(val, searchsalt, searchpass, searchiv, searchmperc) {
  var space_and_words = [];// not in paper: words including whitespaces
  var space = {};          // not in paper: encode whitespaces
  var lettercase = [];     // not in paper: encode letter casing
  var words = [];          // W_i
  var count_words = [];    // W_ci is W_i adding count to words (section 5.2)
  var preenc_words = [];   // E(W_ci)
  var li_words = [];       // L_i
  var s_random_words = []; // S_i
  var f_key_words = [];    // F_ki(L_i)
  var xor_words = [];      // Ciphertext
  var perm = [];           // Permutation of the order of the words
  var perm_words = [];     // Permutation of the Ciphertext

  // ------------------------------------------------------
  // STEP 1: Split all words on whitespace
  space_and_words = wordsplit_forenc( val );

  // STEP 2: Determine which words should be removed because they are whitespace
  var nonwordsplit_ret = nonwordsplit_forenc( space_and_words );
  space = nonwordsplit_ret[0];
  words = nonwordsplit_ret[1];

  // STEP 3: Encrypt the spacing
  var space_enc = searchabledata_encrypt_internal(space, searchpass);

  // STEP 4: Convert all words to lowercase and save the letter casing
  var lettercasefold_ret = lettercasefold_forenc( words );
  words = lettercasefold_ret[0];
  lettercase = lettercasefold_ret[1];

  // STEP 5: Encrypt the letter casing
  var lettercase_enc = searchabledata_encrypt_internal(lettercase, searchpass);

  // STEP 6: Add count to each word, to avoid exposing the frequency of a word
  //         in a document
  count_words = add_count_tosearch(words);
  // ------------------------------------------------------


  // ------------------------------------------------------

  // STEP 7: Pre-encrypt each word
  preenc_words = search_preencrypt(count_words, searchpass, searchiv);

  // STEP 8: Crop each pre-encrypted word to produce L_i
  li_words = search_li(preenc_words, searchmperc);

  // STEP 9: Generate a random value for each word
  search_random_init(searchsalt);
  s_random_words = search_random(preenc_words);

  // STEP 10: Generate a key for each word
  f_key_words = search_key(preenc_words, li_words, s_random_words, searchiv, searchmperc);

  // STEP 11: XOR each pre-encrypted word E(W_ci) with each concatenation of S_i and F_ki(L_i)
  xor_words = search_xor(preenc_words, s_random_words, f_key_words, searchmperc);
  // ------------------------------------------------------


  // ------------------------------------------------------
  // STEP 12: Calculate a random permutation for the words, to counteract a statistical attack
  perm = permutation_calculate(xor_words.length);

  // STEP 13: Now actually apply the permutation to the words
  perm_words = permutation_apply(perm, xor_words);

  // STEP 14: Encrypt the permutation
  perm_enc = permutation_encrypt(perm, searchpass);
  // ------------------------------------------------------


  var ret = {}
  ret['data'] = perm_words;
  ret['permutation'] = perm_enc;
  ret['space'] = space_enc;
  ret['case'] = lettercase_enc;

  return JSON.stringify(ret);
}
"))
	 ret))

(def encsearch-js-toretrieve ()
  (withs (ret "")
	 (= ret (str ret "function add_count_toretrieve(words) {
  var count_words = [];
  var counter = 0;

  while (counter < words.length) {
    var new_word = { 'count': 0, 'word': words[counter] };
    new_word = JSON.stringify(new_word);
    count_words.push(new_word);
    counter++;
  }

  return count_words;
}

function encrypt_toretrieve(val, searchsalt, searchpass, searchiv, searchmperc, numkeys) {
  var space_and_words = [];// not in paper: words including whitespaces
  var words = [];          // W_i
  var count_words = [];    // A W_ci where each word has count 0
  var preenc_words = [];   // E(W_ci)
  var li_words = [];       // L_i

  // ------------------------------------------------------
  // STEP 1: Split all words on whitespace
  space_and_words = wordsplit_forenc( val );

  // STEP 2: Determine which words should be removed because they are whitespace
  var nonwordsplit_ret = nonwordsplit_forenc( space_and_words );
  words = nonwordsplit_ret[1];

  // STEP 3: Convert all words to lowercase
  var lettercasefold_ret = lettercasefold_forenc( words );
  words = lettercasefold_ret[0];

  // STEP 4: Add a count of 0 to each word, to stop at it's first occurance
  count_words = add_count_toretrieve(words);

  // STEP 5: Pre-encrypt each word
  preenc_words = search_preencrypt(count_words, searchpass, searchiv);

  // STEP 6: Crop each pre-encrypted word to produce L_i
  li_words = search_li(preenc_words, searchmperc);
  // ------------------------------------------------------

  // ------------------------------------------------------
  // For each word, generate all possible keys that might be needed, up
  // to numkeys
  var ret = {};
  ret['words'] = preenc_words;
  ret['keys'] = [];
  var counter = 0;
  while (counter < preenc_words.length) {
    var s_random_words = []; // S_i
    var f_key_words = [];    // F_ki(L_i)

    var key_counter = 0;
    search_random_init(searchsalt);
    while (key_counter < numkeys) {
      // STEP 7: Generate a random value for each word
      var this_random_words = search_random([ preenc_words[counter] ]);
      s_random_words.push( this_random_words[0] );
      key_counter++;
    }

    //console.log('generated ' + numkeys + ' s_random_words: ' + s_random_words);
    key_counter = 0;
    while (key_counter < numkeys) {
      // STEP 8: Generate a key for each word
      var this_key_words = search_key( [ preenc_words[counter] ], [ li_words[counter] ], [ s_random_words[key_counter] ], searchiv, searchmperc);
      f_key_words.push( this_key_words[0] );
      key_counter++;
    }
    ret['keys'].push(f_key_words);
    //console.log('generated ' + numkeys + ' f_key_words: ' + f_key_words);
    counter++;
  }
  // ------------------------------------------------------


  return JSON.stringify(ret);
}
"))
	 ret))

(def encsearch-js-fromsearch ()
  (withs (ret "")
	 (= ret (str ret "
function permutation_decrypt(perm_enc, searchpass) {
  var decrypted_words = CryptoJS.AES.decrypt(perm_enc, searchpass);
  var decrypted = decrypted_words.toString(CryptoJS.enc.Utf8);
  var perm = JSON.parse(decrypted);

  return perm;
}

function permutation_remove(perm, words) {
  var unperm_words = [];
  var counter = 0;

  // Generate an array with the same number of elements, holding a dummy value
  while (counter < words.length) {
    unperm_words.push(0);
    counter++;
  }

  // Set the expected value at each index
  counter = 0;
  while (counter < words.length) {
    var perm_index = perm[counter];
    unperm_words[perm_index] = words[counter];
    counter++;
  }

  return unperm_words;
}

// Convert words that are encoded in Base64 into Hex
function search_base64tohex(base64_words) {
  var hex_words = [];

  var counter = 0;
  while (counter < base64_words.length) {
    var this_word_base64 = base64_words[counter];
    var this_word_word = CryptoJS.enc.Base64.parse(this_word_base64);
    var this_word_hex = CryptoJS.enc.Hex.stringify(this_word_word);
    hex_words.push(this_word_hex);
    counter++;
  }

  return hex_words;
}

// XOR the first n-m bytes of each encrypted word with S_i to produce L_i
function search_dexor_li(enc_words_hex, s_random_words, searchmperc) {
  var dexor_words = [];

  var counter = 0;
  while (counter < enc_words_hex.length) {
    var this_enc_word_hex = enc_words_hex[counter];
    var nbytes = this_enc_word_hex.length / 2;
    var mbytes = pickm(this_enc_word_hex, searchmperc) / 2;
    var this_enc_word_hex_firstnm = this_enc_word_hex.substr(0, (nbytes - mbytes) * 2);

    var this_random_word_hex = s_random_words[counter];
    var this_random_word_hex_firstnm = this_random_word_hex.substr(0, (nbytes - mbytes) * 2);

    var bytes_this_enc_word = hexToBytes(this_enc_word_hex_firstnm);
    var bytes_random_word = hexToBytes(this_random_word_hex_firstnm);
    var dexor_word = XORBytes(bytes_this_enc_word, bytes_random_word);
    var dexor_word_hex = bytesToHex(dexor_word);
    console.log('deXOR L_i of encrypted word: ' + this_enc_word_hex + ' using only its first n-m: ' + (nbytes-mbytes) * 2 + ' which crops it to: ' + this_enc_word_hex_firstnm + ' with the cropped random word: ' + this_random_word_hex_firstnm + ' yields: ' + dexor_word_hex);
    dexor_words.push(dexor_word_hex);
    counter++;
  }

  return dexor_words;
}

// XOR the last m bytes of each encrypted word with F_ki(L_i) to produce R_i
function search_dexor_ri(enc_words_hex, f_key_words, searchmperc) {
  var dexor_words = [];

  var counter = 0;
  while (counter < enc_words_hex.length) {
    var this_enc_word_hex = enc_words_hex[counter];
    var nbytes = this_enc_word_hex.length / 2;
    var mbytes = pickm(this_enc_word_hex, searchmperc) / 2;
    var this_enc_word_hex_lastm = this_enc_word_hex.substr((nbytes - mbytes) * 2, nbytes);
    var this_key_word_hex = f_key_words[counter];

    var bytes_this_enc_word = hexToBytes(this_enc_word_hex_lastm);
    var bytes_key_word = hexToBytes(this_key_word_hex);
    var dexor_word = XORBytes(bytes_this_enc_word, bytes_key_word);
    var dexor_word_hex = bytesToHex(dexor_word);
    console.log('deXOR R_i of encrypted word: ' + this_enc_word_hex + ' using only its last m: ' + mbytes * 2 + ' which crops it to: ' + this_enc_word_hex_lastm + ' with the cropped key word: ' + this_key_word_hex + ' yields: ' + dexor_word_hex);
    dexor_words.push(dexor_word_hex);
    counter++;
  }

  return dexor_words;
}

// Concatenate L_i and R_i to produce E(W_ci) and decrypt the word
function search_decrypt(li_words, ri_words, searchpass, searchiv) {
  var dec_words_hex = [];
  //console.log('search_decrypt with searchpass: ' + searchpass);
  var searchpass_words = CryptoJS.enc.Hex.parse(searchpass);
  //console.log('search_decrypt with searchpass_words: ' + searchpass_words);
  var iv = CryptoJS.enc.Hex.parse(searchiv);

  var counter = 0;
  while (counter < li_words.length) {
    var this_xor_word_hex = li_words[counter] + ri_words[counter];
    var this_xor_word = CryptoJS.enc.Hex.parse(this_xor_word_hex);
    console.log('after hex parse for ' + this_xor_word_hex);
    var this_xor_word_base64 = CryptoJS.enc.Base64.stringify(this_xor_word);
    //console.log('word in base64: ' + this_xor_word_base64);
    var decrypted_word = CryptoJS.AES.decrypt(this_xor_word_base64, searchpass_words, { iv: iv });
    var decrypted = decrypted_word.toString(CryptoJS.enc.Utf8);
    console.log('decrypted to: ' + decrypted);
    dec_words_hex.push(decrypted);
    counter += 1;
  }

  return dec_words_hex;
}

function remove_count_fromsearch(count_words) {
  var words = [];
  var counter = 0;

  while (counter < count_words.length) {
    var original_word = JSON.parse(count_words[counter]);
    original_word = original_word['word'];
    words.push(original_word);
    counter++;
  }

  return words;
}

function searchabledata_decrypt_internal (value_enc, internalpass) {
  var decrypted_words = CryptoJS.AES.decrypt(value_enc, internalpass);
  var decrypted = decrypted_words.toString(CryptoJS.enc.Utf8);
  var value = JSON.parse(decrypted);

  return value;
}

function lettercaseunfold (folded_words, lettercase) {
  var unfolded_words = [];
  var counter = 0;

  while (counter < folded_words.length) {
    var letter_counter = 0;
    var word = folded_words[counter];

    while (letter_counter < folded_words[counter].length) {
      var letter = folded_words[counter][letter_counter];
      var should_up = lettercase[counter][letter_counter];

      if (should_up) // should convert to uppercase
        word = word.substr(0, letter_counter) + letter.toUpperCase() + word.substr(letter_counter+letter.length);

      letter_counter++;
    }
    unfolded_words.push(word);

    counter++;
  }

  return unfolded_words;
}

function wordjoin_fordec (words, space) {
  var ret = '';
  var counter = 0;

  while (counter < words.length) {
    ret = ret + words[counter];
    if (space[counter] != null) {
      // there is space after this word
      var space_counter = 0;
      while (space_counter < space[counter].length) {
        ret = ret + space[counter][space_counter];
        space_counter++;
      }
    }
    counter += 1;
  }

  console.log('reassembled to: ' + ret);
  return ret;
}

function decrypt_fromsearch(results, searchsalt, searchpass, searchiv, searchmperc) {
  var perm_words = results['data'];
  var perm_enc = results['permutation'];
  var space_enc = results['space'];
  var lettercase_enc = results['case'];
  console.log('will decrypt data: ' + perm_words);
  console.log('will decrypt permutation: ' + perm_enc);
  console.log('will decrypt space: ' + space_enc);
  console.log('will decrypt case: ' + lettercase_enc);
  var perm = [];           // Permutation of the order of the words
  var enc_words = [];      // The words to decrypt
  var s_random_words = []; // S_i
  var li_words = [];       // L_i
  var ri_words = [];       // R_i
  var enc_words_hex = [];  // The encrypted words, converted from Base64 to Hex
  var space = {};          // The decrypted whitespace between the words
  var lettercase = {};     // The decrypted letter casing for each word
  var ret = '';            // The decrypted words, reassembled as text

  // ------------------------------------------------------
  // STEP 1: Decrypt the permutation
  perm = permutation_decrypt(perm_enc, searchpass);

  // STEP 2: Reassemble the words into their original order
  enc_words = permutation_remove(perm, perm_words);
  // ------------------------------------------------------


  // ------------------------------------------------------
  // STEP 3: Convert the enc_words into hex words
  enc_words_hex = search_base64tohex(enc_words);

  // STEP 4: Generate the random value for each word again
  search_random_init(searchsalt);
  s_random_words = search_random(enc_words_hex);

  // STEP 5: XOR the first n-m bytes of each encrypted word with S_i to produce L_i
  li_words = search_dexor_li(enc_words_hex, s_random_words, searchmperc);

  // STEP 6: Generate a key for each word
  f_key_words = search_key(enc_words_hex, li_words, s_random_words, searchiv, searchmperc);

  // STEP 7: XOR the last m bytes of each encrypted word with F_ki(L_i) to produce R_i
  ri_words = search_dexor_ri(enc_words_hex, f_key_words, searchmperc);

  // STEP 8: Concatenate L_i and R_i to produce E(W_ci) and decrypt the word
  decrypted_words = search_decrypt(li_words, ri_words, searchpass, searchiv);
  // ------------------------------------------------------


  // ------------------------------------------------------
  // STEP 9: Remove word counts
  decrypted_words_nocounts = remove_count_fromsearch(decrypted_words);

  // STEP 10: Decrypt the letter casing
  lettercase = searchabledata_decrypt_internal(lettercase_enc, searchpass);

  // STEP 11: Apply letter casing back to the decrypted words
  lettercase_words_unfolded = lettercaseunfold(decrypted_words_nocounts, lettercase);

  // STEP 12: Decrypt the spacing
  space = searchabledata_decrypt_internal(space_enc, searchpass);

  // STEP 13: Reassamble all the decrypted words into text
  ret = wordjoin_fordec(lettercase_words_unfolded, space);
  // ------------------------------------------------------


  return ret;
}
"))
	 ret))
;; (tostring) is not available in ArcJS, so we need to redefine
;; functions that were using tostring to avoid it if they can
(def subst (new old seq)
  (withs (boundary (+ (- (len seq) (len old)) 1) out nil)
	 (forlen i seq
		 (if (and (< i boundary) (headmatch old seq i))
		     (do (++ i (- (len old) 1))
			 (= out (str out new)))
		     (= out (str out (seq i)))))
	 out))
(def return (new-parse-position return-value)
  (list new-parse-position return-value))

(def match (f)
  (only (fn (p)
          (let x car.p
            (if (f x)
                 (return cdr.p x))))))

(def alt parsers
  (fn (p)
    (some [_ p] parsers)))

(def seq parsers
  (fn (p)
    ((afn (p parsers a)
       (if parsers
            (iflet (p2 r) (car.parsers p)
              (self p2 cdr.parsers (cons r a)))
            (return p rev.a)))
     p parsers nil)))

(def many (parser)
  (fn (p)
    ((afn (p a)
       (iflet (s2 r) (parser p)
         (self s2 (cons r a))
         (return p rev.a)))
     p nil)))

(def on-result (f parser)
  (fn (p)
    (iflet (p2 r) (parser p)
      (return p2 (f r)))))

(mac with-result (vars parser . body)
  `(on-result (fn (,vars) ,@body)
              ,parser))

(mac with-seq (vars-parsers . body)
  (withs (ps (pair vars-parsers)
          vars (map car ps)
          parsers (map cadr ps))
    `(on-result (fn (,vars) ,@body) (seq ,@parsers))))

(def cons-seq (a b)
  (with-seq (r  a
             rs b)
    (cons r rs)))

(def many1 (parser)
  (cons-seq parser
            (many parser)))

(def must (errmsg parser)
  (fn (p)
    (or (parser p)
        (err errmsg))))

(def seqi (i parsers)
  (with-result results (apply seq parsers)
    (results i)))

(def seq1 p (seqi 0 p))

(def seq2 p (seqi 1 p))

(def optional (parser)
  (alt parser
       (fn (p)
         (return p nil))))

(mac forward (parser)
  (w/uniq p
    `(fn (,p) (,parser ,p))))

(def match-is (x)
  (match [is x _]))

(def match-literal (pat val)
  (with (patlist (coerce pat 'cons)
         patlen  len.pat)
    (fn (p)
      (if (begins p patlist)
           (return (nthcdr patlen p) val)))))

(def parse-intersperse (separator parser must-message)
  (optional (cons-seq parser
                      (many (seq2 separator
                                  (must must-message parser))))))

(def skipw (p)
  (mem nonwhite p))

(def skipwhite (parser)
  (fn (p)
    (parser (skipw p))))

(def comma-separated (parser must-message)
  (parse-intersperse (skipwhite:match-is #\,) parser must-message))
;; Parses a JSON expression and converts it to an Arc value.
;;
;;     arc> (fromjson "[1, 2, {\"a\": 3, \"b\": 4}, true, false]")
;;     (1 2 #hash(("a" . 3) ("b" . 4)) t nil)

(= json-true  (match-literal "true"  t))
(= json-false (match-literal "false" nil))
(= json-null  (match-literal "null"  nil))

(= json-number-char
  (match [find _ ".-+eE1234567890"]))

(= json-number
  (with-result cs (many1 json-number-char)
    (coerce (string cs) 'num)))

(def hexdigit (c)
  (and (isa c 'char)
       (or (<= #\a c #\f) (<= #\A c #\F) (<= #\0 c #\9))))

(= fourhex
  (must "four hex digits required after \\u"  
    (with-seq (h1 (match hexdigit)
               h2 (match hexdigit)
               h3 (match hexdigit)
               h4 (match hexdigit))
      (coerce (int (coerce (list h1 h2 h3 h4) 'string) 16) 'char))))

(def json-backslash-char (c)
  (case c
    #\" #\"
    #\\ #\\
    #\/ #\/
    #\b #\backspace
    #\f #\page
    #\n #\newline
    #\r #\return
    #\t #\tab
    (err "invalid backslash char" c)))

(= json-backslash-escape
  (seq2 (match-is #\\)
        (alt (seq2 (match-is #\u)
                   fourhex)
             (fn (p)
               (return cdr.p (json-backslash-char car.p))))))

(= json-string
  (on-result string
    (seq2 (match-is #\")
          (must "missing closing quote in JSON string"
                (seq1 (many (alt json-backslash-escape
                                 (match [isnt _ #\"])))
                      (match-is #\"))))))

(= json-array
  (seq2 (match-is #\[)
        (optional (cons-seq forward.json-value
                            (many (seq2 (skipwhite:match-is #\,)
                                        (must "a comma must be followed by a value"
                                              forward.json-value)))))
        (must "a JSON array must be terminated with a closing ]"
              (skipwhite:match-is #\]))))

(= json-object-kv
  (with-seq (key   skipwhite.json-string
             colon (must "a JSON object key string must be followed by a :"
                         (skipwhite:match-is #\:))
             value (must "a colon in a JSON object must be followed by a value"
                         forward.json-value))
    (list key value)))

(= json-object
   (on-result listtab
     (seq2 (match-is #\{)
           (comma-separated json-object-kv "comma must be followed by a key")
           (must "a JSON object must be terminated with a closing }"
                 (skipwhite:match-is #\})))))

(= json-value
  (skipwhite:alt json-true
                 json-false
                 json-null
                 json-number
                 json-string
                 json-array
                 json-object))

(def fromjson (s)
  (iflet (p r) (json-value (coerce s 'cons))
    (do 
      ;; do not break if there's a \n after a json value
      ;;(if p (err "Unexpected characters after JSON value" (coerce p 'string)))
        r)
    (err:string "not a JSON value: " s)))
;; Safely execute commands sent from a server to a browser.
;;
;; Take as input JSON, convert it to s-exps, and produce as output Javascript
;; that does not give away decrypted data.

(def srextest()
  "alert('srextest worked!')")

;; verify no command can hack us, by removing characters that spread
;; hacking terror
(def srex-clean-item (item)
  (withs (clean item)
	 ;;(prn "will clean item: " item " of type " (type item))
	 (if (or (is (type item) 'int)
		 (is (type item) 'char)
		 (is (type item) 'sym))
	     (= clean item)
	     (do (each c (list " " ";" "\r" "\n" "\"" "'"    ;; common injection attacks
			       "<" ">" ">>" "<<" ":" "*"
			       "!" "&" "|" "||" "&" "&&" "`" ;; shell injection attacks
			       "$" ".") ;; forbid DOM access through jQuery
		       (= clean (cut clean 0 (findsubseq c clean))))
		 ;;(prn "cleaned item from " item " to " clean " of type " (type clean))
		 ))
	 ;;(prn "produced: " clean " of type " (type clean))
	 clean))

(def srex-clean-table (commands-tab)
  (withs (rettab (table))
	 (maptable (fn (k v)
		       (withs (newk (coerce k 'sym))
			      ;; When the plugin calls JSON.parse, it
			      ;; ends up converting all keys from
			      ;; symbols to strings. Convert them back
			      ;; to symbols.
			      ;;(prn "table key: " k " of type " (type k) " changed to type " (type newk))
			      (if (is (type v) 'cons)
				  (= (rettab newk) (srex-clean-list v))
				  (is (type v) 'table)
				  (= (rettab newk) (srex-clean-table v))
				  (= (rettab newk) (srex-clean-item v))))) commands-tab)
	 rettab))

(def srex-clean-list (commands-list)
  (withs (l nil)
	 (each item commands-list
	       (if (is (type item) 'cons)
		   (push (srex-clean-list item) l)
		   (is (type item) 'table)
		   (push (srex-clean-table item) l)
		   (push (srex-clean-item item) l)))
	 (rev l)))

(def srex (fromwebserver cmd pubkey encprivkey encencpass)
  (withs (out "" env (table) clean-list (srex-clean-list (cmd "commands")))
	 (= env!handlercnt 0)
	 (= env!pubkey pubkey)
	 (= env!encprivkey encprivkey)
	 (= env!encencpass encencpass)
	 (= env!form-inputs (srex-clean-list (cmd "form-inputs")))
	 (= env!code (cmd "code"))
	 (= env!fns (table))

	 ;; variables set to a value that originating from decrypted data
	 (= env!vars-using-dec (table))
	 (= env!fns-using-dec (table))
	 ;; variables set to a value that will be encrypted
	 (= env!vars-using-enc (table))
	 (= env!fns-using-enc (table))

	 ;; verify the remote execution commands
	 (each token clean-list
	       (= out (str out (srex-cmd token env))))

	 ;; add savepubkeyto from contact-list to enc-itemlist
	 (srex-addto-enc-itemlist env)

	 ;; initalize hook variables
	 (= env!srex-befenc-all nil) ;; hook before all fields will be encrypted
	 (= env!srex-befenc (table)) ;; table of hooks before each field will be encrypted
         (= env!srex-aftdec (table)) ;; table of hooks after  each field will be encrypted
         (= env!srex-aftdec-all nil) ;; hook after all fields were decrypted
	 (= env!srex-used (table))   ;; table of internal functions that are used
	 (= env!srex-hack-attempt nil)

	 ;; verify the remote execution code
	 (= out (str out (srex-codewalk env)))
	 (= out (str out (srex-print env)))
	 (= out (str out (srex-remove-buttons env)))
	 (= out (str out (srex-enc-functions env)))
	 (= out (str out (srex-encencpass fromwebserver env!pubkey encprivkey env!encencpass env!pubuserid)))
	 (= out (str out (encsearch-js env!enc-itemlist
				       env!dec-itemlist env!autocomp-itemlist)))
	 (= out (str out (srex-enc env fromwebserver)))
	 (= out (str out (srex-submit env)))
	 (if env!dec-itemlist
	     (= out (str out (srex-dec-core fromwebserver env!encprivkey env!encencpass env!marktype env!dec-itemlist env!srex-aftdec env!srex-aftdec-all)))
	     (= out (str out (srex-process-aftdec-all env))))
	 (= out (str out (srex-verify-contacts env!verify-list)))
	 (= out (str out (srex-warn-unencrypted env)))
	 (= out (str out (srex-warn-leaving-browser env)))

	 (if env!srex-hack-attempt
	     (= out (str out "// Alert the user there was an unsuccessful attempt to hack them
error_messages.push('" srex-hack-attempt-msg "');
" (srex-disable-all-links) "
console.log('" srex-hack-attempt-msg "');
alert('" srex-hack-attempt-msg "');
"
)))
	 (= out (str out (srex-warn-process env!pubuserid)))
	 (= out (str out (srex-warnsign env)))
	 (= out (str out (srex-warnauthors)))
	 out))

(def srex-cmd (cmd env)
  (withs (out "")
	 (if (is (type cmd) 'cons)
	     (do (if (is (str (cmd 0)) "alert")
		     (= out (str out "alert('" (cmd 1) "');
"))
		     (is (str (cmd 0)) "may_publish")
		     (= env!may_publish (cmd 1))
		     (is (str (cmd 0)) "print")
		     (= env!may_print (cmd 1))
		     (is (str (cmd 0)) "submit") ;; an href, not a button; easier to style
		     (= env!submit-btn (cmd 1))
		     (is (str (cmd 0)) "encrypt")
		     (withs (encdata (cmd 1))
			    (= env!pubuserid encdata!pubuserid)
			    (= env!formbuttons encdata!formbuttons)
			    (= env!enc-itemlist encdata!enc-itemlist)
			    (= env!hash-itemlist encdata!hash-itemlist)
			    (= env!dec-itemlist encdata!dec-itemlist)
			    (= env!marktype encdata!marktype)
			    (= env!autocomp-itemlist encdata!autocomp-itemlist))
		     (is (str (cmd 0)) "decrypt")
		     (withs (decdata (cmd 1))
			    (= env!pubuserid decdata!pubuserid)
			    (= env!marktype decdata!marktype)
			    (= env!dec-itemlist decdata!dec-itemlist))
		     (is (str (cmd 0)) "verify")
		     (withs (verifydata (cmd 1))
			    (= env!verify-list verifydata!verify-list))
		     )))
	 out))

(def srex-print (env)
  (withs (out "")
	 (if env!may_print
	     (do (= out (str out "function print_page() {
  var elements = document.getElementsByClassName('noprint');
  var counter = 0;

  while (counter < elements.length) {
    elements[counter].style.visibility = 'hidden';
    counter++;
  }

  window.print();
  counter = 0;

  while (counter < elements.length) {
    elements[counter].style.visibility = 'visible';
    counter++;
  }
}
"))
		 (= out (str out "
document.getElementById('" env!may_print "').onclick = print_page;
document.getElementById('" env!may_print "').href = \"#\";
"))))
	 out))
		      
(def srex-remove-buttons (env)
  (withs (out "")
	 (= out (str out "
// Remove all buttons so you can't submit anything.
var buttonsList = document.getElementsByTagName('input');
for (var i = 0; i < buttonsList.length; i++) {
   if (buttonsList[i].type == 'button') {
      buttonsList[i].parentNode.removeChild(buttonsList[i]);
   }
}

"))
	 out))

(def srex-on-contact-list (formbuttons fndo)
  (each item formbuttons
	(if item!contact-list
	    (each contact item!contact-list
		  (fndo contact)))))

(def srex-find-in-enc-itemlist (id enc-itemlist)
  (withs (ret nil)
	 (each item enc-itemlist
	       (if (is item!id id)
		   (= ret item)))
	 ret))

(def srex-addto-enc-itemlist (env)
  (srex-on-contact-list env!formbuttons
			(fn (contact)
			    (if contact!savepubkeyto
				;; don't add this id again if it already exists
				;; but do set the existing one to force signing the pubkey
				(withs (existing (srex-find-in-enc-itemlist contact!savepubkeyto env!enc-itemlist))
				    (if (no existing)
					(push (obj id contact!savepubkeyto
						   forcesign t) ;; force signing the pubkey
					      env!enc-itemlist)
					(withs (new-enc-itemlist nil)
					       (each item env!enc-itemlist
						     (if (is item!id contact!savepubkeyto)
							 (= item!forcesign t))
						     (push item new-enc-itemlist))
					       (= env!enc-itemlist new-enc-itemlist))
					))))))

(def srex-only-searchable (enc-itemlist)
  (withs (ret t)
	 (each item enc-itemlist
	       (if (and (no item!tosearch)
			(no item!toretrieve))
		   (= ret nil)))
	 ret))

;; check if all items in enc-itemlist are forced to be signed: if all
;; of them are public keys that should be encrypted
(def srex-only-forcesign (enc-itemlist formbuttons)
  (withs (forcesigncnt 0)
	 (srex-on-contact-list formbuttons
			       (fn (contact)
				   (if contact!savepubkeyto
				       (++ forcesigncnt))))
	 (if (is (len enc-itemlist) forcesigncnt)
	     t nil)))

(def srex-iscontactpubkey (id formbuttons)
  (withs (ret nil)
	 (srex-on-contact-list formbuttons
			       (fn (contact)
				   (if (is id contact!savepubkeyto)
				       (= ret t))))
	 ret))

(def srex-iscontactsavetextarea (id formbuttons)
  (withs (ret nil)
	 (srex-on-contact-list formbuttons
			       (fn (contact)
				   (if contact!saveistextarea)
				   (= ret t)))
	 ret))

(= SHA512-len* 128)
(def srex-enc-core (enc-itemlist hash-itemlist srex-befenc encpassid formbuttons)
  (withs (ret "")

	 (= ret (str ret "
    // Encrypt each data field"))
	 (if encpassid
	     (= ret (str ret "
    // Prepare an array of keys, one per recipient, to support encrypting
    // data for multiple recipients.
    var keymanager_keys = [];
    {
       recipients_counter = 0;
       while (recipients_counter < all_recipients_total) {
          var this_id = Object.keys(all_recipients)[recipients_counter];
          var local_this_pubkey = all_recipients[this_id]['pubkey'];
          var local_keymanager = openpgp.key.readArmored(local_this_pubkey);
          keymanager_keys.push(local_keymanager.keys[0]);
          recipients_counter++;
       }
    }
")))

	 ;; Prepare any values in fields before encrypting
	 (each item enc-itemlist
	       (withs (id item!id
		       befenc (srex-befenc id))
		      (if befenc
			  (= ret (str ret "    // Server-supplied code for srex-before-encrypt
    " befenc)))))

	 ;; encrypt
	 (each item enc-itemlist
	       (withs (id item!id
		       tosearch item!tosearch       ;; encrypt to store so we can search
		       tosearchout item!tosearchout ;; will hold output of encryption
		       toretrieve item!toretrieve   ;; encrypt to perform the search
		       toretrievekeys item!toretrievekeys ;; number of word keys to generate
		       toretrieveout item!toretrieveout ;; will hold encrypted input to search query
                       iscontactpubkey (srex-iscontactpubkey id formbuttons)
                       forcesign item!forcesign
		       istextarea item!istextarea)
		      (if iscontactpubkey
			  (withs (contactsaveistextarea (srex-iscontactsavetextarea id formbuttons))
				 (= ret (str ret "
    var contact_pubkey = contact_keyinfo['pubkey'];
    document.getElementById('" id "')." (srex-accesstype contactsaveistextarea) " = contact_pubkey;"))))
		      (= ret (str ret "
    var val" id " = document.getElementById('" id "').value;"))
		      (= ret (str ret "
    if (val" id " != '') { // don't encrypt blanks, for error checking"))
		      (if tosearch
			  ;; must do more work to support encrypted search
			  (do ;; if there is no searchout field, fall back to using the id
			      (if (no tosearchout)
				  (= tosearchout id))
			      ;; don't clutter a visible field; also don't send the plaintext
			      (= ret (str ret "
        document.getElementById('" tosearchout "').value = encrypt_tosearch(val" id ", searchsalt, searchpass, searchiv, searchmperc);
        document.getElementById('" id "').value = '';")))
			  toretrieve
			  ;; must send an encrypted query
			  (do (if (no toretrievekeys)
				  (= toretrievekeys 0))
			      ;; don't clutter a visible field; also don't send the plaintext
			      (= ret (str ret "
        document.getElementById('" toretrieveout "').value = encrypt_toretrieve(val" id ", searchsalt, searchpass, searchiv, searchmperc, " toretrievekeys ");
        document.getElementById('" id "').value = '';")))
			  ;; else -- just encrypt
			  (= ret (str ret "
       " ;; if we are encrypting a contact's public key, encrypt it
	  ;; only for us
	  (if iscontactpubkey
	      (str "document.getElementById('" id "').value = encrypt_nonsearchable(val" id ", [pubkey_openpgp], " (if forcesign "1" "sign") ", [privkey_openpgp]);")
	      (str "document.getElementById('" id "').value = encrypt_nonsearchable(val" id ", keymanager_keys, sign, [privkey_openpgp]);")))))
		      (= ret (str ret "
    }
"))
		      ))
	 (= ret (str ret "
"))

	 ;; hash
	 (if hash-itemlist
	     (do (= ret (str ret "
    // Hash each item
    var inmessage = null;
    var outmessage = null;
"))

		 (each id hash-itemlist
		       ;; Don't hash a second time if the password was
		       ;; saved by the browser's password manager as a
		       ;; SHA-512 value
		       (= ret (str ret "
    inmessage = document.getElementById('" id "').value;
    if (inmessage.length == " SHA512-len* ") 
        outmessage = inmessage;
    else
        outmessage = CryptoJS.SHA512(inmessage);
    document.getElementById('" id "').value = outmessage;
")))
	       ))
	 ret))

(def srex-disable-all-links ()
  (withs (out "")
	 (= out (str out "var anchors = document.getElementsByTagName(\"a\");
for (var i = 0; i < anchors.length; i++) {
    anchors[i].onclick = function() {return false;};
    anchors[i].style.color = 'red';
    anchors[i].href = 'file:///THIS_LINK_WAS_DISABLED_TO_PROTECT_YOU';
}
"))
	 out))

(def srex-warn-process (pubuserid)
  (str "// Show the author of all messages
function authors_unique() {
   var author_counter = 0;
   var all_authors = {};

   while (author_counter < author_messages.length) {
     var author = author_messages[author_counter];
     var userid = author[1];

     all_authors[userid] = 1;
     author_counter++;
   }

   return Object.keys(all_authors).length;
}

function authors_only_us () {
   if (authors_unique() == 1) {
      var author = author_messages[0];
      var userid = author[1];
      if (userid == '" pubuserid "') {
         return true;
      }
   }
   return false;
}

if (author_messages.length > 0) {
   var author_counter = 0;

   // Create all author verification messages
   while (author_counter < author_messages.length) {
     var author = author_messages[author_counter];
     var fieldname = author[0];
     var userid = author[1];
     create_author(fieldname, userid);
     show_author(fieldname, true);
     author_counter++;
   }
}

// Alert the user on the top left of the screen if there were errors
function alert_errors () {
  if (error_messages.length > 0) {
     var error_counter = 0;
     var innerHTML = '';

     while (error_counter < error_messages.length) {
         innerHTML = innerHTML + error_messages[error_counter] + '<br>';
         error_counter++;
     }

     var div = document.createElement('div');
     div.id = 'srex-alarm';
     div.style.textAlign = 'left';
     div.style.position = 'absolute';
     div.style.left = 15;
     div.style.top = 15;
     div.style.font = '13px Verdana';
     div.style.padding = '14px';
     div.style.color = 'white';
     div.style.backgroundColor = 'red';
     div.innerHTML = innerHTML;

     document.body.appendChild(div);
  }
}
alert_errors();

"))

(def srex-warn-unencrypted (env)
  (withs (ret "")
	 ;; Don't encrypt hidden values, and never set them. Hidden
	 ;; values should be created as textareas with style
	 ;; "display:none" so they stay hidden visually but are
	 ;; guaranteed to be encrypted.
	 ;; Raise alarms for every field that won't be encrypted
	 (= ret (str ret "

// ---------- alert the user if there are any fields that won't be encrypted
var found_fields_to_not_encrypt = false;
"))
	 (each elementtype (list "textarea" "input")
	       (= ret (str ret "
// Inspect every " elementtype "
var " elementtype "List = document.getElementsByTagName('" elementtype "');
for (var i=0; i < " elementtype "List.length; i++) {
"
  (srex-warn-unencrypted-each elementtype env!enc-itemlist env!hash-itemlist env!autocomp-itemlist)
"
}
")))
	 (= ret (str ret "
if (found_fields_to_not_encrypt) {
  // Alert the user some fields won't be encrypted
  error_messages.push(\"The input fields in red won't be encrypted.\");
}

"))
         ret))

(def srex-warn-unencrypted-each (varname enc-itemlist hash-itemlist autocomp-itemlist)
  (withs (ret "" counter 0)
	 (= ret (str ret "
    if ( "))
	 (if (is varname "input")
	     (do (= ret (str ret "(" varname "List[i].type == 'text' || " varname "List[i].type == 'password')"))
		 (++ counter)))
	 (each item enc-itemlist
	       (withs (id item!id)
		      (if (> counter 0)
			  (= ret (str ret " && ")))
		      (= ret (str ret varname "List[i].name != '" id "'")))
	       (++ counter))
	 (each id hash-itemlist
	       (if (> counter 0)
		   (= ret (str ret " && ")))
	       (= ret (str ret varname "List[i].name != '" id "'"))
	       (++ counter))
	 (each item autocomp-itemlist
	       (withs (id item!searchin)
		      (if (> counter 0)
			  (= ret (str ret " && ")))
		      (= ret (str ret varname "List[i].name != '" id "'"
				  " && " varname "List[i].id != 'token-input-" id "'")))
	       (++ counter))
	 (if (> counter 0)
	     (= ret (str ret " && ")))
	 (= ret (str ret "true ) {
       console.log(" varname "List[i].name + ' will not be encrypted');
       " varname "List[i].style.backgroundColor='red';
       " varname "List[i].style.color='white';
       found_fields_to_not_encrypt = true;
    }
"))
	 ret))

(def srex-warn-leaving-browser (env)
  (withs (ret "" found-sendout nil)
	 (maptable (fn (k v)
		       (if (is k "jq-ajax")
			   (= found-sendout t))
		       ) env!fns-using-enc)
	 (if found-sendout
	     (do (= ret (str ret "// Alert the user some fields are sent out of the browser
error_messages.push(\"The input fields in red will be sent unencrypted out of the browser.\");

"))
		 (maptable (fn (k v)
			       ;;(prn (str "k: " k))
			       (if (srex-is-encrypted-data env (str k) nil)
				   (do ;;(prn (str "var " k " is encrypted"))
				       (= ret (str ret "var val" k " = document.getElementById('" k "');
val" k ".style.backgroundColor='red';
val" k ".style.color='white';

"))
				       ))
			       ) env!vars-using-enc)
		 ))
	 ret))

(def srex-warnsign (env)
  (withs (out "")
	 (if (and env!enc-itemlist
		  (no (srex-only-searchable env!enc-itemlist))
		  (no (srex-only-forcesign env!enc-itemlist env!formbuttons)))
	     (= out (str out "
// warn the user if the encrypted data won't be signed
{
  var div = document.createElement('div');
  div.id = 'srex-sign-alarm';
  div.style.textAlign = 'left';
  div.style.position = 'absolute';
  div.style.right = 15;
  div.style.top = 15;
  div.style.font = '13px Verdana';
  div.style.padding = '14px';
  div.style.color = 'white';
  div.style.backgroundColor = 'orange';
  div.style.display = 'none';
  div.innerHTML = 'The encrypted data will not be digitally signed.';
  document.body.appendChild(div);
}

function check_signing () {
  if (document.getElementById('sign') == null ||
      document.getElementById('sign').checked == false)
     document.getElementById('srex-sign-alarm').style.display = 'block';
  else
     document.getElementById('srex-sign-alarm').style.display = 'none';

  // published data are neither encrypted nor signed
  if (document.getElementById('publish') &&
      document.getElementById('publish').checked == true) {
     document.getElementById('srex-sign-alarm').style.display = 'none';
     if (document.getElementById('sign'))
        document.getElementById('sign').disabled = true;
  } else {
     if (document.getElementById('sign'))
        document.getElementById('sign').disabled = false;
  }
}

if (document.getElementById('sign')) {
   document.getElementById('sign').onclick = check_signing;
}

if (document.getElementById('publish')) {
   document.getElementById('publish').onclick = check_signing;
}

check_signing();
")))
	 out))

(def srex-warnauthors ()
  (withs (out "")
	 (= out (str out "
// warn the user author information will not be shown
{
  var div = document.createElement('div');
  div.id = 'srex-showauthors-alarm';
  div.style.textAlign = 'left';
  div.style.position = 'absolute';
  div.style.right = 15;
  div.style.top = 50;
  div.style.font = '13px Verdana';
  div.style.padding = '14px';
  div.style.color = 'white';
  div.style.backgroundColor = 'orange';
  div.style.display = 'none';
  div.innerHTML = 'Author user ids will not be shown.';
  document.body.appendChild(div);
}

function check_authors() {
  if (document.getElementById('showauthors') != null) {
     if (document.getElementById('showauthors').checked == false) {
        // If all messages have been authored by us don't show the alarm
        if (authors_only_us() == false)
           document.getElementById('srex-showauthors-alarm').style.display = 'block';
        show_all_authors(false);
     } else {
        document.getElementById('srex-showauthors-alarm').style.display = 'none';
        show_all_authors(true);
     }
  } else {
     // If all messages have been authored by us don't show the alarm
     if (authors_only_us() == false)
        document.getElementById('srex-showauthors-alarm').style.display = 'block';
     show_all_authors(false);
  }
}

if (document.getElementById('showauthors')) {
   document.getElementById('showauthors').onclick = check_authors;
}
check_authors();
"))
	 out))

(def srex-encencpass (fromwebserver pubkey encprivkey encencpass pubuserid)
  (str "var error_messages = [];
var author_messages = [];

var pubkey = " (pgp-tomultiline pubkey "             ") ";
var pubkey_openpgp = openpgp.key.readArmored(pubkey).keys[0];

// Extract the encrypted encryption password
var encencpass = " (if fromwebserver
		       "localStorage.getItem('encrypted_encryption_password')"
		       (str "'" encencpass "'")) ";

// Decrypt the private key
var encprivkey = '" encprivkey "';
var privkeyObj = CryptoJS.AES.decrypt( encprivkey, encencpass );
var privkey = privkeyObj.toString(CryptoJS.enc.Utf8);

// Prepare for decrypting each item
var privkey_openpgp = openpgp.key.readArmored(privkey).keys[0];
privkey_openpgp.decrypt(encencpass);

// Decrypt the verified keyids
var encverifiedkeyids = document.getElementById('encverifiedkeyids').value;
var verifiedkeyids = {};
verifiedkeyids = decrypt_nonsearchable('encverifiedkeyids', encverifiedkeyids, privkey_openpgp);
verifiedkeyids = JSON.parse(verifiedkeyids);

// Decrypt a non-searchable field "
;; when called from autocomplete_to_encpass,
;; there is no fieldname, so don't break if a
;; blank one is passed
"
function create_author(fieldname, userid) {
  if (document.getElementById(fieldname).type != 'hidden') {
    var div = document.createElement('div');
    div.id = fieldname + '_author_verification';
    div.style.textAlign = 'left';
    div.style.font = '11px Verdana';
    div.style.color = 'white';
    div.style.position = 'absolute';
    var field_top = document.getElementById(fieldname).getBoundingClientRect().top;
    var field_left = document.getElementById(fieldname).getBoundingClientRect().left;
    div.style.top = field_top - 20;
    div.style.left = field_left;
    div.innerHTML = 'by ' + userid;
    div.style.width = '120px';
    div.style.padding = '3px';
    div.style.backgroundColor = 'green';

    document.body.appendChild(div);
  }
}

function show_author(fieldname, show) {
  if (document.getElementById(fieldname + '_author_verification') != null) {
     if (show)
        document.getElementById(fieldname + '_author_verification').style.display = 'block';
     else
        document.getElementById(fieldname + '_author_verification').style.display = 'none';
  }
}

function show_all_authors(show) {
  var author_counter = 0;

  while (author_counter < author_messages.length) {
    var author = author_messages[author_counter];
    var fieldname = author[0];
    show_author(fieldname, show);
    author_counter++;
  }
}

function decrypt_nonsearchable(fieldname, encfieldvalue, decrypt_privkey_openpgp) {
  var field = encfieldvalue;

  if (encfieldvalue != '') {
    var messagefield = openpgp.message.readArmored( encfieldvalue );
    var decresult = {};
    var msg = messagefield;
    msg = msg.decrypt(decrypt_privkey_openpgp);
    decresult.text = msg.getText();
    if (decresult.text) {
      // success
      console.log('decrypted ' + fieldname + ' to ' + decresult.text);

      // verify all signatures were valid
      decresult.signatures = msg.verify([ decrypt_privkey_openpgp ]);
      var signatures_counter = 0;
      var signatures_total = Object.keys(decresult.signatures).length;
      console.log('There are ' + signatures_total + ' signatures for ' + fieldname);
      var signature_verification_failed = 0;
      var user_verification_failed = 0;
      while (signatures_counter < signatures_total) {
        var sigkey = Object.keys(decresult.signatures)[signatures_counter];
        var sigvalue = decresult.signatures[sigkey];
        if (sigvalue.valid == 0) {
            console.log('invalid signature found');
            error_messages.push(\"The field '\" + fieldname + \"' in red failed signature verification. \" +
                                'Odds are SOMEONE IS EAVESDROPPING ON YOU RIGHT NOW.');
            signature_verification_failed = 1;
        } else {
          // check if this signature is from a user we verified
          var keyid = sigvalue.keyid.toHex();
          console.log('will check keyid: ' + keyid);
          console.log('with verifiedkeyids: ');
          console.log(verifiedkeyids);
          var userid = verifiedkeyids[keyid];
          if (userid == null) { // also check if the keyid was ours
             var our_keyid = pubkey_openpgp.getKeyIds()[0].toHex();
             console.log(our_keyid);
             if (our_keyid == keyid) {
               console.log('the keyid was our own: ' + our_keyid);
               author_messages.push([fieldname, '" pubuserid "']);
             } else {
               console.log('the signature is from an unknown user');
               error_messages.push(\"The field '\" + fieldname + \"' in red was signed by someone you haven't verified.\");
               user_verification_failed = 1;
             }
          } else {
            author_messages.push([fieldname, userid]);
          }
        }
        signatures_counter++;
      }
      if (signatures_total == 0) {
        error_messages.push(\"The data field '\" + fieldname + \"' in red was not digitally signed. \");
      }
      if (signatures_total == 0 || signature_verification_failed == 1 || user_verification_failed) {
          if (document.getElementById(fieldname) != null) {
             document.getElementById(fieldname).style.backgroundColor='red';
             document.getElementById(fieldname).style.color='white';
          }
      }
    } else {
      console.log('failed to decrypt');
    }

    field = decresult.text;
    console.log('decrypted to: ' + field);
  }

  return field;
}

" (encrypt-nonsearchable) "
"))

(def srex-encrypt-verifiedkeyids (spacing forkeys)
  (str "
" spacing "// encrypt the verifiedkeyids
" spacing "var this_verifiedkeyids = JSON.stringify(verifiedkeyids);
" spacing "encverifiedkeyids = encrypt_nonsearchable(this_verifiedkeyids, " forkeys ", 1, [privkey_openpgp]);
" spacing "document.getElementById('encverifiedkeyids').value = encverifiedkeyids;"))

(def srex-contact-dialogids (dialogids)
  (withs (dialogid (str "dialog_" (srex-uniq)))
	 (push dialogid dialogids)))

(def srex-contact-functions (contact dialogid next btn)
  (withs (out "")
	 (= out (str out "// must " contact!action " contact for " contact!id "
var " dialogid " = document.createElement('dialog');

function " dialogid "_yes () {
  // add to verifiedkeyids
  var contact_pubkey = contact_keyinfo['pubkey'];
  var contact_pubkey_openpgp = openpgp.key.readArmored(contact_pubkey).keys[0].primaryKey;
  var keyid = contact_pubkey_openpgp.getKeyId().toHex();
  var userid = contact_keyinfo['userid'];
  if (keyid != null && userid != null) {
     // mark this key as verified
     verifiedkeyids[keyid] = userid;
  }
  " dialogid ".close();
  // go to next dialog, or submit
  " (if next
	(str next ".showModal();")
	"") "
  encrypt_before_submit_" (srex-valid-js btn) "();
}

function " dialogid "_no() {
  " dialogid ".close();
  // go to next dialog, or submit
  " (if next
	(str next ".showModal();")
	;; no need to encrypt the verifiedkeyids again
	(str "encrypt_before_submit_" (srex-valid-js btn) "();")) "
}

"))
	 out))

;; Larry and Sergey won't respect you in the morning.
;; http://old.ycombinator.com/ad.html
(def srex-contact-add (env contact dialogid)
  (withs (out "")
	 ;; note to self: add html.arc
	 (= out (str out "
  // verify contact for " contact!id "
  contact_keyinfo = " (env!fns (sym contact!fn)) "();
  " dialogid ".id = '" dialogid "';
  " dialogid ".style.borderColor = '" (hexrep (color 255 102 0)) "';
  " dialogid ".style.font = '13px Verdana';
  " dialogid ".style.padding = '14px';
  " dialogid ".style.backgroundColor = '#ffffee';
  " dialogid ".style.color = '" (hexrep (color 255 102 0)) "';
  " dialogid ".innerHTML = '<span><b>PLEASE VERIFY the public-key fingerprint of this contact:</b></span>' + '<br><br><br><br>';
  var userid = contact_keyinfo['userid'];
  " dialogid ".innerHTML = " dialogid ".innerHTML + userid + '<br><br>';
  var contact_pubkey = contact_keyinfo['pubkey'];
  if (contact_pubkey != null && contact_pubkey != '') {
    var contact_pubkey_openpgp = openpgp.key.readArmored(contact_pubkey).keys[0].primaryKey;
    var keyid = contact_pubkey_openpgp.getFingerprint();
    if (keyid != null && userid != null) {
       var readable_keyid = keyid.match(/.{1,4}/g).join(' ').toUpperCase();
       " dialogid ".innerHTML = " dialogid ".innerHTML + readable_keyid + '<br>';
    }

    var keyid_short = contact_pubkey_openpgp.getKeyId().toHex();
    if (verifiedkeyids[keyid_short]) {
      // this key was already added; don't override a previous one
      " dialogid ".innerHTML = " dialogid ".innerHTML + '<br><br>' +
\"This key was already added. Will not add it again to protect the existing one.\" + '<br><br>' +
'<table>' +
'<tr>' +
\"<td style='width:150px;'>\" +
\"<button id='" dialogid "_no_button'>OK</button>\" +
'</td>' + 
'</tr>' +
'</table>';
      document.body.appendChild(" dialogid ");
      document.getElementById('" dialogid "_no_button').onclick = " dialogid "_no;
    } else {
      // this key wasn't already added; add it

      " dialogid ".innerHTML = " dialogid ".innerHTML + '<br><br>' +
'<table>' +
'<tr>' +
\"<td style='width:150px;'>\" +
\"<button id='" dialogid "_yes_button'>Yes</button>\" +
'</td>' +
\"<td style='width:150px;'>\" +
'</td>' +
'<td>' +
\"<button id='" dialogid "_no_button'>No</button>\" +
'</td>' + 
'</tr>' + 
'</table>';
      document.body.appendChild(" dialogid ");
      document.getElementById('" dialogid "_yes_button').onclick = " dialogid "_yes;
      document.getElementById('" dialogid "_no_button').onclick = " dialogid "_no;
   }
  } else {
    // this user doesn't have a public key
    " dialogid ".innerHTML = " dialogid ".innerHTML + '<br><br>' +
\"This user doesn't have a public key. There's nothing to verify.\" + '<br><br>' +
'<table>' +
'<tr>' +
\"<td style='width:150px;'>\" +
\"<button id='" dialogid "_no_button'>OK</button>\" +
'</td>' + 
'</tr>' +
'</table>';
   document.body.appendChild(" dialogid ");
   document.getElementById('" dialogid "_no_button').onclick = " dialogid "_no;
  }
  " dialogid ".showModal();
  "))
	 out))

(def srex-enc (env fromwebserver)
  (withs (out "")

	 (each item env!autocomp-itemlist
	       (withs (url item!url enc-fieldlist item!enc-fieldlist
		       searchin item!searchin searchout item!searchout
		       toretrievekeys item!toretrievekeys
		       encpassid item!encpassid
		       eflout "" counter 0)
		      (= eflout (str eflout "["))
		      (each ef enc-fieldlist
			    (if (> counter 0)
				(= eflout (str eflout ", ")))
			    (= eflout (str eflout "'" ef "'"))
			    (++ counter))
		      (= eflout (str eflout "]"))
		      (= out (str out "jq_autocomplete_tokeninput_encrypted('" url "', " eflout  ", '" encpassid "', '#" searchin "', '" searchout "', " toretrievekeys ");
"))))

	 (each item env!formbuttons
	       (withs (form item!form btn item!btn encpassid item!encpassid
		       contact-list item!contact-list)
		      (if contact-list
			  (withs (counter 0 dialogids (list) willadd nil willdelete nil)
				 (= out (str out "var contact_keyinfo = {};
"))
				 (each contact contact-list
				       (if (is contact!action "add")
					   (= dialogids (srex-contact-dialogids dialogids))))
				 (each contact contact-list
				       (if (is contact!action "add")
					   (withs (next (if (< (+ counter 1) (len contact-list))
							    (dialogids counter) nil))
						  (= out (str out (srex-contact-functions contact (dialogids counter) next btn)))))
				       (++ counter))
				 (= out (str out "function verify_before_submit_" (srex-valid-js btn) "() {"))
				 (= counter 0)
				 (each contact contact-list
				       (if (is contact!action "delete")
					   (do (= willdelete t)
					       (= out (str out (srex-contact-delete env contact)))))
				       (++ counter))
				 (= counter 0)
				 (each contact contact-list
				       (if (is contact!action "add")
					   (do (= willadd t)
					       (= out (str out (srex-contact-add env contact (dialogids counter))))))
				       (++ counter))
				 (if willadd
				     (= out (str out "
  // Don't submit the form. Submit only if all verifications occur.
  return false;
}

"))
				     willdelete ;; but not willadd
				     (= out (str out "
  // Submit the form regardless
  " (srex-encrypt-verifiedkeyids "  " "[pubkey_openpgp]") "
  document.getElementById('" form "').submit();
  return true;
}
")))
				 ))

		      (= out (str out "function encrypt_before_submit_" (srex-valid-js btn) "() {
"))

		      (if env!srex-befenc-all
			  (= out (str out "  // Server-supplied code for srex-before-encrypt-all
  " env!srex-befenc-all "
")))

		      ;; if there are any autocomplete entries that
		      ;; contain an id and pubkey, add entries for
		      ;; them in encpass
		      (if env!autocomp-itemlist
			  (do (each item env!autocomp-itemlist
				    (withs (searchout item!searchout)
					   (= out (str out "
  // --------------------------------------------------------------------------
  // Build from autocomplete the new encpass variable
  var autocomplete_ret = autocomplete_to_encpass('" searchout "', '" encpassid "');
  if (autocomplete_ret == false) {
     // someone was eavesdropping, or someone didn't have a public key to encrypt for them
     alert_errors();
     return false;
  }
"))))
			      (= out (str out "

"))))
		      (if env!enc-itemlist
			  (do (= out (str out "  var sign = true;"))
			      ;; if processing only searchable
			      ;; encryption don't check for a signing
			      ;; message
			      (if (no (srex-only-searchable env!enc-itemlist))
				  (= out (str out "
  if (document.getElementById('sign') &&
      document.getElementById('sign').checked == true)
     sign = true;
  else
     sign = false;
")))))
		      (if (or env!enc-itemlist env!hash-itemlist)
			  (do (if env!may_publish
				  ;; the publish field can't be hidden when it was served; it must be checked by the user
				  (= out (str out "  var publish = false;
  // the publish field can't be hidden and checked when served; it must be checked by the user
  if (document.getElementById('publish') &&
      document.getElementById('publish').checked == true &&
      document.getElementById('publish').hidden == false)
      publish = true;

  if (publish) {
     document.getElementById('" form "').submit(); 
     return true; // Do not encrypt published
  }

")))

			      ;;(if env!enc-itemlist ;; do this always
			      (= out (str out "
"
  (if (no encpassid)
      "  var should_encrypt = 1;
"
      (str "
  // --------------------------------------------------------------------------
  // Detect if no recipient supports encryption, to not encrypt message
  var should_encrypt = 1;
  var recipients_counter = 0;
  var all_recipients = document.getElementById('" encpassid "').value;
  if (all_recipients == '') {
    all_recipients = {};
  } else {
    all_recipients = JSON.parse(all_recipients);
  }
  all_recipients['" env!pubuserid "'] = { 'pubkey': pubkey };
  var all_recipients_total = Object.keys(all_recipients).length;

  while (recipients_counter < all_recipients_total) {
     var this_id = Object.keys(all_recipients)[recipients_counter];
     var this_pubkey = all_recipients[this_id]['pubkey'];
     if (this_pubkey == '' || this_pubkey == null) {
         should_encrypt = 0;
     }
     recipients_counter++;
  }

"))

  "  if (should_encrypt == 1) {
"))

			      (= out (str out (srex-enc-core env!enc-itemlist env!hash-itemlist env!srex-befenc encpassid env!formbuttons)))
			      (= out (str out "  }
"))
			      (if (and encpassid env!enc-itemlist)
				  ;; don't try to encrypt unnecessarily
				  (= out (str out "
  // don't send public keys to the server
  recipients_counter = 0;
  while (recipients_counter < all_recipients_total) {
     var this_id = Object.keys(all_recipients)[recipients_counter];
     all_recipients[this_id]['pubkey'] = null;
     if (should_encrypt)
       all_recipients[this_id]['encrypted'] = true;
     else
       all_recipients[this_id]['encrypted'] = false;
     recipients_counter++;
  }

  // set the recipients
  all_recipients = JSON.stringify(all_recipients);
  document.getElementById('" encpassid "').value = all_recipients;
  " (srex-encrypt-verifiedkeyids "  " "[pubkey_openpgp]") "

  document.getElementById('" form "').submit();
")))
			      )) ;; (if (or env!enc-itemlist env!hash-itemlist)

		      (if (no (and encpassid env!enc-itemlist))
			  (= out (str out 
				      (if (srex-processing-contacts env)
					  (str "
  " (srex-encrypt-verifiedkeyids "  " "[pubkey_openpgp]"))) "
  document.getElementById('" form "').submit();
")))
		      (= out (str out "}
"))
		      ))
	 out))

(def srex-enc-autocomplete-prologue (env)
  (str "  // For every entry with an 'id' and 'pubkey' in autocomplete's searchout, add an entry in encpass
  var autocomplete = document.getElementById(searchout).value;
  autocomplete = JSON.parse(autocomplete);
  var autocomplete_counter = 0;

  // Load existing encpass
  var all_recipients = document.getElementById(encpass).value;
  if (all_recipients == '') {
    all_recipients = {};
  } else {
    all_recipients = JSON.parse(all_recipients);
  }

  all_recipients['" env!pubuserid "'] = { 'pubkey': pubkey };
"))

(def srex-enc-functions (env)
  (withs (out "")
	 (if env!autocomp-itemlist
	     (do (= (env!srex-used "jq-autocomplete-tokeninput-encrypted") t)
		 (= (env!srex-used "srex-get") t)
		 (= (env!srex-used "srex-get-wtype") t)
		 (= (env!srex-used "srex-length") t)
		 (= (env!srex-used "srex-set") t)))

	 (if env!enc-itemlist
	     (do (= (env!srex-used "srex-set") t)))

	 (if env!dec-itemlist
	     (do (= (env!srex-used "srex-get") t)))

	 (= out (str out "
"
		     (if (env!srex-used "srex-get-wtype")
			 "function srex_get_wtype(obj, accessor) {
  if (typeof(obj[accessor]) == \"function\") {
      var args = Array.prototype.splice.call(arguments, 2);
      return obj[accessor].apply(obj, args);
  } else
      return obj[accessor]; // accessing a method or indexing a string
}

")
		     (if (env!srex-used "srex-length")
			 "function srex_length(obj) {
  if (typeof(obj) == \"string\")
      return obj.length;
  else
      return Object.keys(obj).length;
}

")
		     (if (env!srex-used "srex-get")
			 "function srex_get (id, istextbox) {
  if (istextbox == true)
      return document.getElementById(id).value;
  else
      return document.getElementById(id).innerText;
}

")
		     (if (env!srex-used "srex-set")
			 "function srex_set (id, istextbox, value) {
  if (istextbox == true)
     document.getElementById(id).value = value;
  else
     document.getElementById(id).innerText = value;
}

")
		     (if (env!srex-used "srex-set-attr")
			 "function srex_set_attr (id, attribute, value) {
  document.getElementById(id).setAttribute(attribute, value);
}

")

		     (if (env!srex-used "srex-onclick")
			 "function srex_onclick (id, fn) {
  var item = document.getElementById(id);
  item.onclick = fn;
}

")

		     (if (env!srex-used "srex-onkeypress")
			 "function srex_onkeypress (id, fn) {
  var item = document.getElementById(id);
  item.onkeypress = fn;
}

")
		     (if (env!srex-used "jq-ajax")
			 "function jq_ajax (ajax) {
  $.ajax( ajax );
}

")
		     (if (env!srex-used "jq-autocomplete")
			 "function jq_autocomplete (field, hash) {
  $( function () {
    $( field ).autocomplete( hash );
  });
}

")

		     (if (env!srex-used "jq-autocomplete-tokeninput")
			 "function jq_autocomplete_tokeninput (field, source, hash) {
  $( field ).tokenInput ( source, hash );
}

")

		     (if (env!srex-used "jq-autocomplete-tokeninput-encrypted")
			 (str (deepcompare) "
function tokeninput_encrypted_getsafe(item, encfields) {
    // All fields will be copied except the fields that were decrypted
    var keyscounter = 0;
    var keystotal = Object.keys(item).length;
    var safe_item = {};
    while (keyscounter < keystotal) {
      var key = Object.keys(item)[keyscounter];
      var value = item[key];
      if (encfields != null && Array.isArray(encfields) && encfields.indexOf(key) > -1) {
         // This is a decrypted field; do not copy it
      } else
        safe_item[key] = value;
      keyscounter++;
    }
   return safe_item;
}

function autocomplete_to_encpass(searchout, encpass) {
" (srex-enc-autocomplete-prologue env) "
  // Add to encpass each entry from autocomplete that contains a 'pubkey'
  while (autocomplete_counter < autocomplete.length) {
     var toadd = autocomplete[autocomplete_counter];
     var enc_contact_pubkey = toadd['pubkey'];
     console.log('enc_contact_pubkey is ' + enc_contact_pubkey);
     console.log('toadd: ');
     console.log(toadd);
     if (enc_contact_pubkey != null && enc_contact_pubkey != false) {
       // must decrypt the contact_pubkey, because it is stored encrypted
       var contact_pubkey = decrypt_nonsearchable('enc_contact_pubkey', enc_contact_pubkey, privkey_openpgp);
       console.log('contact_pubkey');
       console.log(contact_pubkey);
       var userid = toadd['id'];
       console.log('userid: ' + userid);
       if (contact_pubkey == false) {
          // this contact doesn't have a public key
          error_messages.push(\"Can't encrypt for user \" + userid + \" because the public key for them could not be decrypted.\");
          return false;
       } else {
          var contact_pubkey_openpgp = openpgp.key.readArmored(contact_pubkey).keys[0].primaryKey;
          var keyid = contact_pubkey_openpgp.getFingerprint();
          var keyid_short = contact_pubkey_openpgp.getKeyId().toHex();
          var our_keyid_short = pubkey_openpgp.getKeyIds()[0].toHex();
          console.log('keyid: ' + keyid);
          console.log('keyid_short: ' + keyid_short);
          console.log('our_keyid_short: ' + our_keyid_short);
          if ((our_keyid_short == keyid_short) ||
              (keyid != null && userid != null && verifiedkeyids[keyid_short])) {
             // this key was verified; add it
             all_recipients[toadd['id']] = { 'pubkey': contact_pubkey };
             console.log('the key was verified');
          } else {
             // this key failed verification; raise an alert
             console.log('the key failed verification');
             console.log(keyid);
             console.log(userid);
             console.log(keyid_short);
             console.log(verifiedkeyids);
             var readable_keyid = keyid.match(/.{1,4}/g).join(' ').toUpperCase();
             error_messages.push(\"The public key '\" + readable_keyid + \"' for userid '\" + userid + \"' failed verification. \" +
                                 'Odds are SOMEONE IS EAVESDROPPING ON YOU RIGHT NOW.');
             return false;
          }
       }
     } else {
        // this contact doesn't have a public key
        // but the user has been notified, so don't complain
     }
     autocomplete_counter++;
  }

  // Set the new encpass
  all_recipients = JSON.stringify(all_recipients);
  document.getElementById(encpass).value = all_recipients;
}

function validate_recipients (searchout, encpass) {
  console.log('in validate_recipients');
  console.log(searchout);
  console.log(encpass);
" (srex-enc-autocomplete-prologue env) "
  while (autocomplete_counter < autocomplete.length) {
     var toadd = autocomplete[autocomplete_counter];
     var enc_contact_pubkey = toadd['pubkey'];
     console.log('enc_contact_pubkey is ' + enc_contact_pubkey);
     var userid = toadd['id'];
     if (enc_contact_pubkey != null && enc_contact_pubkey != false) {
       var contact_pubkey = decrypt_nonsearchable('enc_contact_pubkey', enc_contact_pubkey, privkey_openpgp);
       if (contact_pubkey == false) {
          // For whatever reason, the public key for this contact could not be decrypted
          error_messages.push(\"Can't encrypt for user \" + userid + \" because the public key for them could not be decrypted.\");
          error_messages.push(\"NONE OF THE DATA WILL BE ENCRYPTED.\");
          all_recipients[toadd['id']] = { 'pubkey': null };
       }
     } else {
       // this contact can't be encrypted
       error_messages.push(\"Can't encrypt for user \" + userid + \" because they don't support encryption.\");
       error_messages.push(\"NONE OF THE DATA WILL BE ENCRYPTED.\");
       all_recipients[toadd['id']] = { 'pubkey': null };
     }
     autocomplete_counter++;
  }

  // Set the new encpass
  all_recipients = JSON.stringify(all_recipients);
  document.getElementById(encpass).value = all_recipients;

  alert_errors();
}

function jq_autocomplete_tokeninput_encrypted (url, encfields, encpass, searchin, searchout, toretrievekeys) {
  var data = {};
  data['onSearch'] = function (inputquery) {
    var ret = 0;
    console.log('----> onSearch');
    ret = encrypt_toretrieve(inputquery, searchsalt, searchpass, searchiv, searchmperc, toretrievekeys);
    console.log('will return: ');
    console.log(ret);
    return ret;
  };
  data['prePopulate'] = JSON.parse(document.getElementById(searchout).value);
  data['onResult'] = function (initial_query, results) {
    console.log('----> onResult');
    console.log(results);
    var counter = 0;
    var l = 0;
    console.log('before l');
    console.log(results);
    if (results != null)
       l = srex_length(results);
    console.log('got len: ' + l);
    
    while (counter < l) { 
      console.log('processing ' + counter);
      var thisres = 0;
      thisres = srex_get_wtype(results, counter);
      console.log('BEFORE thisres is: ');
      console.log(thisres);
      var encfield_counter = 0;

      while (encfield_counter < encfields.length) {
        var contact_enc = 0;
        var contact_dec = 0;

        console.log('processing encfield_counter: ' + encfield_counter + ' for field: ' + encfields[encfield_counter]);

        contact_enc = srex_get_wtype(thisres, encfields[encfield_counter]);
        console.log('got contact');
        console.log(contact_enc);
        contact_dec = decrypt_fromsearch(contact_enc, searchsalt, searchpass, searchiv, searchmperc);
        console.log('got decrypted ' + encfields[encfield_counter] + ': ' + contact_dec);
        thisres[encfields[encfield_counter]] = contact_dec;
        encfield_counter++;
      }

      console.log('AFTER thisres is: ');
      console.log(thisres);
      counter += 1;
    }

    if (l == 0) { // there was no match; use the initial_query
        // if the last character in the initial_query is a space, add this entry
        if (initial_query.substring(initial_query.length-1, initial_query.length) == ' ') {
           var toadd = initial_query.substring(0, initial_query.length-1);
           $( searchin ).tokenInput('add', {id: null, name: toadd});
        }
     }

    console.log('end of onResult');
    return results;
  };
  data['propertyToSearch'] = 'name';
  data['theme'] = 'facebook';
  data['onAdd'] = function (item) {
    console.log('----> onAdd');
    var existing = srex_get(searchout, 1);
    console.log('existing was');
    console.log(existing);
    
    if (existing == '') {
      existing = [];
    } else {
      existing = JSON.parse(existing);
    }

    var safe_item = tokeninput_encrypted_getsafe(item, encfields);
    existing.push( safe_item );
    existing = JSON.stringify(existing);
    srex_set(searchout, 1, existing);
    console.log('onAdd existing is now');
    console.log(existing);
    validate_recipients(searchout, encpass);
  };
  data['onDelete'] = function (item) {
    console.log('----> onDelete');
    var existing = srex_get(searchout, 1);
    console.log('existing was');
    console.log(existing);

    console.log('deleted: ');
    console.log(item);
    if (existing == '') {
      existing = [];
    } else {
      existing = JSON.parse(existing);
    }

    var safe_item = tokeninput_encrypted_getsafe(item, encfields);

    // iterate over existing fields and remove the one that is deleted
    var new_existing = [];
    var existingcounter = 0;
    while (existingcounter < existing.length) {
       var todelete = existing[existingcounter];
       if (deepCompare(safe_item, todelete) == false)
         new_existing.push(todelete);
       existingcounter++;
    }

    new_existing = JSON.stringify(new_existing);
    srex_set(searchout, 1, new_existing);
    console.log('onDelete existing is now');
    console.log(new_existing);
    validate_recipients(searchout, encpass);
  };
  $( searchin ).tokenInput ( url, data );
}

"))

		     (if (env!srex-used "srex-cookies-get")
			 "function srex_cookies_get () {
  var pairs = document.cookie.split(\";\");
  var cookies = {};
  for (var i=0; i<pairs.length; i++){
    var pair = pairs[i].split(\"=\");
    cookies[pair[0]] = unescape(pair[1]);
  }
  return cookies;
}

")
		     (if (env!srex-used "srex-cookie-del")
			 (do (= (env!srex-used "srex-cookie-set") t)
			     "function srex_cookie_del (name) {
  srex_cookie_set(name, \"\", -1);
}

"))
		     (if (env!srex-used "srex-cookie-set")
			 "function srex_cookie_set (name, value, days) {
  if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = \"; expires=\"+date.toGMTString();
    }
  else var expires = \"\";
  document.cookie = name+\"=\"+value+expires+\"; path=/\";
}

")
		     (if (env!srex-used "srex-location-set")
			 "function srex_location_set (param, value) {
  location[param] = value;
}

")
		     ))

	 out))

(def srex-processing-contacts (env)
  (withs (ret nil)
	 (if env!formbuttons
	     (each item env!formbuttons
		   (if item!contact-list
		       (= ret t))))
	 ret))

(def srex-submit (env)
  (withs (out "")
	 (if env!formbuttons
	     (each item env!formbuttons
		   (withs (form item!form btn item!btn entersubmits item!entersubmits)
			  (= out (str out "document.getElementById('" btn "').onclick = "
				      (if (srex-processing-contacts env)
					  "verify"
					  "encrypt")
				      "_before_submit_" (srex-valid-js btn) ";
document.getElementById('" btn "').href = \"#\";
"))
			  ;;force all input (not textarea) fields to submit on enter
			  (each elementtype (list "input")
				(= out (str out "// Force every " elementtype " of form " form " to encrypt data if we press Enter
var " elementtype "List = document.forms['" form "'].getElementsByTagName('input');
for (var i=0; i < " elementtype "List.length; i++) {
  " elementtype "List[i].onkeypress = function (e) {
    if(event.keyCode == 13) {
      event.preventDefault();
      " (if entersubmits
	    (str(if (srex-processing-contacts env)
		"verify"
		"encrypt")
  "_before_submit_" (srex-valid-js btn) "();")) "
      return false;
    }
  };
}
")))			  
			  )))
	 out))

(def srex-contact-delete (env contact)
  (withs (out "")
	 (= out (str out "
  {
     var userid = document.getElementById('" contact!id "')." (srex-accesstype contact!istextarea) ";
     var keyid_counter = 0;
     var keyid_total = Object.keys(verifiedkeyids).length;
     while (keyid_counter < keyid_total) {
       var this_keyid = Object.keys(verifiedkeyids)[keyid_counter];
       var this_userid = verifiedkeyids[this_keyid];
       if (userid == this_userid) {
          delete verifiedkeyids[this_keyid];
       }
       keyid_counter++;
     }
     document.getElementById('" contact!deletedid "').value = 'yes';
  }

"))
	 out))

(def srex-accesstype (istextarea)
  (if istextarea "value" "innerText")) ;; textboxes have a value
      
(def srex-dec-core (fromwebserver encprivkey encencpass marktype dec-itemlist srex-aftdec srex-aftdec-all)
  (if dec-itemlist
      (withs (ret "")
	     (= ret (str "
// ----------------------------------- Decrypt data in the browser to view them

" (if (or (is marktype "markdown")
	  (is marktype "markdown-pretty"))
      "var markdownConverter = new Showdown.converter();
"
      (is marktype "to-html")
      "function to_html (theString) {
  return theString;
}
")
   (if (is marktype "markdown-pretty")
       "
function prettypar(theString) {
  var out = '';
  var pars = theString.split(\"\\n\");
  var length_pars = pars.length;
  var counter = 0;

  while (counter < length_pars) {
    var par = pars[counter];
    var length_par = par.length;    
    var sents = par.split('.');
    var length_sents = sents.length;
    var first = null;
    var length_first = 0;

    if (length_sents > 0) {
        first = sents[0];
        length_first = first.length;
    }
    if (first != null) {
       out = out + '<font color=#993333>' + first + '</font>';
       if (length_par > length_first) {
          out = out + '.';
       }
       out = out + par.substring(length_first + 1, length_par);
    }

    counter++;
  }

  return out;
}
")))

	     (each item dec-itemlist
		   (withs (encpass item!encpass
			   id item!id
			   istextarea item!istextarea
			   only-restsent item!only-restsent
			   newcolor item!newcolor
			   aftdec (srex-aftdec id)
			   fromsearch item!fromsearch ;; decrypt search results
			   fromsearchin item!fromsearchin ;; holds encrypted output of search query
			   fromsearchtextarea item!fromsearchtextarea)
			  (if fromsearch
			      ;; decrypt encrypted search results
			      (do ;; if there is no fromsearchin field, fall back to using the id
				  (if (no fromsearchin)
				      (do (= fromsearchin id)
					  (= fromsearchtextarea istextarea)))
				  ;; fixme: if fromsearchin isn't accessed
				  ;; with .value, things break. so fromsearchin
				  ;; must always be a hidden field
				  (= ret (str ret "
// Decrypt the encrypted search results
var enc" id " = document.getElementById('" fromsearchin "')." (srex-accesstype fromsearchtextarea) ";
var dec" id " = '';
if (enc" id " != '') {
  var enc" id "_parsed = JSON.parse( enc" id " );
  dec" id " = decrypt_fromsearch(enc" id "_parsed, searchsalt, searchpass, searchiv, searchmperc);
"
  ;; after decryption finished, set the value
  (srex-dec-core-after id istextarea only-restsent aftdec marktype "  ")
"}
")))
			      ;; else -- decrypt normally
			      (do (= ret (str ret "
// Decrypt " id "
var enc" id " = srex_get('" id "', " (if istextarea "1" "0") ");
var dec" id " = decrypt_nonsearchable('" id "', enc" id ", privkey_openpgp);
"))
				  ;; after decryption finished, set the value
				  (= ret (str ret (srex-dec-core-after id istextarea only-restsent aftdec marktype "")))
				  (= ret (str ret "
" (if newcolor
      (str "document.getElementById('" id "').style.color = '" (hexrep newcolor) "';")) "
"))
))
			  ))

  ;; all decryption finished
 (= ret (str ret (aif srex-aftdec-all (str "// Server-supplied code for srex-after-decrypt-all
" it))))

	     ret)))

;; after decryption finished, set the value
(def srex-dec-core-after (id istextarea only-restsent aftdec marktype prefix)
  (withs (ret "")
	 (= ret (str ret prefix "document.getElementById('" id "')." (srex-accesstype istextarea) " = dec" id ";
"))
	 (if aftdec
	     (= ret (str ret "// Server-supplied code for srex-after-decrypt
" aftdec "
")))
	 (if (is marktype "markdown")
	     (= ret (str ret "
" prefix "document.getElementById('" id "').innerHTML = markdownConverter.makeHtml( document.getElementById('" id "')." (srex-accesstype istextarea) " );"))
	     (and (is marktype "markdown-pretty") only-restsent)
	     (= ret (str ret "
" prefix "document.getElementById('" id "').innerHTML = prettypar( markdownConverter.makeHtml( document.getElementById('" id "')." (srex-accesstype istextarea) " ) );"))
	     (is marktype "to-html")
	     (= ret (str ret "
" prefix "document.getElementById('" id "').innerHTML = to_html ( document.getElementById('" id "')." (srex-accesstype istextarea) " );
")))
	 (if (is id "subject")
	     (= ret (str ret "
" prefix "document.title = dec" id ";")))
	 (= ret (str ret "
"))
	 ret))

(def srex-process-aftdec-all (env)
  (withs (out "")
	 (aif env!srex-aftdec-all (= out it))
	 out))

(def srex-verify-contacts (verify-list)
  (withs (out "")
	 (if verify-list
	     (do (= out (str out "// Verify contacts
"))
		 (each ver verify-list
		       ;; id istextarea showin kind
		       (= out (str out "{
  var verified = 0;
  var userid = document.getElementById('" ver!id "')." (srex-accesstype ver!istextarea) ";
  var our_keyid = pubkey_openpgp.getKeyIds()[0].toHex();
  var keyid_counter = 0;
  var keyid_total = Object.keys(verifiedkeyids).length;
  while (keyid_counter < keyid_total) {
    var this_keyid = Object.keys(verifiedkeyids)[keyid_counter];
    var this_userid = verifiedkeyids[this_keyid];
    if (this_keyid == our_keyid)
       verified = 1;
    if (userid == this_userid)
       verified = 1;
    keyid_counter++;
  }

  var targetdiv = document.getElementById('" ver!showin "');
"))
		       (= out (str out (if (is ver!kind "word")
					   (str "  var div = document.createElement('div');
  div.id = '" ver!showin "_after_verification';
  div.style.textAlign = 'left';
  div.style.font = '13px Verdana';
  div.style.color = 'white';
  if (verified) {
     div.innerHTML = 'VERIFIED';
     div.style.width = '62px';
     div.style.padding = '7px';
     div.style.backgroundColor = 'green';
  } else {
     div.innerHTML = 'NOT verified';
     div.style.width = '85px';
     div.style.padding = '7px';
     div.style.backgroundColor = 'red';
  }
  targetdiv.appendChild(div);
")
					   (is ver!kind "color")
					   (str "if (verified) {
  targetdiv.backgroundColor = 'green';
} else {
  targetdiv.backgroundColor = 'red';
}"))))
		       (= out (str out "
}"
))
		       )
	       ))
	 out))

;; a field holds decrypted data if (a) it was defined in the
;; decryption list, or (b) is a variable that uses a decrypted data
(def srex-is-decrypted-data (env field)
  (withs (ret nil usedfield (srex-rm-dquotes field))
	 ;;(prn "in srex-is-decrypted-data: " field)
	 (each item env!dec-itemlist
	       (withs (id item!id)
		      (if (is id usedfield)
			  (= ret t))))
	 (if (env!vars-using-dec usedfield)
	     (= ret t))
	 ;;(prn "out of srex-is-decrypted-data: " ret)
	 ret))

;; a field holds data that will be encrypted if (a) it was defined in
;; the encryption list, or (b) is a variable that uses data that will
;; be encrypted
(def srex-is-encrypted-data (env field (o b-too t))
  (withs (ret nil usedfield (srex-rm-dquotes field))
	 ;;(prn "in srex-is-encrypted-data: " field)
	 (each item env!enc-itemlist
	       (withs (id item!id)
		      (if (is id usedfield)
			  (= ret t))))
	 (if b-too
	     (if (env!vars-using-enc usedfield)
		 (= ret t)))
	 ;;(prn "out of srex-is-encrypted-data: " ret)
	 ret))

(def srex-rm-dquotes (f)
  (subst "" "\"" f))

(def srex-is-form-data (env field)
  ;;(prn "in srex-is-form-data: " field " in " env!form-inputs)
  ;; The field passed in could be in double quotes
  (withs (ret nil usedfield (subst "" "\"" field))
	 (each item env!form-inputs
	       (if (is item usedfield)
		   (= ret t)))
	 ;;(prn "out of srex-is-form-data: " (str ret))
	 ret))

;; ----- code verification start ---------------------------------------------

;; Protect from two types of attempts to steal decrypted data:
;; (1) setting a field that won't be encrypted with the value of a
;;     field that was decrypted
;;
;; (2) setting a field that won't be encrypted with the value of a
;;     temporary variable, while this variable was first set to the
;;     value of a field that was decrypted. Also check this
;;     recursively across several temporary variables

(def srex-vars-newcount(env)
  (+ (len env!vars-using-dec)
     (len env!fns-using-dec)
     (len env!vars-using-enc)
     (len env!fns-using-enc)))

(def srex-codewalk (env)
  (withs (out "")
	 (if env!code
	     (do
	       ;; Ideally, we want to first perform control-flow
	       ;; analysis to identify which variables end up using
	       ;; decrypted data, and then walk over all code and
	       ;; produce safe Javascript for it. In practice, we
	       ;; cheat: we continually try to generate Javascript,
	       ;; until there is no change in the number of new
	       ;; variables discovered that use decrypted data.

	       ;; This should be bad at runtime and good at makertime.
	       (withs (lastcount -1)
		      (while (no (is lastcount (srex-vars-newcount env)))
			     (= lastcount (srex-vars-newcount env))
			     (= env!uses-dec nil)
			     (= env!uses-enc nil)
			     (= env!srex-aftdec (table)) ;; because they hold lists
			     (= env!srex-befenc (table))
			     (= out (verify-go env))
			     ))
	       ))
	 (prn "// ======= form-inputs: " env!form-inputs)
	 (prn "// ======= variables using decrypted data: " env!vars-using-dec)
	 (maptable (fn (k v)
		       (prn "// v: " k)) env!vars-using-dec)
	 (prn "// ======= functions using decrypted data: " env!fns-using-dec)
	 (maptable (fn (k v)
		       (prn "// f: " k)) env!fns-using-dec)
	 (prn "// ======= variables using encrypted data: " env!vars-using-enc)
	 (maptable (fn (k v)
		       (prn "// v: " k)) env!vars-using-enc)
	 (prn "// ======= functions using encrypted data: " env!fns-using-enc)
	 (maptable (fn (k v)
		       (prn "// f: " k)) env!fns-using-enc)
	 (prn "// ======= srex functions used: " env!srex-used)
	 (maptable (fn (k v)
		       (prn "// f: " k)) env!srex-used)
	 out))

(= srex-hack-attempt-msg "THERE WAS AN ATTEMPT TO HACK YOU, but it was NOT successful.")

(mac outpend s
     `(do (repeat (* depth 2) (= out (str out " ")))
	  (= out (str out ,@s))))

(= srex-uniq-counter* 0)
(def srex-uniq () ; This gives us repeatable testcases, and valid Javascript var names
  (++ srex-uniq-counter*)
  (str "gs" srex-uniq-counter*))

(def verify-go (env)
  (withs (out nil depth 0 newparams nil	  
	  ;; (read) only reads the first element, so read everything
	  ;; in one big do
	  data (read (str "(do " env!code ")"))) ;; what separates Lisp: treating code as data
	 ;;(prn "in verify-go: " data)
	 (if (is (type data) 'cons)
	     (if (is (str (data 0)) "do")
		 (= out (str out (verify-do env data newparams depth)))
;; 		 (is (str (data 0)) "withs")
;; 		 (= out (str out (verify-withs env data newparams depth)))
		 ))
	 out))

(def verify-do (env data oldparams depth)
  ;;(prn "in verify-do: " data)
  (withs (out "" dobody nil counter 0)
	 (each d data
	       (if (> counter 0)
		   (push d dobody))
	       (++ counter))
	 (each d (rev dobody)
	       (outpend (verify-exp env d oldparams depth) ";" #\newline))
	 ;;(prn "out of verify-do: " out)
	 out))

(def srex-before-encrypt-hook (env data depth)
  (withs (out "" var (data 1) stmt nil)
	 (= stmt (verify-exp env (data 2) nil 0))
	 ;; there could be many hooks for a variable
	 (push (str stmt ";") (env!srex-befenc var))
	 ;;(prn env!srex-befenc)
	 out))

(def srex-before-encrypt-all-hook (env data depth)
  (withs (out "" stmt nil)
	 (= stmt (verify-exp env (data 1) nil 0))
	 (= env!srex-befenc-all (str stmt ";"))
	 ;;(prn env!srex-befenc-all)
	 out))

(def srex-after-decrypt-hook (env data depth)
  (withs (out "" var (data 1) stmt nil)
	 (= stmt (verify-exp env (data 2) nil 0))
	 ;; there could be many hooks for a variable
	 (push (str stmt ";") (env!srex-aftdec var))
	 ;;(prn env!srex-aftdec)
	 out))

(def srex-after-decrypt-all-hook (env data depth)
  (withs (out "" stmt nil)
	 (= stmt (verify-exp env (data 1) nil 0))
	 (= env!srex-aftdec-all (str stmt ";"))
	 ;;(prn "SREX-AFTDEC-ALL: " env!srex-aftdec-all)
	 out))

;; Javascript function and variable names can't have dashes
(def srex-valid-js (v)
  (subst "_" "-" v))

(def verify-def-body (env data oldparams depth fnname)
  ;;(prn "in verify-def-body " data)
  (withs (counter 0 out "" newparams nil)
	 (each i data
	       (if (is counter 0)
		   (= out (str out "function " (if (no (is fnname "")) fnname)))
		   (is counter 1)
		   (withs (paramcnt 0) ;; we will process function parameters
			  (= out (str out "("))
			  (each param i
				(if (> paramcnt 0)
				    (= out (str out ", ")))
				(= out (str out param))
				(push (str param) newparams)
				(++ paramcnt))
			  (= out (str out ") {")))
		   ;; what we will process isn't function parameters
		   (= out (str out #\newline (verify-exp env i (+ oldparams newparams) (+ depth 1)) ";")))
	       (++ counter))
	 (= out (str out #\newline))
	 (outpend "}")
	 ;;(prn "out from verify-def-body")
	 out))

;; no global variables are supported for now (no oldparams passed in verify-def)
(def verify-def (env data oldparams depth)
  ;;(prn "in verify-def: " (data 1) " with uses-dec: " env!uses-dec)
  ;;(prn "in verify-def: " data)
  (withs (out "" fnname nil dataleft nil newfnname nil
	  old-uses-dec nil old-uses-enc nil)
	 (= dataleft data)
	 (pop dataleft) ; pop def
	 (= fnname (car dataleft)) ; pop fnname
	 (if (no (env!fns fnname))
	     (do (= newfnname (str fnname "_" (srex-uniq)))
		 (= newfnname (srex-valid-js newfnname))
		 (= (env!fns fnname) newfnname))
	     (= newfnname (env!fns fnname)))
	 (= old-uses-dec env!uses-dec) ; save
	 (= old-uses-enc env!uses-enc) ; save
	 (= env!uses-dec nil)
	 (= env!uses-enc nil)
	 (= out (str out (verify-def-body env dataleft oldparams depth newfnname)))
	 (if env!uses-dec
	     (do ;;(prn "added " fnname)
		 (= (env!fns-using-dec fnname) t)))
	 (if env!uses-enc
	     (do ;;(prn "added " fnname)
		 (= (env!fns-using-enc fnname) t)))
	 (= env!uses-enc old-uses-enc) ; restore
	 (= env!uses-dec old-uses-dec) ; restore
	 ;;(prn env!fns)
	 ;;(prn "out of verify-def: " out)
	 out))

(def verify-withs (env data oldparams depth)
  ;;(prn "in verify-withs " data)
  (withs (out "" foundwiths nil foundwithsparams nil invar t lastvar nil
	  newparams oldparams pcnt 0)
	 (each i data
;;  	       (prn "type: " (type i))
;;  	       (prn "data: " (str i))
	       (if (no foundwiths)
		   (= foundwiths t)
		   (if (is (type i) 'cons)
		       (if (no foundwithsparams) ;; process the with params
			   (do (= foundwithsparams t)
			       (each p i
				     (++ pcnt)
				     ;;(prn "p is: " p)
				     (if invar ;; processing the 1st, 3rd, 5th, ... element
					 (withs (newvarname (verify-sym env (str p)
									(+ oldparams newparams (list (str p)))))
						(if (> pcnt 1)
						    (= out (str out #\newline)))
						(outpend (str "var " newvarname " = "))
						(= lastvar newvarname)
						(= invar nil)
						;;(push (str newvarname) newparams)
						(push (str p) newparams))
					 (no invar) ;; processing the even element
					 (do (= out (str out (verify-exp env p (+ oldparams newparams) 0) ";"))
					     (if env!uses-dec
						 (= (env!vars-using-dec lastvar) t))
					     (if env!uses-enc
						 (do ;;(prn (str "WILL ADD to vars-usinc-enc: " lastvar))
						     (= (env!vars-using-enc lastvar) t)))
					     (= invar t))
					 ))
			       ;;(outpend "" #\newline)
			       )
			   foundwithsparams ;; process the body of the with
			   (= out (str out #\newline (verify-exp env i (+ oldparams newparams) depth) ";"))
			   )
		       (atom i) ;; not a cons
		       (do (= out (str out #\newline))
			   (outpend (str (verify-exp env i (+ oldparams newparams) depth) ";")))
		       ))
	       )
	 ;;(outpend "" #\newline)
	 ;;(prn "out of verify-withs")
	 out))

(def verify-while (env data oldparams depth)
  (withs (out "" counter 0)
	 (outpend #\newline)
	 (outpend "")
	 (each i data
	       (if (is counter 0)
		   (= out (str out "while ("))
		   (is counter 1)
		   (do (= out (str out (verify-exp env i oldparams depth)))
		       (= out (str out ") { " #\newline)))
		   (= out (str out (verify-exp env i oldparams (+ depth 1)) ";" #\newline)))
	       (++ counter))
	 (outpend "}")
	 out))

; verify an expression using a blank env!uses-dec, and do not
; propagate the value of env!uses-dec further up when done, because
; it's not an assignment
(mac w/udec (env . body)
     (w/uniq oud
	     `(withs (,oud (,env 'uses-dec))
		     (= (,env 'uses-dec) nil)
		     ,@body
		     (= (,env 'uses-dec) ,oud))))
(def verify-exp (env data oldparams depth)
  (withs (out "")
	 ;;(prn "in verify-exp: " data)
	 (if (is (type data) 'cons)
	     (do ;;(prn "in verify-exp: (data 0) " (data 0))
		 (if (is (str (data 0)) "srex-before-encrypt")
		     (= out (str out (srex-before-encrypt-hook env data depth)))
		     (is (str (data 0)) "srex-before-encrypt-all")
		     (= out (str out (srex-before-encrypt-all-hook env data depth)))
		     (is (str (data 0)) "srex-after-decrypt")
		     (= out (str out (srex-after-decrypt-hook env data depth)))
		     (is (str (data 0)) "srex-after-decrypt-all")
		     (= out (str out (srex-after-decrypt-all-hook env data depth)))
		     (or (is (str (data 0)) "eval")
			 (is (str (data 0)) "setTimeout")
			 (is (str (data 0)) "setInterval"))
		     (= env!srex-hack-attempt t)
		     (is (str (data 0)) "new")
		     (= out (str out (verify-new env data oldparams depth)))
		     (is (str (data 0)) "return")
		     (= out (str out (verify-return env data oldparams depth)))
		     (is (str (data 0)) "def")
		     (= out (str out (verify-def env data oldparams depth)))
		     (is (str (data 0)) "withs")
		     (= out (str out (verify-withs env data oldparams depth)))
		     (is (str (data 0)) "do")
		     (= out (str out (verify-do env data oldparams depth)))
		     (is (str (data 0)) "while")
		     (= out (str out (verify-while env data oldparams depth)))
		     (is (str (data 0)) "each")
		     (= out (str out (verify-each env data oldparams depth)))
		     (is (str (data 0)) "maptable")
		     (= out (str out (verify-maptable env data oldparams depth)))
		     (is (str (data 0)) "=")
		     (= out (str out (verify-assign env data oldparams depth)))
		     (is (str (data 0)) "+")
		     (= out (str out (verify-addsub env data oldparams depth "+")))
		     (is (str (data 0)) "-")
		     (= out (str out (verify-addsub env data oldparams depth "-")))
		     (is (str (data 0)) "++")
		     (outpend (data 1) " += 1")
		     (is (str (data 0)) "--")
		     (outpend (data 1) " -= 1")
		     (is (str (data 0)) "*")
		     (= out (str out (verify-addsub env data oldparams depth "*")))
		     (is (str (data 0)) "/")
		     (= out (str out (verify-addsub env data oldparams depth "/")))
		     (is (str (data 0)) "if")
		     (= out (str out (verify-if env data oldparams depth)))
		     (or (is (str (data 0)) "and")
			 (is (str (data 0)) "or"))
		     (= out (str out (verify-andor env data oldparams depth)))
		     (is (str (data 0)) "no")
		     (= out (str out "(" (verify-exp env (data 1) oldparams depth) ") == false"))
		     (is (str (data 0)) "is")
		     (do (= out (str out (verify-exp env (data 1) oldparams depth)))
			 (= out (str out " == "))
			 (= out (str out (verify-exp env (data 2) oldparams depth))))
		     (or (is (str (data 0)) "<")
			 (is (str (data 0)) "<=")
			 (is (str (data 0)) ">")
			 (is (str (data 0)) ">="))
		     (= out (str out (data 1) " " (data 0) " " (data 2)))
		     (or (is (str (data 0)) "string")
			 (is (str (data 0)) "str"))
		     (= out (str out (verify-str env data oldparams depth)))
		     (is (str (data 0)) "len")
		     (do (= (env!srex-used "srex-length") t)
			 (= out (str out "srex_length(" (data 1) ")")))
		     (is (str (data 0)) "table") ;; hashtable in Arc
		     (= out (str out "{}"))
		     (is (str (data 0)) "list")  ;; list/array in Arc
		     (outpend (verify-list env data oldparams 0))
		     (is (str (data 0)) "obj")   ;; obj in Arc
		     (outpend (verify-obj env data oldparams 0))
		     (is (str (data 0)) "push")  ;; add to a list in Arc
		     (= out (str out (verify-push env data oldparams depth)))
		     (is (str (data 0)) "pop")   ;; remove from a list in Arc
		     (= out (str out (verify-pop env data oldparams depth)))
		     (is (str (data 0)) "tojson")
		     (do (= out (str out "JSON.stringify("))
			 (= out (str out (verify-exp env (data 1) oldparams depth)))
			 (= out (str out ")")))
		     (is (str (data 0)) "fromjson")
		     (do (= out (str out "JSON.parse("))
			 (= out (str out (verify-exp env (data 1) oldparams depth)))
			 (= out (str out ")")))
 		     (find (str (data 0)) oldparams)
 		     (outpend (verify-var env data oldparams 0)) ;; calling a property of a variable
		     (is (str (data 0)) "fn") ;; a function object
		     (= out (str out (verify-def-body env data oldparams (+ depth 1) "")))
		     ;; it's an ordinary function call
		     (outpend (verify-apply env data oldparams 0))
		     ))
	     (is (type data) 'char)
	     (if (is (coerce data 'int) 10) ;; #\newline
		 (= out (str "'\\n'"))
		 (is (coerce data 'int) 13) ;; #\return
		 (= out (str "'\\r'"))
		 (= out (str "'" (str data) "'")))
	     (is (type data) 'int)
	     (= out (str out data))
	     (is (type data) 'sym)
	     (= out (str out (verify-sym env data oldparams)))
	     (is (type data) 'string)
	     (do (if (srex-is-decrypted-data env (str data))
		     (= env!uses-dec t))
		 (= out (str out (str "\"" (str data) "\""))))
	     )
	 ;;(prn "out of verify-exp with: " out)
	 out))

(def verify-addsub (env data oldparams depth sign)
  (withs (out "" counter 0)
	 (= out (str out (verify-exp env (data 1) oldparams depth)))
	 (each d data
	       (if (>= counter 2)
		   (do (= out (str out " " sign " "))
		       (= out (str out (verify-exp env d oldparams depth)))))
	       (++ counter))
	 out))

(def verify-list (env data oldparams depth)
  ;;(prn "in verify-list: " data)
  (withs (out "" counter 0)
	 (outpend "[")
	 (each d data
	       (if (> counter 1)
		   (= out (str out ",")))
	       (if (> counter 0)
		   (= out (str out (verify-exp env d oldparams depth))))
	       (++ counter))
	 (= out (str out "]"))
	 ;;(prn "out of verify-list with: " out)
	 out))

(def verify-obj (env data oldparams depth)
  (withs (out "" counter 0)
	 (outpend "{")
	 (each d data
	       (if (> counter 1)
		   (if (is (mod counter 2) 1)
		       (= out (str out ", "))
		       (= out (str out ":"))))
	       (if (> counter 0)
		   (= out (str out (verify-exp env d oldparams depth))))
	       (++ counter))
	 (= out (str out "}"))
	 out))

(def verify-push (env data oldparams depth)
  ;;(prn "in verify-push: " data)
  (withs (out "" counter 0)
	 (if (is (len data) 3)
	     (outpend (str (data 2) ".push(" (verify-exp env (data 1) oldparams depth) ")"))
	     (outpend "null"))
	 ;;(prn "out of verify-push with: " out)
	 out))

(def verify-pop (env data oldparams depth)
  ;;(prn "in verify-pop: " data)
  (withs (out "" counter 0)
	 (if (is (len data) 2)
	     (= out (str out (data 1) ".splice(0,1)"))
	     (= out (str out "null")))
	 ;;(prn "out of verify-pop with: " out)
	 out))

(def verify-var (env data oldparams depth)
  ;;(prn "in verify-var: " data)
  (withs (out "" counter 0 varparams nil)
	 (if (> (len data) 1)
	     (do (each d data
		       ;;(prn "d: '" d "'")
		       (if (>= counter 2)
			   (push d varparams))
		       (++ counter))
		 ;;(= out (str out (data 0) "." (verify-exp (rev varparams) oldparams depth)))
		 (if (is (type (data 1)) 'string) ;; this is a hardcoded string
		     (= out (str out "srex_get_wtype(" (data 0) ", \"" (srex-clean-item (str (data 1))) "\""))
		     (find (str (data 1)) oldparams)
		     ;; this is a variable
		     (= out (str out "srex_get_wtype(" (data 0) ", " (data 1)))
		     ;; this could be a number
		     (= out (str out "srex_get_wtype(" (data 0) ", " (data 1))))
		 ;; either way, srex-get-wtype is used here
		 (= (env!srex-used "srex-get-wtype") t)
		 ;;(prn "will process varparms: " varparams)
		 (withs (varcounter 0)
			;; if we are calling something like: (srex-get-wtype console log "test")
			;; we should allow access to the second var ("log")
			;; but not necessarily the first ("console"); except
			;; the case of specifically the first variable "console".
			(each p (rev varparams)
			      (withs (paramstouse oldparams)
				     (if (> varcounter 0)
					 (push p paramstouse))
				     (= out (str out ", " (verify-exp env p paramstouse depth))))
			      (++ varcounter)))
		 (= out (str out ")"))
		 ;;(= out (str out (data 0) "[" (data 1) "]"))
		 )
	     (= out (str out data)))
	 ;;(prn "out of verify-var: " out)
	 out))

(def verify-new (env data oldparams depth)
  ;;(prn "in verify-new: " data)
  (withs (out "" name (data 1))
	 (if (is name "Function") ; not allowed by Chrome extension
	     (= env!srex-hack-attempt t)
	     (withs (counter 0 fnbody nil) ;; unpack into a function call
		    (each d data
			  (if (> counter 0)
			      (push d fnbody))
			  (++ counter))
		    (= out (str out "new " (verify-apply env (rev fnbody) oldparams 0)))))
	 ;;(prn "out from verify-new: " out)
	 out))

(def verify-return (env data oldparams depth)
  (withs (out "" counter 0 retbody nil)
	 (each d data
	       (if (> counter 0)
		   (push d retbody))
	       (++ counter))
	 (if (is (len retbody) 1)
	     (outpend "return " (verify-exp env (retbody 0) oldparams 0)) ;; to avoid interpreting as a function call
	     (outpend "return " (verify-exp env (rev retbody) oldparams 0)))
	 out))

(def verify-sym (env data oldparams)
  ;;(prn "in verify-sym with: " data " of type " (type data))
  (withs (out "")
	 (if (is (str data) "t")
	     (= out "1")
	     (and (no data)
		  (is (str data) "")) ; nil
	     ;;(= out "0")
	     (= out "false") ;; equal to 0, plus doesn't break when setting browser navigation to false
	     ;; Javascript variable names can't have dashes
	     (= out (srex-valid-js (str data))))
	 (if (srex-is-decrypted-data env out)
	     (= env!uses-dec t))
;; 	 (prn "verify-sym - oldparams: " oldparams)
;; 	 (prn "verify-sym - data: " data)
;; 	 (prn "verify-sym - not a declared var: " (no (find (str data) oldparams)))
;; 	 (prn "verify-sym - not t: " (no (and (is (type data) 'sym) (is (str data) "t"))))
	 (if (and data ; not nil
		  (no (find (str data) oldparams)) ; not a declared var
		  (no (and (is (type data) 'sym) (is (str data) "t")))) ; not t
	     (do ;; Don't allow direct access to the DOM or global
	         ;; framework variables
	         ;; (prn "HACK ATTEMPT --- sym: " (str data))
		 (= env!srex-hack-attempt t)))
	 ;;(prn "out of verify-sym: " out)
	 out))

(def verify-assign (env data oldparams depth)
  ;;(prn "in verify-assign")
  (withs (out "" lhs nil rhs nil
	  old-uses-dec nil lhs-uses-dec nil rhs-uses-dec nil
	  old-uses-enc nil lhs-uses-enc nil rhs-uses-enc nil)
	 ;; save any previous information about accessing decrypted data
	 (= old-uses-dec env!uses-dec)
	 (= env!uses-dec nil)
	 (= old-uses-enc env!uses-enc)
	 (= env!uses-enc nil)

	 ;; check the lhs
	 (if (is (type (data 1)) 'cons) ;; assigning a hashtable
	     (= lhs (str ((data 1) 0) "[\"" ((data 1) 1) "\"]"))
	     (= lhs (verify-sym env (data 1) oldparams)))
	 (= lhs-uses-dec env!uses-dec)
	 (= env!uses-dec nil)
	 (= lhs-uses-enc env!uses-enc)
	 (= env!uses-enc nil)

	 ;; check the rhs
	 (= rhs (verify-exp env (data 2) oldparams 0))
	 (= rhs-uses-dec env!uses-dec)
	 (= rhs-uses-enc env!uses-enc)
	 (if (and (no (is (type (data 2)) "cons"))
		  (env!vars-using-dec (data 2)))
	     (do ;;(prn "detected that " (data 2) " was using decrypted data")
		 (= rhs-uses-dec t)))

	 (if (and (no (is (type (data 2)) "cons"))
		  (env!vars-using-enc (data 2)))
	     (do ;;(prn "detected that " (data 2) " was using encrypted data")
		 (= rhs-uses-enc t)))
	     
	 (= env!uses-dec nil)
	 (= env!uses-enc nil)

	 ;; check if the rhs used a decrypted field
	 (if rhs-uses-dec
	     ;; This is conservative, because variables with the same
	     ;; name in other functions will be incorrectly determined
	     ;; to also be using decrypted data. But it's safe. The
	     ;; proper thing would be more rigorous control-flow
	     ;; analysis; we settle for an inappropriate hack.
	     (= (env!vars-using-dec lhs) t))

	 ;; check if the rhs used an encrypted field
	 (if rhs-uses-enc
	     (do ;; for card["exp_year"], mark both card and exp_year.
	       ;; this is conservative, but easier to reason about in
	       ;; srex-is-encrypted-data (b). eg. for testcase post.arc:
	       ;; card is used in data, used in ajax, used by jq-ajax, thus
	       ;; exp_year should be shown in read
	       ;; fixme: why does this lead to duplicate vars in vars-using-enc?
	       ;;        ...while using (str ((data 1) 0)) doesn't -- but doesn't
	       ;;        produce the desired result of detecting the ajax variable?
	       (if (is (type (data 1)) 'cons) ;; assigning a hashtable
		   (do ;;(prn (str "the lhs hash USED an encrypted field: " ((data 1) 0)))
		       ;;(prn (str "the lhs hash USED an encrypted field: " ((data 1) 1)))
		       (= (env!vars-using-enc ((data 1) 0)) t)
		       (= (env!vars-using-enc ((data 1) 1)) t))
		   (do ;; assigning a value
		       ;;(prn (str "the lhs value USED an encrypted field: " (data 1)))
		       (= (env!vars-using-enc (data 1)) t)
		     ))
	       ))

	 ;; better to not allow arbitrary method access, which will
	 ;; then make the following check unnecessary.
;; 	 (if (and rhs-uses-dec
;; 		  (no (srex-is-encrypted-data env lhs))
;; 		  (no (find lhs oldparams)))
;; 	     ;; tried to set a field that won't be encrypted (fixme:
;; 	     ;; should verify it's a form variable though) and isn't a
;; 	     ;; local variable to the value of a field that was
;; 	     ;; decrypted.
;; 	     (env!srex-hack-attempt t))

	 (if (no env!srex-hack-attempt)
	     (withs (rhstouse rhs)
		    ;; if rhs was a single token that was a function, use the new function name
		    (if (is (type (data 2)) 'sym)
			(aif (env!fns (data 2))
			     (= rhstouse it)))			
		    (outpend (str lhs " = " rhstouse)))
	     (do ;;(prn "HACK ATTEMPT --- 7 on " lhs " = " rhs)
	         (= env!srex-hack-attempt t)
		 ;; clear out env!uses-dec to catch more such issues in other expressions
		 ;; (= env!uses-dec nil)
		 ))

	 ;; restore previous information about the right-hand side
	 ;; accessing decrypted data. You'd think this isn't
	 ;; necessary, but it might be possible to make a valid
	 ;; assignment within an assignment that bypasses our
	 ;; checks. Better safe than sorry.
	 ;; (= env!old-uses-dec (or rhs-uses-dec env!uses-dec))
	 ;;(prn "out of verify-assign with: " out)
	 out))

(def verify-str (env data oldparams depth)
  (withs (out "" counter 0)
	 (each i data
	       (if (is counter 0) ;; str
		   nil
		   (>= counter 2)
		   (= out (str out " + " (verify-exp env i oldparams 0)))
		   (is counter 1)
		   (= out (str out (verify-exp env i oldparams depth))))
	       (++ counter))
	 out))

(def verify-andor (env data oldparams depth)
  ;;(prn " verify-andor: " data)
  (withs (out "" counter 0 op nil)
	 (if (is (str (data 0)) "and")
	     (= op " && ")
	     (is (str (data 0)) "or")
	     (= op " || "))
	 (each i data
	       ;;(prn " processing " i " with op " op " at counter " counter)
	       (do (if (> counter 1)
		       (do (= out (str out op))
			   (= out (str out (verify-exp env i oldparams depth))))
		       (> counter 0) ;; skip the and/or
		       (= out (str out (verify-exp env i oldparams depth)))
		       ;;(prn " did nothing")
		       ))
	       ;;(prn "  will go to next iteration")
	       (++ counter))
	 ;;(prn "out from verify-andor")
	 out))

(def tounderscores (s)
  (withs (out "" counter 0 l (len s))
	 (while (< counter l)
		(withs (thischar (str (s counter)))
		       (if (is (str thischar) "-")
			   (= thischar "_"))
		       (= out (str out thischar)))
		(++ counter))
	 out))

(def srex-is-btn (env i)
  (withs (ret nil)
	 (each item env!formbuttons
	       (withs (btn item!btn)
		      (if (is btn i)
			  (= ret t))))
	 ret))

(= srex-fnmaps* (table))
(each f (list "srex-set-attr" "srex-get-wtype"
	      "jq-autocomplete" "jq-autocomplete-tokeninput" "jq-ajax"
	      "srex-cookie-del" "srex-cookies-get"
	      "srex-location-set" "srex-location-get"
	      "srex-onclick" "srex-onkeypress")
      (= (srex-fnmaps* f) t))
(def verify-apply (env data oldparams depth)
  ;;(prn "in verify-apply: " data)
  (withs (out "" counter 0 name nil isset nil isget nil isgetwt nil
          issendout nil isonclick nil
	  setparam nil setvalue nil getparam nil
	  rhs-uses-dec nil rhs-uses-enc nil)
	 (each i data
	       ;;(prn (str "processing i: " i))
	       (if (> counter 1)
		   (= out (str out ", ")))
	       (if (is counter 0)
		   (do (if (env!fns i)
			   ;; this is a call to a user-supplied function
			   (do ;; (prn "will call user-supplied function " i)
			       (= name (env!fns i))
			       (= out (str out name "(")))
			   ;; this is a call to a different function
			   (is (str i) "srex-get")
			   (do (= isget t)
			       (= (env!srex-used "srex-get") t)
			       (= out (str out "srex_get(")))
			   (is (str i) "srex-set")
			   (do (= isset t)
			       (= (env!srex-used "srex-set") t)
			       (= out (str out "srex_set(")))
			   (is (str i) "srex-onclick")
			   (do (= isonclick t)
			       (= (env!srex-used "srex-onclick") t)
			       (= out (str out "srex_onclick(")))
			   (is (str i) "srex-onkeypress")
			   (do (= (env!srex-used "srex-onkeypress") t)
			       (= out (str out "srex_onkeypress(")))
			   (srex-fnmaps* (str i))
			   (do (if (is (str i) "srex-get-wtype")
				   (= isgetwt t))
			       (= (env!srex-used (str i)) t)
			       (= out (str (tounderscores (str i)) "("))
			       (if (is (str i) "jq-ajax")
				   (do (= issendout t)
				       (= (env!srex-used "jq-ajax") t)
				       ;;(prn "found AJAX")
				       ;;(prn env!using-enc)
				       ))
			       )
			   (do ;; (prn "other function")
			       (= out (str out (tounderscores (str i)) "("))
			       ))
		       )
		   (> counter 0)
		   (withs (param nil paramstouse oldparams)
			  (= rhs-uses-dec env!uses-dec) ;save
			  (= rhs-uses-enc env!uses-enc) ;save
			  (= env!uses-dec nil)
			  (= env!uses-enc nil)
			  (if (and isgetwt (or (> counter 1)
					       (and (is counter 1) (is (str i) "console"))))
			      ;; if we are calling something like: (srex-get-wtype console log "test")
			      ;; allow the first variable only if it
			      ;; is console; allow the second variable
			      ;; at all times
			      (do ;; (prn "pushed " i " to paramstouse")
				  (push (str i) paramstouse)))
			  ;;(prn "i: " i " counter " counter " isgetwt " isgetwt)
			  (= param (verify-exp env i paramstouse 0))
			  (if (and issendout (is counter 1))
			      (do ;;(prn "sending out: " i)
				  (if (env!vars-using-enc i)
				      ;; the variable passed to jq-ajax contains data
				      ;; that should be encrypted but are instead sent
				      ;; out of the browser
				      (= (env!fns-using-enc "jq-ajax") t))
				))
			  (if (and isonclick (is counter 1))
			      (do ;; (prn "isonclick: " i)
				  (if (or (srex-is-btn env i)
					  (is i "sign")
					  (is i "publish")
					  (is i "showauthors"))
				      ;; the element that has an onclick handler set
				      ;; is a button used for encryption. This is a hack attempt.
				      (do (= env!srex-hack-attempt t)))
				))
			  (if (and isset (is counter 1))
			      (= setparam param))
			  (if (and isset (is counter 3))
			      (= setvalue i))
			  (if (and isset (is counter 3)
				   (is (type i) 'cons)
				   (env!fns-using-dec (i 0)))
			      ;; if this is the parameter that was
			      ;; set, and it was a function call
			      ;; using decrypted data
			      (= env!uses-dec t))
			  (if (and isset (is counter 3)
				   (is (type i) 'cons)
				   (env!fns-using-enc (i 0)))
			      ;; if this is the parameter that was
			      ;; set, and it was a function call
			      ;; using decrypted data
			      (= env!uses-enc t))
			  (if (and isget (is counter 1))
			      (do ;; if this is an srex-get, and its first argument describing the
				  ;; input field isn't a string, conservatively assume we are being
				  ;; hacked. We could implement a proper eval here, but why bother
				  ;; helping hackers?
				  (if (no (is (type i) 'string))
				      (do
					;;(prn "HACK ATTEMPT --- 1")
					(= env!srex-hack-attempt t)))
				  (if (srex-is-encrypted-data env i)
				      (do ;;(prn (str "isget for: " i))
					  (= env!uses-enc t)))
				  (= getparam param)))
			  (= env!uses-dec (or rhs-uses-dec env!uses-dec)) ;restore
			  (= env!uses-enc (or rhs-uses-enc env!uses-enc)) ;restore
			  (if (no env!srex-hack-attempt)
			      (= out (str out param))
			      (= out "null"))
			  )
		   )
	       (++ counter))
	 (= out (str out ")"))

	 ;; check if what srex-set will send to the server is not encrypted data
	 (if (and isset
		  env!uses-dec
		  ;; note: don't also check for env!uses-enc. Need
		  ;; special code for showing in red fields that will
		  ;; have encrypted data sent away from the browser.
		  (no (srex-is-encrypted-data env setparam))
		  (srex-is-form-data env setparam)
		  (no (is (type setvalue) 'string)))
	     ;; setting the value of a field that won't be encrypted, using decrypted data
	     (do ;; (prn "HACK ATTEMPT --- 2 with data: " data)
;; 		 (prn "isset: " isset)
;; 		 (prn "env!uses-dec: " env!uses-dec)
;; 		 (prn "not encrypted data: " (no (srex-is-encrypted-data env setparam)))
;; 		 (prn "is-form-data: " (srex-is-form-data env setparam))
;; 		 (prn "not string data: " (no (is (type setvalue) 'string)))
		 (= env!srex-hack-attempt t)))

	 (if env!srex-hack-attempt
	     (= out "null"))

;; 	 (if (srex-is-decrypted-data env lhs)
;; 	     (env!srex-hack-attempt t)
;; 	     (outpend (str lhs " = " rhs ";")))

	 ;;(prn "out from verify-apply: " out)
	 out))

(def verify-each (env data oldparams depth)
  (withs (out "" counter 0 name (srex-uniq)
	  eachbody nil)
	 (withs (listcounter 0)
		;; must generate list variable
		(outpend #\newline)
		(outpend (str "var counter_" name " = 0;" #\newline))
		(outpend (str "var each_" name " = "))
		(if (is (type (data 2)) 'cons)
		    (if (is (str ((data 2) 0)) "list")
			;; this is indeed a list
			(do (= out (str out "["))
			    (each l (data 2)
				  (if (> listcounter 1)
				      (= out (str out ", ")))
				  (if (> listcounter 0)
				      (do ;;(prn "will emit item for each_")
					  (= out (str out (verify-exp env l oldparams depth)))
					  ;;(prn "DID emit item for each_"))
					  ))
				  (++ listcounter))
			    (= out (str out "]")))
			;; this is a function call
			(verify-exp env (data 2) oldparams depth))
		    (atom (data 2))
		    ;; this is a variable
		    (= out (str out (data 2)))
		    )
		(= out (str out ";" #\newline))
		(= (env!srex-used "srex-length") t)
		(outpend (str "var length_" name " = srex_length(each_" name ");" #\newline))
		)
	 (outpend (str "while (counter_" name " < length_" name ") {" #\newline))
	 (++ depth)
	 (outpend (str "var " (data 1) " = each_" name "[counter_" name "];" #\newline))
	 (withs (bodycounter 0 paramstouse oldparams)
		(each i data
		      (if (is bodycounter 1)
			  ;; consider the each iterator is a local variable
			  (push (str i) paramstouse))
		      (if (> bodycounter 2)
			  (push i eachbody))
		      (++ bodycounter))
		(each i eachbody
		      (outpend (verify-exp env i paramstouse depth) ";" #\newline)))
	 (outpend (str "counter_" name " += 1;" #\newline))
	 (-- depth)
	 (outpend (str "}"))
	 out))

(def verify-maptable (env data oldparams depth)
  ;;(prn "in verify-maptable: " data)
  (withs (out "" fnitem (data 1) key ((fnitem 1) 0) value ((fnitem 1) 1)
	  bodycounter 0 maptablebody nil)
	 (each i fnitem
	       (if (> bodycounter 1)
		   (push i maptablebody))
	       (++ bodycounter))
	 (outpend #\newline)
	 (outpend (str "for (" key " in " (data 2) ") {" #\newline))
	 (++ depth)
	 (outpend (str "var " value " = " (data 2) "[" key "];" #\newline))
	 (each i maptablebody
	       (outpend (verify-exp env i (+ oldparams (list (str key))) 0) ";" #\newline))
	 (-- depth)
	 (outpend (str "}"))
	 ;;(prn "out of verify-maptable: " out)
	 out))

(def verify-if (env data oldparams depth)
  ;;(prn "in verify-if: " data)
  (withs (out "" counter 0 els (len data))
	 (outpend #\newline)
	 (outpend "")
	 (each i data
	       ;;(prn "els: " els ", if item " counter ": " i)
	       (if (> counter 0)
		   (if (is (mod counter 2) 1)
		       (if (is (+ counter 1) els)
			   ;; processing the last element
			   (do (= out (str out (verify-exp env i oldparams (+ depth 1)) ";" #\newline))
			       (outpend (str "}" #\newline))
			   )
			   ;; processing a boolean expression
			   (do (= out (str out "if ("))
			       (= out (str out (verify-exp env i oldparams depth)))
			       (= out (str out ")"))))
		       (is (mod counter 2) 0)
		       (do (= out (str out " {" #\newline))
			   (= out (str out (verify-exp env i oldparams (+ depth 1)) ";" #\newline))
			   (if (is (+ counter 2) els)
			       (outpend (str "} else {" #\newline))
			       (< (+ counter 1) els)
			       (outpend (str "} else "))
			       (outpend (str "}")))
			   )))
	       (++ counter))
	 ;;(prn "out from verify-if")
	 out))
