//alert('background.js started');

var foundCSP = 0;

// A policy that is still safe (forbids executing Javascript) while
// allowing CSS, fonts and images from the server.

// You can't execute Javascript from CSS, since script-src controls
// that. Plus style-src does not restrict an external stylesheet
// (e.g., found via <link rel="stylesheet">).
// http://www.w3.org/TR/CSP/#style-src

var desiredCSP = "default-src 'none'; style-src http://127.0.0.1:1412/ 'unsafe-inline'; script-src 'self'; object-src 'self'; connect-src *; img-src http://127.0.0.1:1412/; font-src http://127.0.0.1:1412/;";
chrome.webRequest.onHeadersReceived.addListener(
  function (details)
  {
      //alert('onHeadersReceived');
      for (i = 0; i < details.responseHeaders.length; i++) {
	  if (details.responseHeaders[i].name.toUpperCase() == "X-Webkit-CSP" ||
              details.responseHeaders[i].name.toUpperCase() == "X-Content-Security-Policy" ||
              details.responseHeaders[i].name.toUpperCase() == "Content-Security-Policy") {
	      details.responseHeaders[i].value = desiredCSP;
	      foundCSP = 1;
	  } else if (foundCSP == 0) {
	      //alert('will add CSP');
	      details.responseHeaders.push( { 'name': "Content-Security-Policy", 'value': desiredCSP } );
	      foundCSP = 1;
	  }
      }
      return {
	  responseHeaders : details.responseHeaders
	      };
  },
  {
      urls : ["http://127.0.0.1:1412/*"],
      types : ["main_frame", "sub_frame", "stylesheet", "script", "image", "object", "xmlhttprequest", "other"]
  },
  ["blocking", "responseHeaders"]
);


chrome.webRequest.onHeadersReceived.addListener(
  function (details)
  {
      //alert('foundCSP is reset to 0');
      foundCSP = 0;
  },
  {
      urls : ["http://127.0.0.1:1412/*"],
      types : ["main_frame", "sub_frame", "stylesheet", "script", "image", "object", "xmlhttprequest", "other"]
  },
  ["blocking", "responseHeaders"]
);


function get_url_params(url) {
    var query_string = {};
    var vars = url.split("&");
    for (var i=0;i<vars.length;i++) {
	var pair = vars[i].split("=");
	// If first entry with this name
	if (typeof query_string[pair[0]] === "undefined") {
	    query_string[pair[0]] = pair[1];
	    // If second entry with this name
	} else if (typeof query_string[pair[0]] === "string") {
	    var arr = [ query_string[pair[0]], pair[1] ];
	    query_string[pair[0]] = arr;
	    // If third or later entry with this name
	} else {
	    query_string[pair[0]].push(pair[1]);
	}
    } 
    return query_string;
}

chrome.webRequest.onBeforeRequest.addListener(
  function (details) 
  {
      var add = "";
      var params = {};
      var index = details.url.indexOf('?');
      if (index != -1) {
	  var params_str = details.url.substring(index+1, details.url.length);
	  params = get_url_params(params_str);
      }

      // This means the request is issued from the browser extension
      // Try to make the parameter name not be visually distracting
      var paramname = "___o";

      if (params[paramname] == null) {
	  // Should add a parameter that signifies we are visiting
	  // from this extension, because it tells the server it
	  // should not issue Javascript. e.g. if a user logged out
	  // and is visiting the website again to login.
	  if (Object.keys(params).length == 0)
	      add = "?" + paramname + "=o___";
	  else
	      add = "&" + paramname + "=o___";
      }

      return { redirectUrl: details.url + add};
  },
  {
      urls: [ "http://127.0.0.1:1412/*" ],
      types : ["main_frame", "sub_frame", "stylesheet", "script", "image", "object", "xmlhttprequest", "other"]
  },
  ["blocking", "requestBody"] // not sure what "blocking" does
  //["requestBody"]
);


// Check if localStorage is supported in the browser
var hasStorage = (function() {
      try {
        localStorage.setItem('test', 'test');
        localStorage.removeItem('test');
        return true;
      } catch(e) {
        return false;
      }
    }());

if (hasStorage == false) {
    alert("Your browser does not support localStorage. Please enable localStorage in your browser settings to be able to encrypt data, and then re-install MyExampleWebsite's browser plugin.");
} else {
    // Generate a key-pair if running for the first time
    var encprivkey = localStorage.getItem('encprivkey');
    if (encprivkey == null) {
	chrome.tabs.create( {url: "options_generate.html"} );
    }
}


// API to return data to content scripts
chrome.runtime.onMessage.addListener( function(request, sender, sendResponse) {
	if (request.method == "localStorage.getItem")
	    sendResponse({data: localStorage.getItem(request.key)});
	else if (request.method == "localStorage.setItem.encverifiedkeyids") {
            // save data from content script back inside the browser plugin
	    localStorage.setItem('encverifiedkeyids', request.newData);
	} else
	    sendResponse({});
});
