//alert('options.js opened');
var passlen = 20;
var keybits = 3072;
var saltbits = 1024;
var passkeybits = 1024;
var passiters = 1000;
var searchsaltbits = 4096;
var searchpassbits = 4096;
var searchmperc = 0.25;
var searchivbits = 4096;
var fnid = undefined;
var userid = undefined;
var salt = undefined;
var privkey = undefined;
var pubkey = undefined;

localStorage.setItem('passlen', passlen);
localStorage.setItem('saltbits', saltbits);
localStorage.setItem('searchsaltbits', searchsaltbits);
localStorage.setItem('searchpassbits', searchpassbits);
localStorage.setItem('searchmperc', searchmperc);
localStorage.setItem('searchivbits', searchivbits);
localStorage.setItem('passkeybits', passkeybits);
localStorage.setItem('passiters', passiters);


// the server needed these
localStorage.setItem('keybits', keybits);

// need to have a cookie and a profile created on the server for this GET to return an fnid
$.ajax({
        type: 'GET',
	 url: 'http://127.0.0.1:1412/api-v1-encrypt-data-page',
	data: { 'keybits': keybits,
		'saltbits': saltbits,
		'passkeybits': passkeybits,
		'passiters': passiters,
		'searchsaltbits': searchsaltbits,
		'searchpassbits': searchpassbits,
		'searchmperc': searchmperc,
		'searchivbits': searchivbits
	       },
	success: function(data) {
	    try {
	       var j = JSON.parse(data);
	       fnid = j.fnid;
	       userid = j.id;
	    } catch (e) {}
	   },
	async: false
       });

if (fnid != undefined) {
    document.getElementById('server_available').style.display = 'inline';
} else {
    document.getElementById('server_unavailable').style.display = 'inline';
}

document.getElementById('passlen1').innerHTML = passlen;
document.getElementById('passlen2').innerHTML = passlen;

document.addEventListener('DOMContentLoaded', function () {
	document.getElementById('start_button').addEventListener('click', start_encrypting);
    });

// fixme: this was copy-pasted. Where's a Lisp where you need one...
function encrypt_nonsearchable(input, for_keys, sign, signing_keys) {
  // from openpgp.js
  var msg, armored;
  msg = openpgp.message.fromText(input);
  if (sign)
     msg = msg.sign(signing_keys);
  msg = msg.encrypt(for_keys);
  armored = openpgp.armor.encode(openpgp.enums.armor.message, msg.packets.write());
  return armored;
}
function start_encrypting() {
    // hide stuff
    document.getElementById('introduction').style.display = 'none';
    document.getElementById('processing').style.display = 'inline';

    // allow the start_button to depress
    var load = setInterval(function () {
            start_encrypting_main();
	    clearInterval(load);
        }, 500);

    // display progress indicator
    var progress = setInterval(function () {
        var text = document.getElementById('time-report').innerText;
        document.getElementById('time-report').innerText = text + '.';
    }, 500);
}

function start_encrypting_main () {

      if (document.getElementById('encryption_password').value.length < passlen) {
         document.getElementById('localstorage_body').style.display = 'none';
         document.getElementById('password_error').style.display = 'inline';
         document.getElementById('encryption_password').focus();
         document.getElementById('encryption_password').value = '';
         return false;
      }

      // Generate encrypted password
      salt = CryptoJS.lib.WordArray.random(saltbits/8);
      var costly_key_obj = CryptoJS.PBKDF2( document.getElementById('encryption_password').value, salt, { keySize: passkeybits/32, iterations: passiters } );
      var costly_key = costly_key_obj.toString();
      
      document.getElementById('salt').value = salt.toString();
      localStorage.setItem('encrypted_encryption_password', costly_key);

      var keymanager_passphrase = costly_key;

      // don't use a passphrase, because that would require knowing
      // the cleartext passphrase during decryption, and we don't want
      // a web user to have to type it in.
      // could use the encrypted encryption password, though
      var keymanager = openpgp
	  .generateKeyPair({numBits: keybits, userId: userid, passphrase: keymanager_passphrase})
	   .then(function(keyPair) {
		   console.log("privateKeyArmored: " + keyPair.privateKeyArmored);
		   console.log("publicKeyArmored: " + keyPair.publicKeyArmored);
		   privkey = keyPair.privateKeyArmored;
		   pubkey = keyPair.publicKeyArmored;
		   document.getElementById('pubkey').value = pubkey;
		   
		   continue_encrypting();
	       });
}

function continue_encrypting () {

    // Encrypt the private key
    var encprivObj = CryptoJS.AES.encrypt(privkey, localStorage.getItem('encrypted_encryption_password'));
    var encprivkey = encprivObj.toString();
    document.getElementById('encprivkey').value = encprivkey;
    //alert("created the encryption keys for fnid " + fnid);

    // create a simpler keyring, because openpgp's Keyring object
    // looks complicated to me. Map key ids to user ids, to check them
    // when verifying signatures

    // The alternative here is to map user ids to key ids. But a user
    // id with openpgp.js seems to contain more than one key id,
    // possibly one for encryption and one for signing. Avoid this
    // alternative to keep the mapping one-to-one
    var pubkey_openpgp = openpgp.key.readArmored(pubkey).keys[0];
    var privkey_openpgp = openpgp.key.readArmored(privkey).keys[0];
    privkey_openpgp.decrypt(localStorage.getItem('encrypted_encryption_password'));
    var userid = pubkey_openpgp.getPrimaryUser().user.userId.userid;
    var verified_keyids = {};

    // Encrypt the verified_keyids
    verified_keyids = JSON.stringify(verified_keyids);
    var encverifiedkeyids = encrypt_nonsearchable(verified_keyids, [pubkey_openpgp], 1, [privkey_openpgp]);

    // Generate what's necessary for encrypting data in a way that
    // would allow encrypted search queries.

    // Generate seed
    var searchsalt = CryptoJS.lib.WordArray.random(searchsaltbits/8).toString();
    // Generate a single key for encrypted search queries
    var searchpass = CryptoJS.lib.WordArray.random(searchpassbits/8).toString();
    // Generate a constant iv, to guarantee pre-encryption for
    // encrypted search is deterministc
    var searchiv = CryptoJS.lib.WordArray.random(searchivbits/8).toString();

    // Encrypt all that
    var searchinfo = {};
    searchinfo['salt'] = searchsalt;
    searchinfo['pass'] = searchpass;
    searchinfo['iv'] = searchiv;
    // the searchmperc is saved twice:
    // - once encrypted here, so the server can't force the client to use a different value
    // - once unencrypted on the server, so the server can search
    searchinfo['mperc'] = searchmperc;
    // temporarily save this in the browser; will remove in encrypt_data_page.js
    searchinfo = JSON.stringify(searchinfo);
    localStorage.setItem('searchinfo', searchinfo);
    var encsearchinfo = encrypt_nonsearchable(searchinfo, [pubkey_openpgp], 1, [privkey_openpgp]);

    finish_encrypting(encprivkey, pubkey, salt.toString(), encverifiedkeyids, encsearchinfo);
}
function finish_encrypting(encprivkey, pubkey, salt, encverifiedkeyids, encsearchinfo) {
    // Don't save the private key on the server. Save it in localStorage
    localStorage.setItem('encprivkey', encprivkey);
    localStorage.setItem('pubkey', pubkey);
    localStorage.setItem('salt', salt);
    document.getElementById('encverifiedkeyids').value = encverifiedkeyids;

    var pluginuniq = undefined;
    $.ajax({
	    type: 'POST',
	     url: 'http://127.0.0.1:1412/security-extension-fnid',
	    data: { 'fnid': fnid,
		    'pubkey': pubkey,
		    // Don't save the private key on the server. Save it in localStorage
		    //'encprivkey': encprivkey,
		    //'salt': salt
		    'encverifiedkeyids': encverifiedkeyids,
		    'encsearchinfo': encsearchinfo
		    },
	 success: function(data) {
		//alert (data);
		var j = JSON.parse(data);
		pluginuniq = j.pluginuniq;
		localStorage.setItem('plugincont', j.plugincont);
		// fixme: not doing anything with pluginuniq
		// localStorage.setItem('pluginuniq', j.pluginuniq);
	    },
		async: false
		});

    //alert('got ' + pluginuniq);
    if (pluginuniq == undefined) {
	document.getElementById('cannot_save_keys').style.display = 'inline';
	document.getElementById('server_available').style.display = 'none';
    } else {

	//alert('will change tabs');
	chrome.tabs.getSelected(null, function(tab) {
		//tab.url = "encrypt_data_page.html";
		chrome.tabs.create( {url: "encrypt_data_page.html" } );
		chrome.tabs.remove(tab.id);
	    });
	    
	return true;
    }
}
