#!/bin/bash

# Note: It turns out this is not needed
# # Note: A noeval version of ArcJS must be built first using:
# #  $ noeval.sh
#
# Run as:
#  $ ./prep.sh https://myexamplewebsite.com MyExampleWebsite
#  $ ./prep.sh  http://104.236.73.78:1412 JoanDemo

# Prepare all files that should contain the website url
# SITE_URL should not contain a / at the end
# SITE_URL should better be an https:// link 
SITE_URL=http://127.0.0.1:1412
SITE_NAME=MyExampleWebsite

if [ "$1" != "" ]; then
    SITE_URL=$1
fi

if [ "$2" != "" ]; then
    SITE_NAME=$2
fi

echo "SITE_URL:  $SITE_URL"
echo "SITE_NAME: $SITE_NAME"
VERSION=2

for file in `ls *in`; do
    new_file=`echo $file | sed -e 's/\.in$//'`
    # Can't use / in sed because the SITE_URL contains some. Can use ; instead
    cat $file | sed -e "s;@SITE_URL@;$SITE_URL;g" > $new_file
    cat $new_file | sed -e "s;@SITE_NAME@;$SITE_NAME;g" > $new_file.sitename
    cat $new_file.sitename | sed -e "s;@VERSION@;$VERSION;g" > $new_file.version
    rm $new_file.sitename
    mv $new_file.version $new_file
done


# Convert Arc source into a Javascript variable
rm -f add_encryption.arc > /dev/null
cat arc_ported.arc >> add_encryption.arc
cat strings.arc >> add_encryption.arc
cat share_with_plugin.arc >> add_encryption.arc
cat arc_redefined.arc >> add_encryption.arc
cat parsecomb0.arc >> add_encryption.arc
cat fromjson.arc | grep -v parsecomb0.arc >> add_encryption.arc
cat safe_rex.arc >> add_encryption.arc
arc-js-master/bin/arcjsc add_encryption.arc -o add_encryption.fasl


# Begin with the compiler ArcJS source
for file in add_encryption.js encrypt_data_page.js options_generate.js; do
    rm -f $file > /dev/null

#     # It turns out the following isn't needed, because the Content
#     # Security Policy prohibits using eval in encrypt_data_page.js.
#     if [ $file = "encrypt_data_page.js" ]; then
# 	cat arc-js-master/arc.min.js >> $file
# 	cat arc-js-master/arc_loader.js >> $file
#     fi

    if [ $file = "add_encryption.js" ]; then
	echo "// This file was generated semi-automatically. Do not edit
var preloads = [];
var preload_vals = [];
" >> $file
    fi
    
    if [ $file = "add_encryption.js" ]; then
	cat add_encryption.fasl >> $file
    fi

    if [ $file = "add_encryption.js" ]; then
	echo "
ArcJS.fasl_loader(ArcJS.NameSpace.get('user'), preloads, preload_vals);
" >> $file
	cat add_encryption_share_with_plugin.js >> $file
	cat ${file}_post >> $file
    fi

    if [ $file = "encrypt_data_page.js" ]; then
	# Generate the JS needed to encrypt/decrypt data for search
	CURPWD=`pwd`
	cd ..
	cat $CURPWD/prep_driver.arc > $CURPWD/last_prep_run
	echo '(prep "chrome-extension/encrypt_data_page.js_pre") (quit)' >> $CURPWD/last_prep_run
	cat $CURPWD/last_prep_run | racket -f as.scm > /dev/null 2>&1
	cd -
	cat seedrandom/seedrandom.js >> $file
	cat ${file}_pre >> $file
	cat ${file}_post >> $file
	cat ${file}_post2 >> $file
    fi

    if [ $file = "options_generate.js" ]; then
	# Generate parts of this file from a common template
	cat ${file}_pre >> $file
	cat ${file}_common >> $file
	cat ${file}_post >> $file
    fi
done
