#!/bin/bash

DEBUG=0

FILES=$1
CURPWD=`pwd`
cd tests
if [ "$FILES" = "" ]; then
    FILES=`ls -1 *arc`
fi
cd - > /dev/null 2>&1
for file in $FILES; do
    cd ..
    cat $CURPWD/test_driver.arc > $CURPWD/last_test_run
    echo "(test \"$CURPWD/tests/$file\") (quit)" >> $CURPWD/last_test_run
    rm $CURPWD/tests/$file.out > /dev/null 2>&1
    if [ $DEBUG = 0 ]; then
	cat $CURPWD/last_test_run | racket -f as.scm > /dev/null 2>&1
    else
	cat $CURPWD/last_test_run | racket -f as.scm
    fi
    rm $CURPWD/last_test_run
    cd - > /dev/null 2>&1
    diff -prauN $CURPWD/tests/$file.exp $CURPWD/tests/$file.out > $CURPWD/tests/$file.diff
    DIFFRET=$?
    if [ $DIFFRET = 0 ]; then
	echo PASS $file
    else
	echo FAIL $file
	cat $CURPWD/tests/$file.diff
    fi
done
