(defop example-autocomplete-server-multiple req
  (page (backlink "/examples") site-name* nil
	(rex (list (list 'encrypt
			 (obj formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-autocomplete-server-multiple
						     encpassid "encpass"))
			      )))
	     (fread "joan-example-autocomplete-server-multiple-sent.arc"))
	(pr "This example uses a different autocomplete library that allows selecting multiple items. It uses jQuery Tokeninput, not jQuery's autocomplete.")
	(br2)
	(pr "Type the string 'tur' and see what happens.")
	(br 3)
	(click-source "joan-example-autocomplete-server-multiple.arc")
	(pr " Click ")
	(tag (a href  "/joan-example-autocomplete-server-multiple-sent.arc")
	     (pr "here"))
	(pr " to see the code written on the server for the autocomplete command.")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (withs (all (arg _ "autocomplete-all"))
			  (= all (fromjson all))
			  (example-autocomplete-multiple-show all (get-user _))))
	       (gentag input type "text" id "autocomplete-target" name "autocomplete-target" value "" autofocus "")
	       (gentag input type "hidden" id "autocomplete-all" name "autocomplete-all" value "")
	       (br 3)
	       (encverif (get-user req))
	       (encsearchinfo (get-user req))
	       (tag (a id "example-autocomplete-server-multiple")
		    (pr "submit")))
	(br 8)
	(hline)))

(def example-autocomplete-multiple-show (all user)
  (page (backlink "/examples") site-name* nil
	(pr "You selected:")
	(br2)
	(encverif user)
	(encsearchinfo user)
	(tabwrap
	 (tag (ol)
	      (each d all
		    (tag (li)
			 (pr "The text: '" (d "name") "' with value: " (d "id") "."))
		    (br))))
	(br 8)
	(hline)))

(= allcontacts-multiple* (table))
(= (allcontacts-multiple* 701) "The Turtle")
(= (allcontacts-multiple* 702) "The Hare")
(= (allcontacts-multiple* 703) "Snowwhite")
(= (allcontacts-multiple* 704) "Arturo Sandoval")
(= (allcontacts-multiple* 705) "John Turturo")
(= (allcontacts-multiple* 706) "Arturo Albergati")
(= (allcontacts-multiple* 707) "Arturo Toscanini")
(defop example-autocomplete-multiple-contacts req
  (withs (out "" term (lower (arg req "q")) counter 0 matched nil)
	 (maptable (fn (k v)
		       (if (findsubseq term (lower v))
			   (push (list v k) matched))) allcontacts-multiple*)
	 (= out (str "["))
	 (each item matched
	       (withs (name (item 0) id (item 1))
		      (if (> counter 0) (= out (str out ",")))
		      (= out (str out "{ \"name\": " (json-escape name) ", \"id\": \"" id "\"}"))
		      (++ counter)))
	 (= out (str out "]"))
	 ;;(fwrite "/tmp/out" (tostring (pr out)))
	 (pr out)))
