(defop example-autocomplete-server req
  (page (backlink "/examples") site-name* nil
	(rex (list (list 'encrypt
			 (obj formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-autocomplete-server
						     encpassid "encpass"))
			      )))
	     (fread "joan-example-autocomplete-server-sent.arc"))
	(pr "This example shows how to autocomplete a sentence using data stored on the server. It wraps a call to jQuery's autocomplete.")
	(br2)
	(pr "Type the string 'tur' and see what happens.")
	(br 3)
	(click-source "joan-example-autocomplete-server.arc")
	(pr " Click ")
	(tag (a href  "/joan-example-autocomplete-server-sent.arc")
	     (pr "here"))
	(pr " to see the code written on the server for the autocomplete command.")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (withs (text (arg _ "autocomplete-target")
			   id (arg _ "autocomplete-id"))
			  (example-autocomplete-show text id (get-user _))))
	       (gentag input type "text" id "autocomplete-target" name "autocomplete-target" value "" autofocus "")
	       (gentag input type "hidden" id "autocomplete-id" name "autocomplete-id" value "")
	       (br 3)
	       (encverif (get-user req))
	       (tag (a id "example-autocomplete-server")
		    (pr "submit")))
	(br 8)
	(hline)))

(def example-autocomplete-show (text id user)
  (page (backlink "/examples") site-name* nil
	(encverif user)
	(pr "You entered the text: '" text "' with value: " id ".")
	(br 8)
	(hline)))

(= allcontacts* (table))
(= (allcontacts* 701) "The Turtle")
(= (allcontacts* 702) "The Hare")
(= (allcontacts* 703) "Snowwhite")
(= (allcontacts* 704) "Arturo Sandoval")
(= (allcontacts* 705) "John Turturo")
(= (allcontacts* 706) "Arturo Albergati")
(= (allcontacts* 707) "Arturo Toscanini")
(defop example-autocomplete-contacts req
  (withs (out "" term (lower (arg req "term")) counter 0 matched nil)
	 (maptable (fn (k v)
		       (if (findsubseq term (lower v))
			   (push (list v k) matched))) allcontacts*)
	 (= out (str "["))
	 (each item matched
	       (withs (name (item 0) id (item 1))
		      (if (> counter 0) (= out (str out ",")))
		      (= out (str out "{ \"label\": " (json-escape name) ", \"value\": \"" id "\"}"))
		      (++ counter)))
	 (= out (str out "]"))
	 (pr out)))
