(def get-pubkey ()
  (withs (ret (table) data (table) ajax (table) kind "@KIND@")
	 (if (is kind "username")
	     ;; get the public key from the server
	     (do (= (data "id") (srex-get "username" t))
		 (= (ajax "data") data)
		 (= (ajax "type") "GET")
		 (= (ajax "async") nil)
		 (= (ajax "url") "/api-v1-pubkey")
		 (= (ajax "success")
		    (fn (data)
			(withs (retpubkey nil d nil)
			       (= d (fromjson data))
			       (= retpubkey (srex-get-wtype d "pubkey"))
			       (= (ret "userid") (srex-get "username" t))
			       (= (ret "pubkey") retpubkey)
			       )))
		 (jq-ajax ajax))
	     ;; get the public key from a PGP keyserver, through the server
	     (is kind "keyserver")
	     (do (= (data "email") (srex-get "email" t))
		 (= (ajax "data") data)
		 (= (ajax "type") "GET")
		 (= (ajax "async") nil)
		 (= (ajax "url") "/api-v1-pgp-pubkey")
		 (= (ajax "success")
		    (fn (data)
			(= (ret "userid") (srex-get "email" t))
			(= (ret "pubkey") data)))
		 (jq-ajax ajax))
	     ;; else get the public key from the page, entered by the user
	     (do (= (ret "userid") (srex-get "username" t))
		 (= (ret "pubkey") (srex-get "pubkey" t))))
	 (return ret)))
