(defop example-date req
  (page (backlink "/examples") site-name* nil
	;; define what the browser extension should do
	(rex (list (list 'encrypt
			 (obj formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-text
						     encpassid "encpass"))
			      ;; must provide an 'encrypt command, since
			      ;; there's a 'submit button, but should not
			      ;; list anything to encrypt
			      )))
	     ;; execute code written on the server
	     (fread "joan-example-date-sent.arc"))
	(pr "This example shows you can still create Javascript objects in Arc and call their methods.")
	(br 3)
	(pr "It creates a new Date object to calculate the local date, which is then submitted to the server.")
	(br 3)
	(click-source "joan-example-date.arc")
	(pr " Click ")
	(tag (a href (str "/joan-example-date-sent.arc"))
	     (pr "here"))
	(pr " to see the code written on the server that is executed by the browser extension.")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (withs (tzhours (arg _ "tzhours")
			   real_tzhours nil)
			  ;; gettimezone is inverted. heh. Javascript
			  ;; http://stackoverflow.com/questions/14669475/date-gettimezoneoffset-inverted
			  (= real_tzhours (- (/ (coerce (arg _ "tzhours") 'int) 60)))
			  (example-date-page2 real_tzhours (get-user req))))
	       (gentag input type "hidden" id "tzhours" name "tzhours" value "")
	       (encverif (get-user req))
	       (br 3)
	       (tag (a id "example-text")
		    (pr "submit")))
	(br 8)
	(hline)
	))

(def example-date-page2 (real_tzhours users)
  (page (backlink "/examples") site-name* nil
	(pr "Your local timezone is " real_tzhours " hours from UTC.")
	(encverif user)
	(br 8)
	(hline)))
