(defop example-login req
  (page (backlink "/examples") site-name* nil
	;; define what the browser extension should do
	(rex (list (list 'encrypt
			 (obj formbuttons (list (obj form "LOGIN"
						     btn 'example-login))
			      hash-itemlist (list "password")))))
	(pr "Most web apps hash user passwords at the server. This example hashes the password in the browser plugin, which is more secure. It doesn't trust the server at all.")
	(br 3)
	(click-source "joan-example-login.arc")
	(br2)
	(sform "LOGIN"
	       (fn (_)
		   (withs (p (prof (get-user _))
			   password (arg _ "password")
			   dataid nil)
			  (= p!loginpassword password)
			  (save-prof p)
			  (example-login-view-password (get-user _))))
	       ;; each data item has an encryption password
	       (encverif (get-user req))
	       (gentag input type "password" id "password" name "password" value "" autofocus "")
	       (br 3)
	       (tag (a id "example-login")
		    (pr "submit")))
	(br 8)
	(hline)))

(def example-login-view-password (user)
  (withs (p (prof user))
	 (page (backlink "/examples") site-name* nil
	       (pr "The password saved was: ")
	       (br2)
	       (encverif user)
	       (tabwrap
		(pr p!loginpassword))
	       (br 8)
	       (hline))))
