(defop example-noencrypt-alert req
  (example-noencrypt-alert-core (get-user req) nil))

(def example-noencrypt-alert-core (user encrypt)
  (page (backlink "/examples") site-name* nil
	;; define what the browser extension should do
	(rex (list (list 'encrypt
			 (obj formbuttons (list (obj form "ENTER_TEXT_NOENCRYPT"
						     btn 'example-noencrypt-alert
						     encpassid "encpass"))
			      enc-itemlist (if encrypt
					       (list (obj id "body"))
					       nil) ; if you don't encrypt the body, you get an alert
			      ))))
	(pr "This example shows an input field that won't be encrypted has a red background. So a server can't trick the user into thinking their text will be encrypted. The user is alerted if the server does that.")
	(br 3)
	(click-source "joan-example-noencrypt-alert.arc")
	(pr " Click ") (w/link (example-noencrypt-alert-core user (if encrypt nil t)) (pr "here"))
	(pr " to see how the same example ")
	(if encrypt
	    (prbold "DOES")
	    (do (pr "does ") (prbold "NOT")))
	(pr " raise an alert if the input field is configured at the server to be encrypted.")
	(br2)
	(sform "ENTER_TEXT_NOENCRYPT"
	       (fn (_)
		   (withs (p (prof (get-user _))
			   body (arg _ "body")
			   encpass (arg _ "encpass")
			   dataid nil)
			  (if (is encpass "") (= encpass nil))
			  (= dataid (add-data (get-user _) "blog-entry" encpass body nil nil nil))
			  (example-text-view-encrypted (get-user _) dataid)))
	       ;; each data item has an encryption password
	       (gentag input type "hidden" id "encpass" name "encpass" value "")
	       (encverif user)
	       (tag (textarea id "body" name "body" rows 12 cols 53 autofocus "")
		    (pr ""))
	       (showsign nil t)
	       (br2)
	       (tag (a id "example-noencrypt-alert")
		    (pr "submit")))
	(br 8)
	(hline)))
