(mac str body `(string ,@body))

(def fwrite (file contents)
     (w/outfile p file (each b contents (writec b p))))

(def fappend (file contents)
     (w/appendfile p file (each b contents (writec b p))))

(def fread (file) (tostring (system (str "cat " file)))) ; cat, seriously Arc?

(def fexists(file)
  (withs (exists nil)
	 (= exists (tostring (system (str "ls " file " 2>/dev/null | wc -l | awk '{ print $1 }' | xargs echo -n "))))
	 (if (is exists "0") nil t)))

;; splits on strings too, not just chars; better
(def strsplit (st sp)
  (withs (left st index nil ret nil)
	 (while (> (len left) 0)
		(= index (findsubseq sp left))
		(if (no index)
		    (do (push (cut left 0 index) ret)
			(= left nil))
		    (do ;;(prn "match in: " index)
			;;(prn "will push: " (cut left 0 index))
			(push (cut left 0 index) ret)
			(= left (cut left (+ index (len sp)) (len left)))
			;;(prn "left is: " left)
			)))
	 (if (no ret)
	     (= ret (list st))
	     (= ret (rev ret)))
	 ret))

(def pgp-tomultiline (s prefix)
  (withs (multi (strsplit s "\n") ret "" counter 0 numitems (len multi))
	 (each item multi
	       ;; must also get rid of carriage return, produced by the version string, e.g.:
	       ;; Version: OpenPGP.js v0.10.1
	       (withs (itemtouse ((strsplit item "\r") 0))
		      (if (> counter 0)
			  (= ret (str ret " +
" prefix)))
		      (= ret (str ret "\"" itemtouse ))
		      (if (> numitems 1)
			  (= ret (str ret "\\n")))
		      (= ret (str ret "\""))
		      (++ counter)))
	 ret))

;; http://stackoverflow.com/questions/1068834/object-comparison-in-javascript
(def deepcompare ()
  "function deepCompare () {
  var i, l, leftChain, rightChain;

  function compare2Objects (x, y) {
    var p;

    // remember that NaN === NaN returns false
    // and isNaN(undefined) returns true
    if (isNaN(x) && isNaN(y) && typeof x === 'number' && typeof y === 'number') {
         return true;
    }

    // Compare primitives and functions.     
    // Check if both arguments link to the same object.
    // Especially useful on step when comparing prototypes
    if (x === y) {
        return true;
    }

    // Works in case when functions are created in constructor.
    // Comparing dates is a common scenario. Another built-ins?
    // We can even handle functions passed across iframes
    if ((typeof x === 'function' && typeof y === 'function') ||
       (x instanceof Date && y instanceof Date) ||
       (x instanceof RegExp && y instanceof RegExp) ||
       (x instanceof String && y instanceof String) ||
       (x instanceof Number && y instanceof Number)) {
        return x.toString() === y.toString();
    }

    // At last checking prototypes as good a we can
    if (!(x instanceof Object && y instanceof Object)) {
        return false;
    }

    if (x.isPrototypeOf(y) || y.isPrototypeOf(x)) {
        return false;
    }

    if (x.constructor !== y.constructor) {
        return false;
    }

    if (x.prototype !== y.prototype) {
        return false;
    }

    // Check for infinitive linking loops
    if (leftChain.indexOf(x) > -1 || rightChain.indexOf(y) > -1) {
         return false;
    }

    // Quick checking of one object beeing a subset of another.
    // todo: cache the structure of arguments[0] for performance
    for (p in y) {
        if (y.hasOwnProperty(p) !== x.hasOwnProperty(p)) {
            return false;
        }
        else if (typeof y[p] !== typeof x[p]) {
            return false;
        }
    }

    for (p in x) {
        if (y.hasOwnProperty(p) !== x.hasOwnProperty(p)) {
            return false;
        }
        else if (typeof y[p] !== typeof x[p]) {
            return false;
        }

        switch (typeof (x[p])) {
            case 'object':
            case 'function':

                leftChain.push(x);
                rightChain.push(y);

                if (!compare2Objects (x[p], y[p])) {
                    return false;
                }

                leftChain.pop();
                rightChain.pop();
                break;

            default:
                if (x[p] !== y[p]) {
                    return false;
                }
                break;
        }
    }

    return true;
  }

  if (arguments.length < 1) {
    return true; //Die silently? Don't know how to handle such case, please help...
    // throw 'Need two or more arguments to compare';
  }

  for (i = 1, l = arguments.length; i < l; i++) {

      leftChain = []; //Todo: this can be cached
      rightChain = [];

      if (!compare2Objects(arguments[0], arguments[i])) {
          return false;
      }
  }

  return true;
}
")

(def encrypt-nonsearchable ()
  (str "function encrypt_nonsearchable(input, for_keys, sign, signing_keys) {
  // from openpgp.js
  var msg, armored;
  msg = openpgp.message.fromText(input);
  if (sign)
     msg = msg.sign(signing_keys);
  msg = msg.encrypt(for_keys);
  armored = openpgp.armor.encode(openpgp.enums.armor.message, msg.packets.write());
  return armored;
}
"))

(def encsearch-js-decryptkeys ()
  (withs (out "")
	 (= out (str out "// Decrypt the encrypted search info
var encsearchinfo = document.getElementById('encsearchinfo').value;
var searchinfo = decrypt_nonsearchable('encsearchinfo', encsearchinfo, privkey_openpgp);
searchinfo = JSON.parse(searchinfo);
var searchsalt = searchinfo['salt'];
var searchpass = searchinfo['pass'];
var searchiv = searchinfo['iv'];
var searchmperc = searchinfo['mperc'];
"))
	 out))

;; emit all code necessary to later perform an encrypted search
;; store/retrieve/decrypt
(def encsearch-js (enc-itemlist dec-itemlist autocomp-itemlist)
  (withs (out "" emit-tosearch nil emit-toretrieve nil emit-fromsearch nil)
	 (each item enc-itemlist
	       (if item!tosearch
		   (= emit-tosearch t))
	       (if item!toretrieve
		   (= emit-toretrieve t)))
	 (each item dec-itemlist
	       (if item!fromsearch
		   (= emit-fromsearch t)))
	 (if autocomp-itemlist
	     (do (= emit-toretrieve t)
		 (= emit-fromsearch t)))

	 (if (or emit-tosearch emit-toretrieve emit-fromsearch)
	     (do (= out
		    (str out
			 (encsearch-js-decryptkeys)
			 (encsearch-js-common)))))

	 (if emit-tosearch
	     (= out (str out (encsearch-js-tosearch))))
	 (if emit-toretrieve
	     (= out (str out (encsearch-js-toretrieve))))
	 (if emit-fromsearch
	     (= out (str out (encsearch-js-fromsearch))))

	 out))

;; The Dawn of Encryption
;; http://www.cs.berkeley.edu/~dawnsong/papers/se.pdf
(def encsearch-js-common ()
  (withs (ret "")
	 ;; split on anything that is not a word
	 (= ret (str ret "// split a sentence on whitespace, into a list of individual words to encrypt
function wordsplit_forenc(s) {
  var sinit = s.split(/\\W/);
  var sfinal = [];
  var wcounter = 0;
  var scopy = '';

  while (wcounter < sinit.length) {
    scopy = scopy + sinit[wcounter];
    if (sinit[wcounter] != '') // remove blank matches from split
      sfinal.push(sinit[wcounter]);
    var ccounter = scopy.length;
    var stop = 0;
    while (stop == 0) {
      if (ccounter < s.length && s[ccounter].match(/\\W/) != null) {
        scopy = scopy + s[ccounter];		
        sfinal.push(s[ccounter]);
        ccounter++;
      } else
        stop = 1;
      }
      wcounter++;
  }

  return sfinal;
}

function is_whitespace(s) {
  return /\\W/g.test(s);
}

function nonwordsplit_forenc (space_and_words) {
  var words = [];
  var space = {};
  var counter = 0;
  var word_counter = 0;

  while (counter < space_and_words.length) {
    // if a word does not consist only of word characters, then it's
    // whitespace or punctuation.
    if (is_whitespace(space_and_words[counter])) {
      // it's whitespace or punctuation
      // index with -1, because word_counter was already incremented
      if (space[word_counter-1] == null)
        space[word_counter-1] = [];
      space[word_counter-1].push(space_and_words[counter]);
    } else {
      // it's a word
      words.push(space_and_words[counter]);
      word_counter++;
    }
    counter++;
  }
  //alert('space: ' + JSON.stringify(space));
  //alert('words:' + JSON.stringify(words));

  return [space, words];
}

function searchabledata_encrypt_internal (value, internalpass) {
  var value_str = JSON.stringify(value);
  var encrypted = CryptoJS.AES.encrypt(value_str, internalpass);
  var value_enc = encrypted.toString();

  return value_enc;
}

function lettercasefold_forenc( words ) {
  var lowercase_words = [];
  var lettercase = [];
  var counter = 0;

  while (counter < words.length) {
    var lowercase_word = words[counter].toLowerCase();
    var lower_encoding = {};
    var letter_counter = 0;

    // Identify uppercase letters in each word
    while (letter_counter < words[counter].length) {
      if (lowercase_word[letter_counter] != words[counter][letter_counter]) {
        // This letter was uppercase
        lower_encoding[letter_counter] = 1;
      }
      letter_counter++;
    }
    lowercase_words.push(lowercase_word);
    lettercase.push(lower_encoding);

    counter++;
  }

  return [lowercase_words, lettercase];
}

function add_count_tosearch(words) {
  var count_words = [];
  var all_word_counts = {};
  var counter = 0;

  while (counter < words.length) {
    if (all_word_counts[words[counter]] == null) {
       all_word_counts[words[counter]] = 0;
    } else {
       all_word_counts[words[counter]] += 1;
    }
    var new_word = { 'count': all_word_counts[words[counter]], 'word': words[counter] };
    new_word = JSON.stringify(new_word);
    count_words.push(new_word);
    
    counter++;
  }

  return count_words;
}

// Given a word, pick a suitable m value for it
// fixme: currently make m be a percentage of n; not sure what's a good value
function pickm (word, searchmperc) {
  var n = word.length;
  var m = Math.ceil(n * searchmperc);

  return m;
}
"
;; from http://code.google.com/p/crypto-js/source/browse/branches/2.0.x/src/Crypto.js?spec=svn301&r=301
"
function bytesToHex (bytes) {
  for (var hex = [], i = 0; i < bytes.length; i++) {
    hex.push((bytes[i] >>> 4).toString(16));
    hex.push((bytes[i] & 0xF).toString(16));
  }
  return hex.join('');
}

function hexToBytes (hex) {
  for (var bytes = [], c = 0; c < hex.length; c += 2)
    bytes.push(parseInt(hex.substr(c, 2), 16));
  return bytes;
}

function XORBytes (bytes_array1, bytes_array2) {
  var counter = 0;
  var xor_bytes = [];

  if (bytes_array1.length == bytes_array2.length) {
    while (counter < bytes_array1.length) {
      var this_byte = bytes_array1[counter] ^ bytes_array2[counter];
      xor_bytes.push(this_byte);
      counter++;
    }
  }

  return xor_bytes;
}

// return a random value between 0 and 1
function random_zerotoone() {
  // fixme: we shouldn't need to do this. It's CryptoJS.lib.WordArray.random() that should be fixed.
  var ar = new Uint32Array(1);
  var v = window.crypto.getRandomValues(ar)[0];
  var zerotoone = v / (Math.pow(2,32) - 1);

  return zerotoone;
/*  
  var randomValue_words = CryptoJS.lib.WordArray.random(1);
  var randomValue_hex = randomValue_words.toString();
  var randomValue_bin = hexToBytes(randomValue_hex)[0] / 255;

  return randomValue_bin;
*/
}
"

;; Fisher-Yates Shuffle, changed to not use Math.random() because Math.random()
;; was seeded to return repeatable values and was causing shuffle to always
;; generate the same permutation. Also because Math.random() is not
;; cryptographically secure in all browsers.
;;
;; http://stackoverflow.com/questions/2450954/how-to-randomize-shuffle-a-javascript-array
"
function shuffle(array) {
  var currentIndex = array.length, temporaryValue, randomIndex ;

  // While there remain elements to shuffle...
  while (0 !== currentIndex) {

    // Pick a remaining element...
    randomIndex = Math.floor(random_zerotoone() * currentIndex);
    currentIndex -= 1;

    // And swap it with the current element.
    temporaryValue = array[currentIndex];
    array[currentIndex] = array[randomIndex];
    array[randomIndex] = temporaryValue;
  }

  return array;
}

// Pre-encrypt every word with deterministic encryption
function search_preencrypt(words, searchpass, searchiv) {
  var preenc_words = [];
  var iv = CryptoJS.enc.Hex.parse(searchiv);
  var searchpass_words = CryptoJS.enc.Hex.parse(searchpass);

  var counter = 0;
  while (counter < words.length) {
    var encrypted = CryptoJS.AES.encrypt(words[counter], searchpass_words, { iv: iv });
    // Save in hex, to make debugging easier
    var encrypted_words = CryptoJS.enc.Base64.parse(encrypted.toString());
    var encrypted_hex = CryptoJS.enc.Hex.stringify(encrypted_words);
    preenc_words.push(encrypted_hex);
    console.log('the word: ' + words[counter] + ' has been pre-encrypted to: ' + encrypted_hex);
    // to debug, enable this:
    //if (counter == 0)
    //  alert('===============preencrypted word was: ' + encrypted_hex + ' for: ' + words[counter] + ' using searchpass: ' + searchpass);
    counter++;
  }

  return preenc_words;
}

// Crop each pre-encrypted word to produce L_i
function search_li(preenc_words, searchmperc) {
  var li_words = [];

  var counter = 0;
  while (counter < preenc_words.length) {
    var this_preenc_word = preenc_words[counter]
    // in calculating mbytes, divide by two because this_preenc_word
    // is a hex string, where each byte is represented by two characters
    var nbytes = this_preenc_word.length / 2;
    var mbytes = pickm(this_preenc_word, searchmperc) / 2;
    // Split word into its first n-m bytes to produce L_i
    var first_nm_word = this_preenc_word.substr(0, (nbytes - mbytes) * 2);
    //console.log('will extract L_i key for: ' + this_preenc_word + ' from the first n-m bytes which are: ' + first_nm_word + ' and should be n-m: ' + (nbytes-mbytes));
    li_words.push(first_nm_word);
    counter++;
  }

  return li_words;
}

// initialize pseudorandom generator that returns repeatable values given the seed
function search_random_init(searchsalt) {
  Math.seedrandom(searchsalt);
}

// For every pre-encrypted word, generate a random value which is as
// long as the word
function search_random(preenc_words) {
  var s_random_words = [];

  var counter = 0;
  while (counter < preenc_words.length) {
    var this_preenc_word = preenc_words[counter];
    //console.log('preenc word: ' + this_preenc_word);
    //console.log('preenc word len: ' + this_preenc_word.length);
    // In calculating nbytes and mbytes, divide by two because this_preenc_word
    // is a hex string, where each byte is represented by two characters.
    var nbytes = this_preenc_word.length / 2;
    var random_counter = 0;
    var random_word = '';
    while (random_counter < nbytes) {
      // Not only is it ok to use Math.random() here, it's also a requirement.
      // Because it has been seeded with a pseudorandom generator that returns
      // repeatable values, and we want repeatable values.
      var random_value = Math.random();
      //console.log('random_value is: ' + random_value);
      var random_value_byte = random_value * 255;
      //console.log('random_value as a byte is: ' + random_value_byte);
      random_word = random_word + bytesToHex([random_value_byte]);
      random_counter++;
    }
    //console.log('the word: ' + this_preenc_word + ' has the random value: ' + random_word + ' cropped in n bytes: ' + nbytes);
    s_random_words.push(random_word);

    counter++;
  }

  return s_random_words;
}

// For each random value, generate a separate key with a function that takes
// the pre-encrypted word as input
function search_key(preenc_words, li_words, s_random_words, searchiv, searchmperc) {
  var f_key_words = [];
  var iv = CryptoJS.enc.Hex.parse(searchiv);

  var counter = 0;
  while (counter < s_random_words.length) {
    var this_preenc_word = preenc_words[counter];
    var this_random_value = s_random_words[counter];
    var nbytes = this_preenc_word.length / 2;
    var mbytes = pickm(this_preenc_word, searchmperc) / 2;
    var random_bytes = nbytes - mbytes;
    var this_random_value_firstnm_hex = this_random_value.substr(0, (nbytes - mbytes) * 2);
    var this_random_value_firstnm_words = CryptoJS.enc.Hex.parse(this_random_value_firstnm_hex);

    var li_firstnm_hex = li_words[counter];
    var li_firstnm_words = CryptoJS.enc.Hex.parse(li_firstnm_hex);
    var this_separate_key = CryptoJS.AES.encrypt(this_random_value_firstnm_words, li_firstnm_words, { iv: iv });
    var this_separate_key_words = CryptoJS.enc.Base64.parse(this_separate_key.toString());
    var this_separate_key_hex = CryptoJS.enc.Hex.stringify(this_separate_key_words);
    // Save in hex, to make debugging easier
    this_separate_key = this_separate_key_hex;
    // keep only last m bytes for this key
    // in cropping mbytes, multiply by two because this_separate_key is a hex string
    var this_separate_key_cropped = this_separate_key.substr( this_separate_key.length - mbytes * 2, this_separate_key.length);
    //console.log('the L_i word: ' + li_words[counter] + ' has the separate key: ' + this_separate_key + ' which was cropped to: ' + this_separate_key_cropped + ' of m: ' + mbytes);
    f_key_words.push(this_separate_key_cropped);
    // to debug, enable this:
    //if (counter == 0)
    //  alert('========== key was: ' + this_separate_key_cropped + ' with random value ' + this_random_value + ' and li_firstnm_word ' + li_firstnm_hex)
    counter++;
  }

  return f_key_words;
}

// XOR each pre-encrypted word E(W_ci) with each concatenation of S_i and F_ki(L_i)
function search_xor(preenc_words, s_random_words, f_key_words, searchmperc) {
  var xor_words = [];

  var counter = 0;
  while (counter < preenc_words.length) {
    var this_preenc_word = preenc_words[counter];
    var this_random_word = s_random_words[counter];
    var nbytes = this_preenc_word.length / 2;
    var mbytes = pickm(this_preenc_word, searchmperc) / 2;
    var this_random_word = this_random_word.substr(0, (nbytes - mbytes) * 2);
    var concat_word = this_random_word + f_key_words[counter];

    var bytes_preenc_word = hexToBytes(this_preenc_word);
    var bytes_concat_word = hexToBytes(concat_word);
    var bytes_xor_word = XORBytes(bytes_preenc_word, bytes_concat_word);
    var xor_word = bytesToHex(bytes_xor_word);
    console.log('XOR ' + this_preenc_word + ' with ' + concat_word + ' yields ' + xor_word);
    // encode the xor_word to Base64 to make it compact
    var xor_word_words = CryptoJS.enc.Hex.parse(xor_word);
    var xor_word_base64 = CryptoJS.enc.Base64.stringify(xor_word_words);
    xor_words.push(xor_word_base64);
    counter++;
  }

  return xor_words;
}

"))
	 ret))

(def encsearch-js-tosearch ()
  (withs (ret "")
	 (= ret (str ret "function permutation_calculate(num) {
  var perm = [];
  var counter = 0;

  while (counter < num) {
    perm.push(counter);
    counter++;
  }
  shuffle(perm);

  return perm;
}

function permutation_apply(perm, words) {
  perm_words = [];
  var counter = 0;

  while (counter < perm.length) {
    var word_index = perm[counter];
    var word_to_push = words[word_index];
    perm_words.push(word_to_push);
    counter++;
  }

  return perm_words;
}

function permutation_encrypt(perm, searchpass) {
  var perm_str = JSON.stringify(perm);
  var encrypted = CryptoJS.AES.encrypt(perm_str, searchpass);
  var perm_enc = encrypted.toString();
  //alert('encrypted: ' + perm_str + ' and got: ' + perm_enc);

  return perm_enc;
}

function encrypt_tosearch(val, searchsalt, searchpass, searchiv, searchmperc) {
  var space_and_words = [];// not in paper: words including whitespaces
  var space = {};          // not in paper: encode whitespaces
  var lettercase = [];     // not in paper: encode letter casing
  var words = [];          // W_i
  var count_words = [];    // W_ci is W_i adding count to words (section 5.2)
  var preenc_words = [];   // E(W_ci)
  var li_words = [];       // L_i
  var s_random_words = []; // S_i
  var f_key_words = [];    // F_ki(L_i)
  var xor_words = [];      // Ciphertext
  var perm = [];           // Permutation of the order of the words
  var perm_words = [];     // Permutation of the Ciphertext

  // ------------------------------------------------------
  // STEP 1: Split all words on whitespace
  space_and_words = wordsplit_forenc( val );

  // STEP 2: Determine which words should be removed because they are whitespace
  var nonwordsplit_ret = nonwordsplit_forenc( space_and_words );
  space = nonwordsplit_ret[0];
  words = nonwordsplit_ret[1];

  // STEP 3: Encrypt the spacing
  var space_enc = searchabledata_encrypt_internal(space, searchpass);

  // STEP 4: Convert all words to lowercase and save the letter casing
  var lettercasefold_ret = lettercasefold_forenc( words );
  words = lettercasefold_ret[0];
  lettercase = lettercasefold_ret[1];

  // STEP 5: Encrypt the letter casing
  var lettercase_enc = searchabledata_encrypt_internal(lettercase, searchpass);

  // STEP 6: Add count to each word, to avoid exposing the frequency of a word
  //         in a document
  count_words = add_count_tosearch(words);
  // ------------------------------------------------------


  // ------------------------------------------------------

  // STEP 7: Pre-encrypt each word
  preenc_words = search_preencrypt(count_words, searchpass, searchiv);

  // STEP 8: Crop each pre-encrypted word to produce L_i
  li_words = search_li(preenc_words, searchmperc);

  // STEP 9: Generate a random value for each word
  search_random_init(searchsalt);
  s_random_words = search_random(preenc_words);

  // STEP 10: Generate a key for each word
  f_key_words = search_key(preenc_words, li_words, s_random_words, searchiv, searchmperc);

  // STEP 11: XOR each pre-encrypted word E(W_ci) with each concatenation of S_i and F_ki(L_i)
  xor_words = search_xor(preenc_words, s_random_words, f_key_words, searchmperc);
  // ------------------------------------------------------


  // ------------------------------------------------------
  // STEP 12: Calculate a random permutation for the words, to counteract a statistical attack
  perm = permutation_calculate(xor_words.length);

  // STEP 13: Now actually apply the permutation to the words
  perm_words = permutation_apply(perm, xor_words);

  // STEP 14: Encrypt the permutation
  perm_enc = permutation_encrypt(perm, searchpass);
  // ------------------------------------------------------


  var ret = {}
  ret['data'] = perm_words;
  ret['permutation'] = perm_enc;
  ret['space'] = space_enc;
  ret['case'] = lettercase_enc;

  return JSON.stringify(ret);
}
"))
	 ret))

(def encsearch-js-toretrieve ()
  (withs (ret "")
	 (= ret (str ret "function add_count_toretrieve(words) {
  var count_words = [];
  var counter = 0;

  while (counter < words.length) {
    var new_word = { 'count': 0, 'word': words[counter] };
    new_word = JSON.stringify(new_word);
    count_words.push(new_word);
    counter++;
  }

  return count_words;
}

function encrypt_toretrieve(val, searchsalt, searchpass, searchiv, searchmperc, numkeys) {
  var space_and_words = [];// not in paper: words including whitespaces
  var words = [];          // W_i
  var count_words = [];    // A W_ci where each word has count 0
  var preenc_words = [];   // E(W_ci)
  var li_words = [];       // L_i

  // ------------------------------------------------------
  // STEP 1: Split all words on whitespace
  space_and_words = wordsplit_forenc( val );

  // STEP 2: Determine which words should be removed because they are whitespace
  var nonwordsplit_ret = nonwordsplit_forenc( space_and_words );
  words = nonwordsplit_ret[1];

  // STEP 3: Convert all words to lowercase
  var lettercasefold_ret = lettercasefold_forenc( words );
  words = lettercasefold_ret[0];

  // STEP 4: Add a count of 0 to each word, to stop at it's first occurance
  count_words = add_count_toretrieve(words);

  // STEP 5: Pre-encrypt each word
  preenc_words = search_preencrypt(count_words, searchpass, searchiv);

  // STEP 6: Crop each pre-encrypted word to produce L_i
  li_words = search_li(preenc_words, searchmperc);
  // ------------------------------------------------------

  // ------------------------------------------------------
  // For each word, generate all possible keys that might be needed, up
  // to numkeys
  var ret = {};
  ret['words'] = preenc_words;
  ret['keys'] = [];
  var counter = 0;
  while (counter < preenc_words.length) {
    var s_random_words = []; // S_i
    var f_key_words = [];    // F_ki(L_i)

    var key_counter = 0;
    search_random_init(searchsalt);
    while (key_counter < numkeys) {
      // STEP 7: Generate a random value for each word
      var this_random_words = search_random([ preenc_words[counter] ]);
      s_random_words.push( this_random_words[0] );
      key_counter++;
    }

    //console.log('generated ' + numkeys + ' s_random_words: ' + s_random_words);
    key_counter = 0;
    while (key_counter < numkeys) {
      // STEP 8: Generate a key for each word
      var this_key_words = search_key( [ preenc_words[counter] ], [ li_words[counter] ], [ s_random_words[key_counter] ], searchiv, searchmperc);
      f_key_words.push( this_key_words[0] );
      key_counter++;
    }
    ret['keys'].push(f_key_words);
    //console.log('generated ' + numkeys + ' f_key_words: ' + f_key_words);
    counter++;
  }
  // ------------------------------------------------------


  return JSON.stringify(ret);
}
"))
	 ret))

(def encsearch-js-fromsearch ()
  (withs (ret "")
	 (= ret (str ret "
function permutation_decrypt(perm_enc, searchpass) {
  var decrypted_words = CryptoJS.AES.decrypt(perm_enc, searchpass);
  var decrypted = decrypted_words.toString(CryptoJS.enc.Utf8);
  var perm = JSON.parse(decrypted);

  return perm;
}

function permutation_remove(perm, words) {
  var unperm_words = [];
  var counter = 0;

  // Generate an array with the same number of elements, holding a dummy value
  while (counter < words.length) {
    unperm_words.push(0);
    counter++;
  }

  // Set the expected value at each index
  counter = 0;
  while (counter < words.length) {
    var perm_index = perm[counter];
    unperm_words[perm_index] = words[counter];
    counter++;
  }

  return unperm_words;
}

// Convert words that are encoded in Base64 into Hex
function search_base64tohex(base64_words) {
  var hex_words = [];

  var counter = 0;
  while (counter < base64_words.length) {
    var this_word_base64 = base64_words[counter];
    var this_word_word = CryptoJS.enc.Base64.parse(this_word_base64);
    var this_word_hex = CryptoJS.enc.Hex.stringify(this_word_word);
    hex_words.push(this_word_hex);
    counter++;
  }

  return hex_words;
}

// XOR the first n-m bytes of each encrypted word with S_i to produce L_i
function search_dexor_li(enc_words_hex, s_random_words, searchmperc) {
  var dexor_words = [];

  var counter = 0;
  while (counter < enc_words_hex.length) {
    var this_enc_word_hex = enc_words_hex[counter];
    var nbytes = this_enc_word_hex.length / 2;
    var mbytes = pickm(this_enc_word_hex, searchmperc) / 2;
    var this_enc_word_hex_firstnm = this_enc_word_hex.substr(0, (nbytes - mbytes) * 2);

    var this_random_word_hex = s_random_words[counter];
    var this_random_word_hex_firstnm = this_random_word_hex.substr(0, (nbytes - mbytes) * 2);

    var bytes_this_enc_word = hexToBytes(this_enc_word_hex_firstnm);
    var bytes_random_word = hexToBytes(this_random_word_hex_firstnm);
    var dexor_word = XORBytes(bytes_this_enc_word, bytes_random_word);
    var dexor_word_hex = bytesToHex(dexor_word);
    console.log('deXOR L_i of encrypted word: ' + this_enc_word_hex + ' using only its first n-m: ' + (nbytes-mbytes) * 2 + ' which crops it to: ' + this_enc_word_hex_firstnm + ' with the cropped random word: ' + this_random_word_hex_firstnm + ' yields: ' + dexor_word_hex);
    dexor_words.push(dexor_word_hex);
    counter++;
  }

  return dexor_words;
}

// XOR the last m bytes of each encrypted word with F_ki(L_i) to produce R_i
function search_dexor_ri(enc_words_hex, f_key_words, searchmperc) {
  var dexor_words = [];

  var counter = 0;
  while (counter < enc_words_hex.length) {
    var this_enc_word_hex = enc_words_hex[counter];
    var nbytes = this_enc_word_hex.length / 2;
    var mbytes = pickm(this_enc_word_hex, searchmperc) / 2;
    var this_enc_word_hex_lastm = this_enc_word_hex.substr((nbytes - mbytes) * 2, nbytes);
    var this_key_word_hex = f_key_words[counter];

    var bytes_this_enc_word = hexToBytes(this_enc_word_hex_lastm);
    var bytes_key_word = hexToBytes(this_key_word_hex);
    var dexor_word = XORBytes(bytes_this_enc_word, bytes_key_word);
    var dexor_word_hex = bytesToHex(dexor_word);
    console.log('deXOR R_i of encrypted word: ' + this_enc_word_hex + ' using only its last m: ' + mbytes * 2 + ' which crops it to: ' + this_enc_word_hex_lastm + ' with the cropped key word: ' + this_key_word_hex + ' yields: ' + dexor_word_hex);
    dexor_words.push(dexor_word_hex);
    counter++;
  }

  return dexor_words;
}

// Concatenate L_i and R_i to produce E(W_ci) and decrypt the word
function search_decrypt(li_words, ri_words, searchpass, searchiv) {
  var dec_words_hex = [];
  //console.log('search_decrypt with searchpass: ' + searchpass);
  var searchpass_words = CryptoJS.enc.Hex.parse(searchpass);
  //console.log('search_decrypt with searchpass_words: ' + searchpass_words);
  var iv = CryptoJS.enc.Hex.parse(searchiv);

  var counter = 0;
  while (counter < li_words.length) {
    var this_xor_word_hex = li_words[counter] + ri_words[counter];
    var this_xor_word = CryptoJS.enc.Hex.parse(this_xor_word_hex);
    console.log('after hex parse for ' + this_xor_word_hex);
    var this_xor_word_base64 = CryptoJS.enc.Base64.stringify(this_xor_word);
    //console.log('word in base64: ' + this_xor_word_base64);
    var decrypted_word = CryptoJS.AES.decrypt(this_xor_word_base64, searchpass_words, { iv: iv });
    var decrypted = decrypted_word.toString(CryptoJS.enc.Utf8);
    console.log('decrypted to: ' + decrypted);
    dec_words_hex.push(decrypted);
    counter += 1;
  }

  return dec_words_hex;
}

function remove_count_fromsearch(count_words) {
  var words = [];
  var counter = 0;

  while (counter < count_words.length) {
    var original_word = JSON.parse(count_words[counter]);
    original_word = original_word['word'];
    words.push(original_word);
    counter++;
  }

  return words;
}

function searchabledata_decrypt_internal (value_enc, internalpass) {
  var decrypted_words = CryptoJS.AES.decrypt(value_enc, internalpass);
  var decrypted = decrypted_words.toString(CryptoJS.enc.Utf8);
  var value = JSON.parse(decrypted);

  return value;
}

function lettercaseunfold (folded_words, lettercase) {
  var unfolded_words = [];
  var counter = 0;

  while (counter < folded_words.length) {
    var letter_counter = 0;
    var word = folded_words[counter];

    while (letter_counter < folded_words[counter].length) {
      var letter = folded_words[counter][letter_counter];
      var should_up = lettercase[counter][letter_counter];

      if (should_up) // should convert to uppercase
        word = word.substr(0, letter_counter) + letter.toUpperCase() + word.substr(letter_counter+letter.length);

      letter_counter++;
    }
    unfolded_words.push(word);

    counter++;
  }

  return unfolded_words;
}

function wordjoin_fordec (words, space) {
  var ret = '';
  var counter = 0;

  while (counter < words.length) {
    ret = ret + words[counter];
    if (space[counter] != null) {
      // there is space after this word
      var space_counter = 0;
      while (space_counter < space[counter].length) {
        ret = ret + space[counter][space_counter];
        space_counter++;
      }
    }
    counter += 1;
  }

  console.log('reassembled to: ' + ret);
  return ret;
}

function decrypt_fromsearch(results, searchsalt, searchpass, searchiv, searchmperc) {
  var perm_words = results['data'];
  var perm_enc = results['permutation'];
  var space_enc = results['space'];
  var lettercase_enc = results['case'];
  console.log('will decrypt data: ' + perm_words);
  console.log('will decrypt permutation: ' + perm_enc);
  console.log('will decrypt space: ' + space_enc);
  console.log('will decrypt case: ' + lettercase_enc);
  var perm = [];           // Permutation of the order of the words
  var enc_words = [];      // The words to decrypt
  var s_random_words = []; // S_i
  var li_words = [];       // L_i
  var ri_words = [];       // R_i
  var enc_words_hex = [];  // The encrypted words, converted from Base64 to Hex
  var space = {};          // The decrypted whitespace between the words
  var lettercase = {};     // The decrypted letter casing for each word
  var ret = '';            // The decrypted words, reassembled as text

  // ------------------------------------------------------
  // STEP 1: Decrypt the permutation
  perm = permutation_decrypt(perm_enc, searchpass);

  // STEP 2: Reassemble the words into their original order
  enc_words = permutation_remove(perm, perm_words);
  // ------------------------------------------------------


  // ------------------------------------------------------
  // STEP 3: Convert the enc_words into hex words
  enc_words_hex = search_base64tohex(enc_words);

  // STEP 4: Generate the random value for each word again
  search_random_init(searchsalt);
  s_random_words = search_random(enc_words_hex);

  // STEP 5: XOR the first n-m bytes of each encrypted word with S_i to produce L_i
  li_words = search_dexor_li(enc_words_hex, s_random_words, searchmperc);

  // STEP 6: Generate a key for each word
  f_key_words = search_key(enc_words_hex, li_words, s_random_words, searchiv, searchmperc);

  // STEP 7: XOR the last m bytes of each encrypted word with F_ki(L_i) to produce R_i
  ri_words = search_dexor_ri(enc_words_hex, f_key_words, searchmperc);

  // STEP 8: Concatenate L_i and R_i to produce E(W_ci) and decrypt the word
  decrypted_words = search_decrypt(li_words, ri_words, searchpass, searchiv);
  // ------------------------------------------------------


  // ------------------------------------------------------
  // STEP 9: Remove word counts
  decrypted_words_nocounts = remove_count_fromsearch(decrypted_words);

  // STEP 10: Decrypt the letter casing
  lettercase = searchabledata_decrypt_internal(lettercase_enc, searchpass);

  // STEP 11: Apply letter casing back to the decrypted words
  lettercase_words_unfolded = lettercaseunfold(decrypted_words_nocounts, lettercase);

  // STEP 12: Decrypt the spacing
  space = searchabledata_decrypt_internal(space_enc, searchpass);

  // STEP 13: Reassamble all the decrypted words into text
  ret = wordjoin_fordec(lettercase_words_unfolded, space);
  // ------------------------------------------------------


  return ret;
}
"))
	 ret))
