(defop example-code-from-server req
  (page (backlink "/examples") site-name* nil
	;; define what the browser extension should do
	(rex (list (list 'may_publish 'ENTER_TEXT)
		   (list 'encrypt
			 (obj pubuserid (get-user req)
			      formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-text
						     encpassid "encpass"))
			      enc-itemlist (list (obj id "body")))))
	     ;; execute code written on the server
	     (fread "joan-example-code-from-server-sent.arc"))

	(pr "This example does more than just encrypt data. It also <i>modifies the data</i>, before they are encrypted, using code sent by the server.")
	(br 3)
	(pr "Server code extracts the first sentence of what you type in, and encrypts and submits only that.")
	(br2)
	(pr "The rocket science here is that code written on the server runs safely in the browser. A code verifier in the browser extension rejects code that tries to send decrypted data to a server.")
	(br 3)
	(click-source "joan-example-code-from-server.arc")
	(pr " Click ")
	(tag (a href (str "/joan-example-code-from-server-sent.arc"))
	     (pr "here"))
	(pr " to see the code written on the server that is executed by the browser extension.")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (withs (p (prof (get-user _))
			   body (arg _ "body")
			   encpass (arg _ "encpass")
			   publish (is (arg _ "publish") "on")
			   dataid nil)
			  (encpass-read encpass p)
			  (if (is encpass "") (= encpass nil))
			  (= dataid (add-data (get-user _) "blog-entry" encpass body nil nil nil))
			  (example-text-view-encrypted (get-user _) dataid)))
	       ;; each data item has an encryption password
	       (gentag input type "hidden" id "encpass" name "encpass" value "")
	       (encverif (get-user req))
	       (tag (textarea id "body" name "body" rows 12 cols 53 autofocus "")
		    (pr ""))
	       (br2)
	       (checkbox "publish")
	       (pr " publish")
	       (showsign nil t)
	       (br 3)
	       (tag (a id "example-text")
		    (pr "submit")))
	(br 8)
	(hline)
	))
