(defop example-compute-from-decrypted req
  (example-compute-from-decrypted-page1 req))

(def example-compute-from-decrypted-page1 (req)
  (page (backlink "/examples") site-name* nil
	;; define what the browser extension should do
	(rex (list (list 'encrypt
			 (obj pubuserid (get-user req)
			      formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-text
						     encpassid "encpass"))
			      enc-itemlist (list (obj id "body"))))))
	(pr "You can do more than display decrypted data. You can also modify the data before displaying them.")
	(br 3)
	(pr "In this example, server code counts and displays the number of words in decrypted data.")
	(br2)
	(pr "There are two steps in this example:")
	(br)
	(tag (ul)
	     (tag (li)
		  (pr "In this page, you enter some text and the text is encrypted and saved on the server.")
		  (br2))
	     (tag (li)
		  (pr "In the next page, you'll see the decrypted text you entered and the number of words in it. This is safe, because the decrypted data are not sent back to the server; they are just displayed in the browser.")))
	(br2)
	(click-source "joan-example-nodecrypt.arc")
	(pr " Click ")
	(tag (a href "/joan-example-compute-from-decrypted-sent.arc")
	     (pr "here"))
	(pr " to see the code written on the server that is executed on the second page by the browser extension.")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (withs (p (prof (get-user _))
			   body (arg _ "body")
			   encpass (arg _ "encpass")
			   dataid nil thedata nil)
			  (encpass-read encpass p)
			  (if (is encpass "") (= encpass nil))
			  (= dataid (add-data (get-user _) "blog-entry" encpass body nil nil nil))
			  (= thedata (data (get-user _) dataid))
			  (example-compute-from-decrypted-page2 thedata (get-user _))))
	       ;; each data item has an encryption password
	       (gentag input type "hidden" id "encpass" name "encpass" value "")
	       (encverif (get-user req))
	       (tag (textarea id "body" name "body" rows 12 cols 53 autofocus "")
		    (pr ""))
	       (showsign nil t)
	       (br 3)
	       (tag (a id "example-text")
		    (pr "submit")))
	(br 8)
	(hline)))

(def example-compute-from-decrypted-page2 (data user)
  (page (backlink "/examples") site-name* nil
	(withs (dec-itemlist nil)
	       ;; must provide the password and id of the item to decrypt
	       (push (obj encpass (encpass-val data!encpass user)
			  id (str "entry_1")) dec-itemlist)
	       (rex (list ;; - every submit button should be accompanied by an 'encrypt command
		          ;; - an encrypt command also decrypts, so there should be no 'decrypt if there's an 'encrypt
			  (list 'decrypt
				(obj dec-itemlist dec-itemlist)))
		    (fread "joan-example-compute-from-decrypted-sent.arc"))
	       (pr "The decrypted text is:")
	       (br2)
	       (encverif user)
	       (tabwrap
		(tag (span id (str "entry_1"))
		     (pr (topgp data!data))))
	       (br2)
	       (pr "The number of words in it is: ") (tag (span id (str "showwords")))
	       (br 8)
	       (hline)
	       )))
