(defop example-contact-delete req
  (page (backlink "/examples") site-name* nil
	(pr "This example shows how to delete contacts. It removes the mapping of key id to contact id from the browser plugin.")
	(br2)
	(encverif (get-user req))
	(if (is (len (allcontacts (get-user req))) 0)
	    (do (pr "There are no contacts to delete. Please ")
		(tag (a href "/example-contact-add")
		     (pr "add"))
		(pr " a contact first."))
	    (do (pr "Pick a contact you would like to delete:") (br2)
		(maptable (fn (k v)
			      (w/link (example-encrypted-contact-delete-confirm (get-user req) v!username)
				      (pr v!username))
			      (br)
			      ) (allcontacts (get-user req)))))
	(br2)
	(click-source "joan-example-contact-delete.arc")
	(br 8)
	(hline)
	))

(def example-encrypted-contact-delete-confirm (user contact-username)
  (page (backlink "/examples") site-name* nil
	(rex (list (list 'encrypt
			 (obj pubuserid user
			      formbuttons (list (obj form "DELETE"
						     btn "delete_yes"
						     encpassid "encpass"
						     contact-list (list (obj action 'delete
									     id "username"
									     deletedid "was_it_deleted"))))))
		   nil))
	(pr "Are you sure you want to delete this contact?")
	(br2)
	(sform "DELETE"
	       (fn (req)
		   (del-contact (get-user req) contact-username)
		   (example-contacts-show (get-user req)))
	       (tag (a href "/examples")
		    (pr "No"))
	       (nbsp 3)
	       (tag (a href ""
		       id "delete_yes")
		    (pr "Yes"))
	       (br2)
	       (tag (span id "username")
		    (pr contact-username))
	       (encverif user)
	       (gentag input type "hidden" id "was_it_deleted" name "was_it_deleted" value "no"))
	(br 8)
	(hline)))
