(defop example-encrypt-for-contact-with-autocomplete req
  (page (backlink "/examples") site-name* nil
	(withs (p (prof (get-user req))
		enc-itemlist (list (obj id "body")))
	(rex (list (list 'encrypt
			 (obj pubuserid (get-user req)
			      formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-encrypt-for-contact-with-autocomplete
						     encpassid "encpass"))
			      enc-itemlist enc-itemlist
			      autocomp-itemlist (list (obj url "/example-autocomplete-encrypted-search-for-contact-with-autocomplete-search-contacts"
							   ;; "name" is the name of the field returned by
							   ;;the search; whereas "contactname" is the name
							   ;; of the field used for the search query term
							   enc-fieldlist (list "name")
							   encpassid "encpass"
							   searchin "contactname"
							   searchout "autocomplete-all"
							   toretrievekeys (aif p!searchmaxnames it 0))
						      )
			      )))
	     nil
	     ;;(fread "joan-example-encrypt-for-contact-with-autocomplete-sent.arc")
	     )
	(pr "This example encrypts text for a user's contact. Since the contact name is encrypted, it is selected with autocomplete using an encrypted search query that returns the contact's public key.")
	(br2)
	(pr "Because a user encrypting text for a contact probably wants to be able to decrypt and reread the text in the future, text is always encrypted for both the user and the contact.")
	(br2)
	(pr "It seems you must list at least one field to encrypt for the autocomplete search to work correctly. This could be improved.")
	(br2)
	(pr "To try this example you need to have added at least one contact. If you haven't yet, go to the page that shows how to add contacts and ")
	(tag (a href "/example-contact-add")
	     (pr "add one"))
	(pr " now. Then come back to this page and enter the contact's name.")
	(br 3)
	(click-source "joan-example-encrypt-for-contact-with-autocomplete.arc")
;; 	(pr " Click ")
;; 	(tag (a href  "/joan-example-encrypt-for-contact-with-autocomplete-sent.arc")
;; 	     (pr "here"))
;; 	(pr " to see the code written on the server for the autocomplete command.")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (fwrite "/tmp/arg" (tostring (pr _)))
		   (withs (all (arg _ "autocomplete-all")
			   encpass (arg _ "encpass")
			   body (arg _ "body")
			   p (prof (get-user _)))
			  (= all (fromjson all))
			  (encpass-read encpass p)
			  ;; you'll need to do work here, like save or
			  ;; send the message to each recipient. for
			  ;; this example, let's only save themessage
			  ;; in the current user's data
			  (= dataid (add-data (get-user _) "message" encpass body nil nil nil))
			  (example-encrypt-for-contact-with-autocomplete-multiple-show all (get-user _) body dataid encpass)))
	       (gentag input type "text" id "contactname" name "contactname" value "" autofocus "")
	       ;; the value is in json: it can be a list of values to prepopulate
	       (gentag input type "hidden" id "autocomplete-all" name "autocomplete-all" value "[]")
	       (br)
	       (pr "Message:") (br)
	       (encverif (get-user req))
	       (encsearchinfo (get-user req))
	       (gentag input type "hidden" id "encpass" name "encpass" value "")
	       (tag (textarea id "body" name "body" rows 12 cols 53))
	       (br 3)
	       (showsign nil t)
	       (tag (a id "example-encrypt-for-contact-with-autocomplete")
		    (pr "submit")))
	(br 8)
	(hline))))

(def example-encrypt-for-contact-with-autocomplete-multiple-show (all user body dataid encpass)
  (page (backlink "/examples") site-name* nil
	(withs (data (data user dataid))
	       (pr "You selected the following contacts to receive your message. The server doesn't know the name of each contact. It only knows their username:")
	       (br2)
	       (encverif user)
	       (encsearchinfo user)
	       (tabwrap
		(tag (ol)
		     (each d all
			   (tag (li)
				(pr "Username: " (d "id")))
			   (br))))
	       (br2)
	       (pr "As a result, the message was encrypted for the following users, which is the selected contacts plus the current user:")
	       (br2)
	       (tabwrap
		(tag (ol)
		     (maptable (fn (k v)
				   (tag (li)
					(pr k) ", encrypted: " v!encrypted)
				   (br))
			       encpass)))
	       (br2)
	       (pr "Here is the message submitted. The message is encrypted in a way that allows multiple recipients to decrypt it, not just the contact or just the current user. Click ")
	       (w/link (example-text-view-decrypted user data) (pr "here"))
	       (pr " to see it decrypted as the user. Or if you used as a contact a public key to which you have the private key, try decrypting it with the private key with other software.")
	       (br2)
	       (tabwrap
		(pr (topgp body)))
	       (br 8)
	       (hline))))

(defop example-autocomplete-encrypted-search-for-contact-with-autocomplete-search-contacts req
  (withs (out "" term (arg req "q") counter 0
	  results nil p (prof (get-user req)))
	 (fwrite "/tmp/term" term)
	 (if term
	     (= term (fromjson term))
	     ;; don't break if there is a bug in the ui
	     (= term (table)))
	 (= results (contact-search nil term (get-user req) p!searchmperc (allcontacts (get-user req))))
	 (fwrite "/tmp/contacts" (tostring (pr results)))
	 (= out (str out "["))
	 (maptable (fn (k data)
		       (if (> counter 0)
			   (= out (str out ",")))
		       (= out (str out "{ \"name\": "
				   (tojson (obj data data!data
						permutation data!encpermname
						space data!encspacename
						case data!enccasename))
				   ", \"id\": \"" data!username "\""
				   ;; you could be returning a contact's email address here
				   ;;", \"email\": \"\""
				   ", \"pubkey\": " (tojson data!pubkey)
				   "}"
				   ))
		       (++ counter)
		       ) results)
	 (= out (str out "]"))
	 (fwrite (str "/tmp/out_" (seconds)) out)
	 (pr out)))
