(defop example-nodom req
  (page (backlink "/examples") site-name* nil
	(encverif (get-user req))
	(pr "This example shows you can't access the DOM directly.")
	(br 3)
	(pr "You cannot:")
	(tag (ul)
	     (tag (li)
		  (w/link (example-nodom-do "joan-example-nodom-direct-sent.arc"
					    "You can't access the document variable directly."
					    (get-user req))
			  (pr "Access the document variable directly.")))
	     (br)
	     (tag (li)
		  (w/link (example-nodom-do "joan-example-nodom-srex-get-wtype-sent.arc"
					    "You can't access the document using (srex-get-wtype). For example, with (srex-get-wtype document \"cookie\") to get the cookies."
					    (get-user req))
			  (pr "Access the document using (srex-get-wtype).")))
	     (br)
	     (tag (li)
		  (w/link (example-nodom-do "joan-example-nodom-access-textarealist-sent.arc"
					    (str "You can't access global " site-name* " variables, like the textareaList.")
					    (get-user req))
			  (pr "Access " site-name* " global variables, like the textareaList.")))
	     (br)
	     (tag (li)
		  (w/link (example-nodom-do "joan-example-nodom-access-encverifiedkeyids-sent.arc"
					    (str "You can't access global " site-name* " variables, like the verified key ids.")
					    (get-user req))
			  (pr "Access " site-name* " global variables, like the verified key ids.")))
	     )
	(br2)
	(click-source "joan-example-nodom.arc")
	(br 8)
	(hline)))

(def example-nodom-do (file explanation user)
  (page (backlink "/examples") site-name* nil
	(pr explanation)
	(if (is file "joan-example-nodom-access-encverifiedkeyids-sent.arc")
	    (do (rex (list (list 'may_publish 'ENTER_TEXT)
			   (list 'encrypt
				 (obj pubuserid user
				      formbuttons (list (obj form "ENTER_TEXT"
							     btn 'example-text
							     encpassid "encpass"))
				      enc-itemlist (list (obj id "body")))))
		     (fread file))
	        (sform "ENTER_TEXT"
		       (fn (_)
			   ))
		;; each data item has an encryption password
		(gentag input type "hidden" id "encpass" name "encpass" value "")
		(encverif user)
		(tag (textarea id "body" name "body" rows 4 cols 53 autofocus "")
		     (pr ""))
		(br2)
		(showsign nil t)
		(br 3)
		(tag (a id "example-text")
		     (pr "submit"))
		)
	    (do (rex nil
		     (fread file))
		(encverif user)))
	(br2)
	(pr " Click ")
	(tag (a href file)
	     (pr "here"))
	(pr " to see the code sent from the server.")
	(br 8)
	(hline)))
