(defop example-text req
  (page (backlink "/examples") site-name* nil
	;; define what the browser extension should do
	(rex (list (list 'may_publish 'ENTER_TEXT)
		   (list 'encrypt
			 (obj pubuserid (get-user req)
			      formbuttons (list (obj form "ENTER_TEXT"
						     btn 'example-text
						     encpassid "encpass"))
			      enc-itemlist (list (obj id "body"))))))
	(pr "Enter some text, press submit, and then watch how the text becomes encrypted in the browser (by the browser extension) before it is sent to the server. The server doesn't send any Javascript to the browser.")
	(br2)
	(pr "If you check \"publish\", the text is not encrypted. If a server produces an enabled but hidden \"publish\" field, to trick the user into thinking their text will be encrypted, the \"publish\" field is ignored by the browser extension to protect the user.")
	(br2)
	(pr "The default is to sign before encrypting. A user can deny they are the author of a message by un-checking the \"sign\" flag.")
	(br2)
	(pr "If a message will not be signed, the user sees an alert on the screen. The user also sees an alert when viewing a decrypted message that wasn't signed.")
	(br 3)
	(click-source "joan-example-text.arc")
	(br2)
	(sform "ENTER_TEXT"
	       (fn (_)
		   (withs (p (prof (get-user _))
			   body (arg _ "body")
			   encpass (arg _ "encpass")
			   publish (is (arg _ "publish") "on")
			   dataid nil)
			  (if (no publish)
			      (encpass-read encpass p))
			  (if (is encpass "") (= encpass nil))
			  (= dataid (add-data (get-user _) "blog-entry" encpass body nil nil nil))
			  (example-text-view-encrypted (get-user _) dataid)))
	       ;; each data item has an encryption password
	       (gentag input type "hidden" id "encpass" name "encpass" value "")
	       (encverif (get-user req))
	       (tag (textarea id "body" name "body" rows 12 cols 53 autofocus "")
		    (pr ""))
	       (br2)
	       (checkbox "publish")
	       (pr " publish")
	       (br2)
	       (showsign t t)
	       (br 3)
	       (tag (a id "example-text")
		    (pr "submit")))
	(br 8)
	(hline)
	))
